(function($) {
	
	$.fn.showPane= function(){
		this.siblings().hide();
		this.show();
	}//showPane
	
	$.fn.loadTree = function(tree){
		var right = this;
		$.get(
			"${servletURL}",
			{
				op: "fr_schedule_getFolder",
				type : 'POST'
			},
			function callback(jasonA){
				var treedata = JSON.parse(jasonA);
				var o = {
					onlyfolder: true,
					data: treedata,
					onnodeclick: function(){
						var currentItem = tree.getTCT();
						if (currentItem.id == '0-1') {
							right.filePane.hide();
							right.filePane.siblings().hide();
							return;
						}
						right.loadReport(currentItem);
					}
				};
				tree.treeview(o);
			}//callback
		);
	}//loadTree
	
	
	$.fn.loadReport = function(item){
		var right = this;
		var filePane = right.filePane;
		filePane.showPane();
		filePane.tableBody.empty();
		
		var childNodes = item.ChildNodes;
		if(!childNodes){
			return;
		}
		for (var i=0; i<childNodes.length; i++){
			if (childNodes[i].type != "2"){
				continue;
			}
			var tableTR = $('<tr></tr>').appendTo(filePane.tableBody)
			.mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");});
			
			var reportcheck = $('<input type="checkbox">').attr({id:i})
			.click(function(){
				if(this.checked){
					$(this.parentNode.parentNode).addClass("selected");
				} else {
					$(this.parentNode.parentNode).removeClass("selected");
				}
				childNodes[this.id].checked = this.checked;
			});
			reportcheck.wrap($('<td></td>')).parent().appendTo(tableTR);
			
			var reporttask = $("<input height=25 type='image' src='${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/clock.png'>").attr({id:i, title:"༭"})
			.click(function(){
				right.loadTask(childNodes[this.id]);
			});
			reporttask.wrap($('<td></td>')).parent().appendTo(tableTR);
			
			var url = $().dealplus(FR.cjkEncode(childNodes[i].path)) + ((childNodes[i].isView)? "" : "&op=write");
			var reporturl = "${servletURL}?reportlet=" + url;
			
			
			$("<td onclick=window.open('" + reporturl + "')>" + childNodes[i].text + '</td>').addClass("visitReport").appendTo(tableTR);
//			reporturl.wrap($('<td></td>')).parent().appendTo(tableTR);
			
			
			var isWrite = !childNodes[i].isView ? '' : '';
			
			var reportwrite = $('<td>' + isWrite + '</td>').appendTo(tableTR);
		}//ر
		
		var separator = false;
		for (var i = 0; i < childNodes.length; i++){
			if (childNodes[i].type != "1"){
				continue;
			}
			if (!separator) {
				$('<tr><td class="trseparator"></td><td class="trseparator">ʱļ</td><td class="trseparator">ʱ</td><td class="trseparator">ʹñ</td></tr>').appendTo(filePane.tableBody);
				separator = true;
			}

			var tableTR = $('<tr></tr>').appendTo(filePane.tableBody)
			.mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");});
			
			var reportcheck = $('<input type="checkbox">').attr({id:i})
			.click(function(){
				if(this.checked){
					$(this.parentNode.parentNode).addClass("selected");
				}else{
					$(this.parentNode.parentNode).removeClass("selected");
				}
				childNodes[this.id].checked = this.checked;
			});
			reportcheck.wrap($('<td></td>')).parent().appendTo(tableTR);
			var paths = childNodes[i].path.split("\\");
			var task = paths[paths.length - 4];
			var triggerTime = paths[paths.length - 3] + '+' + paths[paths.length - 2];
			var files = paths[paths.length - 1].split(".");
			var file = files[files.length - 1];
			var para = /_\[.+\]_/.exec(files[0]);
			var filename = "&fileName=" + paths[paths.length - 1];
			
			if (file == "cpt") {
				file = "reportlet=schedulereport";
			} else if (file == "xls") {
				file = "op=fr_schedule_file&format=excel";
			} else if (file == "doc") {
				file = "op=fr_schedule_file&format=word"
			} else if (file == "pdf") {
				file = "op=fr_schedule_file&format=pdf";
			}
			var realurl = '${servletURL}?'+ file + '&task=' + $().dealplus(FR.cjkEncode(task)) + '&triggerTime=' + triggerTime +  $().dealplus(FR.cjkEncode(filename));
			var open = "open";
//			if (newWindow) {
//				open = "showModalDialog";
//			}

			var visitFile = $("<td onclick=window." + open + "('" + realurl + "')>" + childNodes[i].text + '</td>').addClass('visitReport').appendTo(tableTR);

//			reporturl.wrap($('<td></td>')).parent().appendTo(tableTR);
			
			var time = ' ' + paths[paths.length - 2].substring(0, 2) + ':' + paths[paths.length - 2].substring(2, 4);
			
			var createtime = $('<td>' + paths[paths.length - 3] + time + '</td>').appendTo(tableTR);
			
			var identify = "_";
			if (para != null) {
				identify = para[0];
			}
			var dates = paths[paths.length - 3].split("-");
			$.each(dates, function(i) {
				identify += dates[i];
			});
			var reportName = paths[paths.length - 1].split(identify)[0] + ".cpt";
			var reportwrite = $('<td>' + reportName + '</td>').appendTo(tableTR);
		}//طǱļ
	}//loadReport
	
	$.fn.loadTask = function(item){
		var right = this;
		var taskPane = right.taskPane;
		taskPane.showPane();
		taskPane.tableBody.empty();
		taskPane.populate(item);
		$.ajax({
				type : 'POST',
				url : '${servletURL}',
				data : {
					op : 'fr_schedule_getTask',
					reportId: item.id.substr(1)
					},
				async : false,
				complete : function(res, status) {
					var tasks = JSON.parse(res.responseText);		
					item.tasks = tasks;				
					for (var i=0; i<tasks.length; i++){					
						var tableTR = $('<tr></tr>').appendTo(taskPane.tableBody)
						.mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");});
					
						var taskcheck = $('<input type="checkbox">').attr({id:i})
						.click(function(){
							if(this.checked){
								$(this.parentNode.parentNode).addClass("selected");
							}else{
								$(this.parentNode.parentNode).removeClass("selected");
							}
							tasks[this.id].checked = this.checked;
						});
						taskcheck.wrap($('<td></td>')).parent().appendTo(tableTR);
						
						var taskname = $('<td>'+ tasks[i].name +'</td>').appendTo(tableTR);
						
						var taskedit = $("<input height=25 type='image' src='${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/edit.png'>").attr({id:i, title:"༭"})
						.click(function(){
							right.processPane.populate(taskPane.report, tasks[this.id], item.isView);
							right.processPane.showPane();
						});
						taskedit.wrap($('<td></td>')).parent().appendTo(tableTR);
						
						var taskstate = $("<input height=25 type='image'>").attr({id:i})
						.click(function(){
							var task = this;
							$.get(
								"${servletURL}",
								{
								op: "fr_schedule_stateJob",
								taskId: tasks[task.id].id
								},
								function callback(state){
									tasks[task.id].state = state;
									if (state == -2) {
										state.title = "ȴ";
										state.src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/wait.png';					
									} else if(state == 0){
										task.title = "";
										task.src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/start.png';
									} else if(state == 1){
										task.title = "ͣ";
										task.src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/pause.png';
									} else {
										task.title = "";
										task.src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/stop.png';
									}
								}//callback
							);
						});
						if (tasks[i].state == -2) {
							taskstate[0].title = "ȴ";
							taskstate[0].src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/wait.png';					
						} else if(tasks[i].state == 0){
							taskstate[0].title = "";
							taskstate[0].src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/start.png';
						} else if(tasks[i].state == 1){
							taskstate[0].title = "ͣ";
							taskstate[0].src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/pause.png';
						} else {
							taskstate[0].title = "";
							taskstate[0].src = '${servletURL}?op=resource&resource=/com/fr/schedule/web/css/images/stop.png';
						}
						taskstate.wrap($('<td></td>')).parent().appendTo(tableTR);
						if (item.isView) {
							var reporturl = tasks[i].name;
							$("<td title='鿴ɵı' onclick=window.open('${servletURL}?reportlet=schedulereport&task=" + $().dealplus(FR.cjkEncode(reporturl)) + "')>ʷ¼ѯ</td>").addClass("visitReport").appendTo(tableTR);								
						} else {
							$('<td>޼¼</td>').appendTo(tableTR);
						}
					}
				}
		});
	}//loadTask

	$.fn.loadParameter = function(parameters){
		var parameterPane = this;
		parameterPane.tableBody.empty();
		for (var i=0; i<parameters.length; i++){
			parameters[i].checked = false;
			var tableTR = $('<tr></tr>').appendTo(parameterPane.tableBody).attr({id:i})
			.mouseover(function() {$(this).addClass("over");}).mouseout(function() {$(this).removeClass("over");})
			.dblclick(function(){
				FR.showDialog("༭",500,-1,SC.editParameterDialog(parameterPane,parameters[this.id],parameters),false);
			});
			
			var parametercheck = $('<input type="checkbox">').attr({id:i})
			.click(function(){
				if(this.checked){
					$(this.parentNode.parentNode).addClass("selected");
				}else{
					$(this.parentNode.parentNode).removeClass("selected");
				}
				parameters[this.id].checked = this.checked;
			});
			parametercheck.wrap($('<td></td>')).parent().appendTo(tableTR);
			
			var parametername = $('<td>'+ parameters[i].name +'</td>').appendTo(tableTR);
			
			var type = eval("FR.i18n.Parameter_" +  parameters[i].type);
			var parametertype = $('<td>'+ type +'</td>').appendTo(tableTR);
			
			var parametervalue = $('<td>'+ parameters[i].value +'</td>').appendTo(tableTR);
		}//for
	}//loadParameter
	
	$.fn.dealplus = function(text) {
	    if (typeof text !== 'string') {
    		return text;
    	}
    	var newText = "";
        for (var i = 0; i < text.length; i++) {
            var code = text.charCodeAt(i);
            if (code == 43) {
                newText += "[" + code.toString(16) + "]";
            } else {
                newText += text.charAt(i);
            }
        }

        return newText
	}
	
})(jQuery);


