	
	function Point2D(x, y) {
		this.x = x;
		this.y = y;
	}
	
	Point2D.prototype = {
		x 		:	0,
		y		:	0,
		
		getX	:		function() {
			return this.x;
		},
		
		getY	:		function() {
			return this.y;
		},
		
		setX	:		function(x) {
			this.x = x;
		},
		
		setY	:		function(y) {
			this.y = y;
		},
		
		equals	:		function(point) {
			if(point instanceof Point2D) {
				return (this.getX() == point.getX()) && (this.getY() == point.getY());
			}
			return false;
		}
	}
	
	function Dimension2D(width, height) {
		this.initConstants(width, height);
	}
	
	Dimension2D.prototype = {
		initConstants	:	function(width, height) {
			this.width = width == undefined ? 0 : width;
			this.height = height == undefined ? 0 : height;
		},
		
		getWidth	:	function() {
			return this.width;
		},
		
		getHeight	:	function() {
			return this.height;
		},
		
		setWidth	:	function(width) {
			this.width = width;
		},
		
		setHeight	:	function(height) {
			this.height = height;
		}
	}
	
	function Line2D(startPoint, endPoint) {
		this.startPoint = startPoint;
		this.endPoint = endPoint;
	
	}
	
	Line2D.prototype = {
		startPoint		:	new Point2D(),
		endPoint 		:	new Point2D(),
		
		getStartPoint	:	function() {
			return this.startPoint;
		},
		
		setStartPoint	:	function(point) {
			this.startPoint = point;
		},
		
		getEndPoint		:	function() {
			return this.endPoint;
		},
		
		setEndPoint		:	function(point) {
			this.endPoint= point;
		},
		
		drawStroke		:	function(ctx, lineStyle) {
			if(lineStyle) {
				// kunsnat: TODO ֵ߲Ĵ, и͵ʽ. 
				if(lineStyle == Constants.prototype.LINE_THIN) {
					ctx.lineWidth = 1;
					this.drawStroke(ctx);
					return ;
				} else if(lineStyle == Constants.prototype.LINE_MEDIUM) {
					ctx.lineWidth = 2;
					this.drawStroke(ctx);
					return ;
				} else if(lineStyle == Constants.prototype.LINE_DASH || lineStyle == Constants.prototype.LINE_HAIR 
							|| lineStyle == Constants.prototype.LINE_HAIR2) {
					ctx.lineWidth = 1;
				} else if(lineStyle == Constants.prototype.LINE_THICK) {
					ctx.lineWidth = 3;
					this.drawStroke(ctx);
					return ;
				} else if(lineStyle == Constants.prototype.LINE_DOT) {
					ctx.lineWidth = 1;
				} else if(lineStyle == Constants.prototype.LINE_MEDIUM_DASH) {
					ctx.lineWidth = 2;
				} else if(lineStyle == Constants.prototype.LINE_DASH_DOT) {
					ctx.lineWidth = 1;
				} else if(lineStyle == Constants.prototype.LINE_MEDIUM_DASH_DOT) {
					ctx.lineWidth = 2;
				} else if(lineStyle == Constants.prototype.LINE_DASH_DOT_DOT) {
					ctx.lineWidth = 1;
				} else if(lineStyle == Constants.prototype.LINE_MEDIUM_DASH_DOT_DOT) {
					ctx.lineWidth = 2;
				} else if(lineStyle == Constants.prototype.LINE_SLANTED_DASH_DOT) {
					ctx.lineWidth = 2;
				}
				this.drawDotLine(ctx);
			} else {
				ctx.beginPath();
				ctx.moveTo(this.startPoint.getX(),this.startPoint.getY());
				ctx.lineTo(this.endPoint.getX(),this.endPoint.getY());
				ctx.stroke();
			}
		},
		
		// kunsnat: ---  lineStyle  . ȼ򵥴, ֻṩһ..
		drawDotLine	:	function(ctx) {
			/**
			 * ע6Ϊߵܳ, мĿಿ, һΪߵĳ
			 */ 
			var dotLength = 6;
			
			var x = this.startPoint.getX();
			var y = this.startPoint.getY();
			var ex = this.endPoint.getX();
			var ey = this.endPoint.getY();
			
			// kunsnat: ȹ̶4, 2  ܳ, ָ, Ȼб
			var width = x - ex; var height = y - ey;
			// ߵĿ
			var dotNumber = 0;
			var xIncrement = 0;
			var yIncrement = 0;
			// ֱ. б
			if(width == 0) {
				dotNumber = height / dotLength;
				xIncrement = 0;
				yIncrement = (y - ey)  > 0 ? -dotLength : dotLength;
			} else {
				var alpha = Math.atan(height/width);
				
				xIncrement = dotLength * Math.cos(alpha);
				yIncrement = dotLength * Math.sin(alpha);
				
				// dotNumber Ҫٸ.
				dotNumber = Math.sqrt(width * width + height * height) / dotLength; 
			}
			ctx.beginPath();
			for(var i = 0; i < dotNumber - 0.5; i++) {
				ctx.moveTo(x + xIncrement * i, y + yIncrement * i);
				ctx.lineTo(x + xIncrement * (i + 0.5), y + yIncrement * (i + 0.5));
			}
			ctx.stroke();
		}
	}
	
	function Bounds(x, y, width, height) {
	  	this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	Bounds.prototype = {
		x		:	0,
		y		:	0,
		width	:	0,
		height	:	0,
		
		getBounds2D	:	function() {
			return this;
		},
		
		getLineGradient	:	function(ctx, isHorizontal) {
			if(this.lineGradient != null) {
				return this.lineGradient;
			}
			
			if(isHorizontal) {
				// xy IEǱ ֻҪʾͿ, FF..
				this.lineGradient = ctx.createLinearGradient(this.x, this.y, this.x, this.y + this.height);
			} else {
				this.lineGradient = ctx.createLinearGradient(this.x, this.y, this.x + this.width, this.y);
			}
			
			return this.lineGradient;
		},
		
		getX	:		function() {
			return this.x;
		},
		
		setX	:		function(x) {
			this.x = x;
		},
		
		getY	:		function() {
			return this.y;
		},
		
		setY		:		function(y) {
			this.y = y;
		},
		
		getWidth	:		function() {
			return this.width;
		},
		
		setWidth	:		function(width) {
			this.width = width;
		},
		
		getHeight	:		function() {
			return this.height;
		},
		
		setHeight	:		function(height) {
			this.height = height;
		},
		
		paint		:		function(ctx) {
			ctx.fillRect(this.x, this.y, this.width, this.height);
		},
		
		getAnimateShape	:	function(step) {
			var shape = [];
			
			for(var i = 0; i < step; i++) {
				// kunsnat: ھķʽ. 
				if(this.isHorizontal4Bounds) {
					shape[i] = new Bounds(this.x, this.y, this.width/step * (i + 1), this.height);
				} else {
					var actionHeight = this.height/step * (i + 1);
					shape[i] = new Bounds(this.x, this.y + this.height - actionHeight, this.width, actionHeight);
				}
			}
			
			return shape;
		}
	}

	function	ChartUtils() {
		
	}
	
	ChartUtils.intersectsPoint = function(p1, p2, p1_, p2_) {
		var alpha = (p2_.getY() - p1_.getY()) * (p2.getX() - p1.getX()) - (p2.getY() - p1.getY()) * (p2_.getX() - p1_.getX());
    	
    	if (Math.abs(alpha) < 0.01) {
    		return null;
    	}
    	
    	var a_ = (p2_.getY() - p1_.getY()) * p1_.getX() - (p2_.getX() - p1_.getX()) * p1_.getY();
    	var b = (p2.getY() -p1.getY()) * p1.getX() - (p2.getX() - p1.getX()) * p1.getY();
    	
    	var x = ((p2.getX() - p1.getX()) * a_ - (p2_.getX() - p1_.getX()) * b) / alpha;
    	var y = ((p2.getY() - p1.getY()) * a_ - (p2_.getY() - p1_.getY()) * b) / alpha;
    	
    	return new Point2D(x, y);
	}
	
	
	function	Color() {
		
	}
	
	Color.FACTOR = 0.7;
	
	/**
	 * ʽɫ, 'red' 'rgb(255,0,0)' ..
	 * תΪ[255,0,0]
	 */
	Color.getColorArray = function(color) {   
	    if(/^#[0-9a-f]{6}$/i.test(color))   
	    {//#rrggbb   
	        return Color.Map([color.substr(1, 2), color.substr(3, 2), color.substr(5, 2)],   
	            function(x){ return parseInt(x, 16); }   
	        )   
	    }   
	    else if(/^#[0-9a-f]{3}$/i.test(color))   
	    {//#rgb   
	        return Color.Map([color.substr(1, 1), color.substr(2, 1), color.substr(3, 1)],   
	            function(x){ return parseInt(x + x, 16); }   
	        )   
	    }   
	    else if(/^rgb(.*)$/i.test(color))   
	    {//rgb(n,n,n) or rgb(n%,n%,n%)   
	        return Color.Map(color.match(/\d+(\.\d+)?\%?/g),   
	            function(x){ return parseInt(x.indexOf("%") > 0 ? parseFloat(x, 10) * 2.55 : x, 10); }   
	        )   
	    }   
	    else  
	    {//color   
	    // TODO Զб.
	        var mapping = {	"red":"#FF0000", "white":"#FFFFFF","black":"#000000",
	        				"gray":"#D0D0D0","green":"#00EC00", "blue":"#0000C6"
	        			  };//   
	        color = mapping[color.toLowerCase()];   
	        if(color){   
	            return Color.Map([color.substr(1, 2), color.substr(3, 2), color.substr(5, 2)],   
	                function(x){ return parseInt(x, 16); }   
	            )   
	        }   
	    }   
	}
		
	Color.Map = function(array, callback, thisObject){   
	    if(array.map){   
	        return array.map(callback, thisObject);   
	    }else{   
	        var res = [];   
	        for (var i = 0, len = array.length; i < len; i++) { 
	        	res.push(callback.call(thisObject, array[i], i, array)); 
	        }   
	        return res;   
	    }   
	}  
	
	/**
	 * տcanvasɫ
	 */
	Color.getColor	= function(colorArray) {
		return 'rgb(' + colorArray + ')';
	}
	
	// ɫ
	Color.darker	= function(color) {
		var colorArray = Color.getColorArray(color);
			colorArray[0] =	Math.max(Math.round(colorArray[0]  * Color.FACTOR), 0);
			colorArray[1] =	Math.max(Math.round(colorArray[1]  * Color.FACTOR), 0);
			colorArray[2] =	Math.max(Math.round(colorArray[2]  * Color.FACTOR), 0);
			return Color.getColor(colorArray);
	}
	
	Color.brighter	= function(color) {
		var colorArray = Color.getColorArray(color);
		
		var r = colorArray[0];
        var g = colorArray[1];
        var b = colorArray[2];

        var i = 1.0/(1.0-Color.FACTOR);
        if (r == 0 && g == 0 && b == 0) {
        	i = Math.round(i);
        	colorArray[0] = i;
        	colorArray[1] = i;
        	colorArray[2] = i;
			return colorArray;
        }
        
        if ( r > 0 && r < i ) r = i;
        if ( g > 0 && g < i ) g = i;
        if ( b > 0 && b < i ) b = i;

		colorArray[0] = Math.min(Math.round(r/Color.FACTOR), 255);
		colorArray[1] = Math.min(Math.round(g/Color.FACTOR), 255);
		colorArray[2] = Math.min(Math.round(b/Color.FACTOR), 255);
		
		return Color.getColor(colorArray);
	}
	
	function	ChartData() {
		
	}	 
	
	ChartData.getMax = function(chartData) {
		var maxValue = 0.0;
    	for (var i = 0; i < chartData.getCategoryLabelCount(); i ++) {
    		for (var j = 0; j < chartData.getSeriesCount(); j ++) {
    			maxValue = (chartData.getValueAt(j, i) > maxValue) ? chartData.getValueAt(j, i) : maxValue;//getsValue
    		}
    	}
    	if(maxValue < 0)return maxValue * 0.9;
    	return maxValue * 1.1;
	}
	
	ChartData.getMin = function(chartData) {
		var minValue = 0.0;
    	for (var i = 0; i < chartData.getCategoryLabelCount(); i ++) {
    		for (var j = 0; j < chartData.getSeriesCount(); j ++) {
    			minValue = (chartData.getValueAt(j, i) < minValue) ? chartData.getValueAt(j, i) : minValue;
    		}
    	}
    	if(minValue < 0)return minValue * 1.1;
    	return minValue * 0.9;
	}
	
function Constants() {

}

Constants.prototype = {
	CENTER	:	0,		
	TOP	: 	1,
	LEFT	:	2,
	BOTTOM	:	3,
	RIGHT	:	4,

	TICK_MARK_NONE		:	0,
	TICK_MARK_INSIDE	:	1,
	TICK_MARK_OUTSIDE	:	2,
	TICK_MARK_CROSS		:	3,
	
	// kunsnat: BaseCoreConstantsе˳Ӧֵ
    LINE_NONE	:	0, 
    LINE_THIN	: 	1,  
    LINE_MEDIUM	: 	2,  
    LINE_DASH	: 	3,  
    LINE_HAIR	:	4, 
    LINE_HAIR2	: 	14,  
    LINE_THICK	:	5,  
    LINE_DOT	:	7, 
   	LINE_MEDIUM_DASH	: 	8,  
    LINE_DASH_DOT	:	9,  
    LINE_MEDIUM_DASH_DOT	: 	10,  
    LINE_DASH_DOT_DOT	:	11,  
    LINE_MEDIUM_DASH_DOT_DOT	: 	12, 
    LINE_SLANTED_DASH_DOT	:	13,
    
	LABEL_AROUND	:	3,
	LABEL_TOP	:	2,
	LABEL_BOTTOM	:	1,
	LABEL_NONE	:	0,

	IMAGE_DEFAULT	:	3,
	IMAGE_TILED	:	0,
	IMAGE_CENTER	:	1,
	IMAGE_EXTEND	:	2,
	
	INSIDE		:		5,
	OUTSIDE		:		6,
	AXISINSIDE	:		7
}

function 	ChartCoreConstants() {
	
}

ChartCoreConstants.prototype = {
	CHART_COLOR_ARRAY	:	[
		"rgb(225, 88, 42)",
    	"rgb(250, 188, 91)",
    	"rgb(90, 154, 242)",
    	"rgb(191, 191, 191)",
    	"rgb(20, 114, 157)",

       	"rgb(192,116,26)",
        "rgb(33,191,111)",
        "rgb(28,163,191)",
      	"rgb(119,186,13)",
        
      	"rgb(182,203,4)",
       	"rgb(150,80,80)",
        "rgb(156,156,219)",
        "rgb(77,85,133)",
        "rgb(203,219,156)",
        
        "rgb(100,120,58)",
        "rgb(227,203,148)",
        "rgb(227,186,84)",
        "rgb(140,109,52)",
        "rgb(227,148,155)",
        
        "rgb(212,99,107)",
        "rgb(171,75,75)",
        "rgb(133,60,60)",
        "rgb(219,156,212)",
        "rgb(204,108,108)",
        
        "rgb(125,67,116)",
        "rgb(80,77,133)",
        "rgb(191,219,156)",
        "rgb(123,163,83)",
        "rgb(163,83,131)",
        
        "rgb(153,0,137)",
        "rgb(58,153,34)",
        "rgb(158,53,53)",
        "rgb(180,204,106)",
        "rgb(139,163,83)",
        
        "rgb(100,120,58)",
        "rgb(227,203,148)",
        "rgb(156,156,219)",
        "rgb(116,116,181)",
        "rgb(77,85,133)"
      ]
}

function	FRFont(js) {
	this.initConstants(js);
}

FRFont.prototype =  {
	initConstants	:	function(js) {
		js = js || {};
		
		this.size = js.size == undefined ?  12 : js.size;
		this.color = js.color == undefined ? 'black' : js.color;
		this.fontName = js.fontName == undefined ? "SimSun" : js.fontName;
		// kunsnat: style --> , Ӵ, б, Ӵб
		this.style = js.style == undefined ? "" : js.style;
	}
}

function PaintUtils() {

}

PaintUtils.paintContent = function(context,text,textAttr,width, height) {
	context.save();
	
	var toAngle = Math.PI / 180;

     // ɫ. TODO » Ч
	if(textAttr.frFont == null) {
	    context.font = "12px SimSun"; 
	    context.fillStyle = 'black'; 
	} else {
		var font = textAttr.frFont;
		context.font = font.style + " " + font.size + "px " + font.fontName;
		context.fillStyle = font.color;
	}

    // The alignment is recorded here for purposes of Opera compatibility
    if (navigator.userAgent.indexOf('Opera') != -1) {
        context.canvas.__rgraph_valign__ = textAttr.getVerticalAlignment();
        context.canvas.__rgraph_halign__ = textAttr.getHorizontalAlignment();
    }

    // Rotate the canvas if need be
    var rotaAngle = textAttr.rotation;
    if (textAttr.rotation != 0) {
        context.rotate(-rotaAngle * toAngle);
    }

    // Vertical alignment - defaults to bottom
    var vAlign = textAttr.verticalAlignment;
    if (vAlign == Constants.prototype.BOTTOM) {
        context.textBaseline = 'bottom';
    } else if (vAlign == Constants.prototype.CENTER) {
        context.textBaseline = 'middle';
    } else if (vAlign == Constants.prototype.TOP) {
    }
    // 
    context.textBaseline = "top";

    // Hoeizontal alignment - defaults to left  TODO canvasлstartend
    var hAlign = textAttr.horizontalAlignment;
    if (hAlign == Constants.prototype.LEFT) {
        context.textAlign = 'left';
    } else if (hAlign == Constants.prototype.CENTER) {
        context.textAlign = 'center';
   	} else if (hAlign == Constants.prototype.RIGHT) {
        context.textAlign ='right';
    }
    
     // kunsnat: ı, ֱӷ, תĻǲͬ.
    if(textAttr.alignText == Style.prototype.VERTICALTEXT) {
    	for(var i = 0; i < text.length; i++) {
			context.fillText(text.charAt(i), 0, i * textAttr.frFont.size);
		}
    } else {
	    if(rotaAngle > 0) {
	    	ctx.fillText(text, -Math.sin(rotaAngle * toAngle) * Math.sin(rotaAngle*toAngle) * width, 
	    						Math.sin(rotaAngle *toAngle) * width * Math.cos(rotaAngle*toAngle));
	    } else {
		    context.fillText(text,0,0);
	    }
    }
    
	context.restore();
}

	function Formula() {

	}

	Formula.prototype = {
		content		:	'',
		EXPAND_BASE_ON_EACH	:	0,
		EXPAND_BASE_ON_MAX	:	1,
		EXPAND_BASE_ON_MIN	:	2,
		expandBase		:	this.EXPAND_BASE_ON_MAX,
		result			: 	null,
		reserveExecute		:	false,
		reserveInWeb		:	true,
		needReExecute		:	false	
	}

	Formula.getExpandBase = function() {
		return this.expandBase;
	}

	Formula.setExpandBase = function(expandBase) {
		this.expandBase = expandBase;
	}

	Formula.isNeedReExeecute = function() {
		return this.needReExecute;
	}

	Formula.setNeedReExecute = function(needReExecute) {
		this.needReExcute = needReExcute;
	}

	Formula.getContent = function() {
		if(this.content.startsWidth("=")) {
			return this.content;
		} else {
			return "=" + this.content;
		}
	}

	Formula.setContent = function(content) {
		this.content = content;
		
		if(this.content.startwWidth("=")) {
			this.content = this.content.substring(1);
		}
	}

	Formula.getResult = function() {
		return this.result;
	}

	Formula.setResult = function(result) {
		this.result = result;
	}

	Formula.isReserveExecute = function() {
		return this.reserveExecute;
	}

	Formula.setReserveExecute = function(reserveExecute) {
		this.reserveExecute = reserveExecute;	
	}

	Formula.isReserveInWeb = function() {
		return this.reserveInWeb;
	}

	Formula.setReserveInWeb = function(reserveInWeb) {
		this.reserveInWeb = reserveInWeb;
	}

	Formula.isEmpty = function() {
		return "=".equals(this.getContent());
	}


	function GraphHelper() {
	
	}
	
	// kunsnat: lineStyle ҪжǷ. GeneralPathdrawStroke
	GraphHelper.drawLine = function(ctx, line2D, lineStyle) {
			line2D.drawStroke(ctx, lineStyle);
	}
	
	GraphHelper.ctx = null;
	
	GraphHelper.stringDimension = function(string, font, rotation) {
		if(string == null) {
			return new Dimension2D();
		}
		
		var norWidth = string.length * font.size;
		if(GraphHelper.ctx) {
			norWidth = GraphHelper.ctx.measureText(string).width;
		}

		var nRotation = rotation * Math.PI / 180;

		var dimension = new Dimension2D();
		//kunsnat: ʱfont.size , ܻе.  Ĭϵ5
		dimension.setWidth(norWidth * Math.abs(Math.cos(nRotation)) + 5 * Math.abs(Math.sin(nRotation)));
		dimension.setHeight(norWidth * Math.abs(Math.sin(nRotation)) + font.size * Math.abs(Math.cos(nRotation)));

		return dimension;
	}
	
	GraphHelper.getLineStyleSize = function(lineStyle) {
		if (lineStyle == Constants.prototype.LINE_NONE) {
            return 0;
        } else if (lineStyle == Constants.prototype.LINE_MEDIUM ||
                lineStyle == Constants.prototype.LINE_DOUBLE ||
                lineStyle == Constants.prototype.LINE_MEDIUM_DASH ||
                lineStyle == Constants.prototype.LINE_MEDIUM_DASH_DOT ||
                lineStyle == Constants.prototype.LINE_MEDIUM_DASH_DOT_DOT ||
                lineStyle == Constants.prototype.LINE_SLANTED_DASH_DOT) {
            return 2;
        } else if (lineStyle == Constants.prototype.LINE_THICK) {
            return 3;
        }

        return 1;
	}
	
	function Style() {

	}

	Style.prototype ={
		HORIZONTALTEXT	:	0,
		VERTICALTEXT	:	1,

		RIGHT_TO_LEFT	:	0,
		LEFT_TO_RIGHT	:	1,

		TextStyle_WrapText	:	0,
		TextStyle_SingleLine	:	1,
		TextStyle_SingleLineAdjustFont	:	2,
		TextStyle_MultiLineAdjustFont	:	3,

		format		:	null,
		frFont 		:	null,

		background	:	null,
		
		border_top 	:	Constants.prototype.LINE_NONE,
		border_left	:	Constants.prototype.LINE_NONE,
		border_bottom	:	Constants.prototype.LINE_NONE,
		border_right 	:	Constants.prototype.LINE_NONE,
		border_top_color	:	"black",
		border_left_color	:	"black",
		border_bottom_color	:	"black",
		border_right_color	:	"black",

		horizontal_alignment	:	Constants.prototype.LEFT,
		vertical_alignment	:	Constants.prototype.CENTER,

		textStyle 		:	Style.prototype.TextStyle_WrapText,
		verticalText		:	Style.prototype.HORIZONTALTEXT,
		textDirection		:	Style.prototype.RIGHT_TO_LEFT,
		rotation		:	0,

		imageLayout		:	Constants.prototype.IMAGE_DEFAULT,

		paddingLeft		:	2,
		paddingRight		:	2,

		spacingBefore		:	0,
		spacingAfter		:	0,
		lineSpacing		:	0
	}

	function TextAttr(js) {
		this.initConstants(js);
	}

	TextAttr.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			this.frFont = js.frFont == undefined ? null : new FRFont(js.frFont);
			
			this.direction = js.direction == undefined ? Style.prototype.LEFT_TO_RIGHT : js.direction;
			this.rotation = js.rotation == undefined ? 0 : js.rotation;
			this.horizontalAlignment = js.horizontalAlignment == undefined ? Constants.prototype.LEFT : js.horizontalAlignment;
			this.verticalAlignment = js.verticalAlignment == undefined ? Constants.prototype.CENTEWR : js.verticalAlignment;
			this.alignText = js.alignText == undefined ? Style.prototype.HORIZONTALTEXT : js.alignText;
		},
		
		getFrFont		:		function() {
			return this.frFont;
		},
	
		setFrFont		:		function(frFont) {
			this.frFont = frFont;
		},
	
		setDirection	:		function(direction) {
			this.direction = direction;
		},
	
		getDirection	:		function() {
			return this.direction;
		},
	
		getRotation		:		function() {
			return this.rotation;
		},
	
		setRotation		:		function(rotation) {
			this.rotation = rotation;
		},
	
		setHorizontalAlignment	:		function(alignment) {
			this.horizontalAlignment = alignment;
		},
	
		getHorizontalAlignment	:		function() {
			return this.horizontalAlignment;
		},
	
		setVerticalAlignment	:		function(alignment) {
			this.verticalAlignment = alignment;
		},
	
		getVerticalAlignment	:		function() {
			return this.verticalAlignment;
		},
	
		setAlignText		:		function(alignText) {
			this.alignText = alignText;
		},
	
		getAlignText		:		function() 	{
			return this.alignText;
		}
	}

	
		function	ReportChartData(category, series, value) {
		this.initConstants();
		
		this.setCategoryArray(category);
		this.setSeriesArray(series);
		this.setValue(value);
	}
	
	ReportChartData.prototype = {
		initConstants 	:	function() {
			categoryArray = [];
			seriesArray = [];
			value = [];
		},
		
		getCategoryLabelCount	:	function() {
			return this.getCategoryArray() == null ? 0 : this.getCategoryArray().length;
		},
		
		getCategoryLabel	:	function(labelIndex) {
			if(this.getCategoryArray() != null && this.getCategoryArray().length > labelIndex) {
				return this.getCategoryArray()[labelIndex];
			}
			return "";
		},
		
		setCategoryArray	:	function(categoryArray) {
			this.categoryArray = categoryArray;
		},
		
		getCategoryArray	:	function() {
			return this.categoryArray;
		},
		
		setSeriesArray	:	function(seriesArray) {
			this.seriesArray = seriesArray;
		},
		
		getSeriesArray 	:	function(seriesArray) {
			return this.seriesArray;
		},
		
		setValue	:	function(value) {
			this.value = value;
		},
		
		getValue	:	function() {
			return this.value;
		},
		
		getSeriesCount	:	function() {
			return this.getSeriesArray() == null ? 0 : this.getSeriesArray().length;
		},
		
		getSeriesLabel	:	function(index) {
			if(this.getSeriesArray() != null && this.getSeriesArray().length > index) {
				return this.getSeriesArray()[index];
			}
			return "";
		},
		
		getValueAt	:	function(seriesIndex, labelIndex) {
			var result = null;
			// ޸~  ľѾûл kt
			// ܵԽ. ʱû뵽õĽ null.
			// ӦÿԱ֤ȡݶ~
			if(this.getValue() == null 
				|| this.getValue().length <= seriesIndex || seriesIndex < 0) {
				return 0;
			}
			// ֱӿɵõӦе..
			var value_1D = this.getValue()[seriesIndex];
			// ֤߱ȡݶ~
			if (value_1D.length <= labelIndex) {
				return 0;
			}
			result = value_1D[labelIndex];
			
			return result;
		}
	}
	
	function	ChartDataModel() {
		this.initConstants();
	}
	
	ChartDataModel.prototype = {
		initConstants	:	function() {
			category = ["1", "2", "3"];
			seriesName = ["BC", "CA", "NY", "WA"],
			values = [[10, 20, 30], [20, 30,40],[30,40,50], [40,50,60]],
			
			this.defaultChartData = new ReportChartData(category, seriesName, values);
			
			pieSeries = ["ϵ"];
			pieValue = [[10,20,30]];
			this.pieData = new ReportChartData(category, pieSeries, pieValue);
			
			radarCate = [1,2,3,4,5];
			radarValue = [[10,10,10,10,10],[20,20,20,20,20],[30,30,30,30,30],[40,40,40,40,40],[50,50,50,50,50]];
			this.radarData = new ReportChartData(radarCate, seriesName, radarValue);
			
			highLowSeries = ["", "", "ر"];
			highLowValue	= [[30,20,20], [10,6,10],[15,10,12]];
			this.highLowChartData = new ReportChartData(category, highLowSeries, highLowValue);
			
			openHighLowSeries = ["", "", "", ""];
			openHighLowValue	= [[20,18,30],[30,40,40],[10,5,20],[15,24,24]];
			this.openHighLowChartData = new ReportChartData(category,openHighLowSeries,openHighLowValue);
			
			volumeHighLowSeries = ["ɽ", "", "", ""];
			volumeHighLowValue = [[4,5,6],[30,20,33],[10,5,20],[15,10,23]];
			this.volumeHighLowChartData = new ReportChartData(category, volumeHighLowSeries, volumeHighLowValue);
			
			volumeOpenSeries = ["ɽ","", "̸", "̵",""];
			volumeOpenValue = [[4,5,6],[20,18,30],[30,32,33],[10,6,20],[15,23,24]];
			this.volumeOpenChartData = new ReportChartData(category, volumeOpenSeries,volumeOpenValue);
			
			xyCategoryName = [10,20,30];
			this.xyPlotChartData = new ReportChartData(xyCategoryName, seriesName, values);
			
			rangeCate = ["1"];
			rangeSeries = ["Сֵ", "ֵ", "ƽֵ", "ǰֵ"];
			rangeValue = [[6],[30],[18],[24]];
			this.rangeChartData = new ReportChartData(rangeCate, rangeSeries,rangeValue);
			
			meterCate = ["1"];
			meterSeries = ["Ǳ"];
			meterValue = [[70]];
			this.meterChartData = new ReportChartData(meterCate, meterSeries, meterValue);
			
		},
		
		getChartData :	function(plotGlyph) {
			var chartData = null;
			if(plotGlyph instanceof PiePlotGlyph) {
				chartData = this.pieData;
			} else if(plotGlyph instanceof RadarPlotGlyph) {
			   	chartData = this.radarData;
			} else if(plotGlyph instanceof StockPlotGlyph) {
				var type = plotGlyph.getSubType();
				if(type == StockPlotGlyph.prototype.HIGH_LOW_CLOSE) {
					chartData = this.highLowChartData;
				} else if(type == StockPlotGlyph.prototype.OPEN_HIGH_LOW_CLOSE) {
					chartData = this.openHighLowChartData;
				} else if(type == StockPlotGlyph.prototype.VOLUME_HIGH_LOW_CLOSE) {
					chartData = this.volumeHighLowChartData;
				} else if(type == StockPlotGlyph.prototype.VOLUME_OPEN_HIGH_LOW_CLOSE) {
					chartData = this.volumeOpenChartData;
				}
			} else if(plotGlyph instanceof XYScatterPlotGlyph) {
				chartData = this.xyPlotChartData;
			} else if(plotGlyph instanceof RangePlotGlyph) {
				chartData = this.rangeChartData;
			} else if(plotGlyph instanceof MeterPlotGlyph) {
				chartData = this.meterChartData;
			}
			else {
			    chartData  = this.defaultChartData;
			}
			
			return chartData;
		}
	}
	


function SeriesAttrMarkerType(js) {
	this.initConstants(js);
}

SeriesAttrMarkerType.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.markerTypeIndex = js.markerTypeIndex == undefined ? 0 : js.markerTypeIndex;
	},
	
	equals	:	function(condition) {
		condition = condition || {};
		if(condition instanceof SeriesAttrMarkerType) {
			return true;
		}
		return false;
	}
}
		
function SeriesAttrAlpha(js) {
	this.initConstants(js);
}

SeriesAttrAlpha.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		this.alpha = js.alpha == undefined ? 1.0 : js.alpha;
	},
	
	equals	:	function(condition) {
		condition = condition || {};
		if(condition instanceof SeriesAttrAlpha) {
			return true;
		}
		return false;
	},
	
	setAlpha	:		function(alpha) {
		this.alpha = alpha;
	},
	
	getAlpha	:		function() {
		return this.alpha;
	}
}

function SeriesAttrBorder(js) {
	this.initConstants(js);
}

SeriesAttrBorder.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.borderColor = js.borderColor == undefined ? 'red' : js.borderColor;
		this.borderStyle = js.borderStyle == undefined ? Constants.prototype.LINE_NONE : js.borderStyle;
	},
	
	equals	:	function(condition) {
		if(condition instanceof SeriesAttrBorder) {
			return true;
		}
		return false;
	},
	
	setBorderColor	:		function(borderColor) {
		this.borderColor = borderColor;
	},
	
	getBorderColor	:		function() {
		return this.borderColor;
	},
	
	setBorderStyle	:		function(borderStyle) {
		this.borderStyle = borderStyle;
	},
	
	getBorderStyle	:		function() {
		return this.borderStyle;
	}
}

function SeriesAttrBackground(js) {
	this.initConstants(js);
}

SeriesAttrBackground.prototype = {
	initConstants	:	function(js) {
		js = js || {};
	
		// ʱֻColorBackground, ȫתͼƬ֮.
		// ImageBackground, GriantBackground, PatternBackground, TextureBackground, IntervalColorBackground
		if(js.seriesBackground == undefined || js.backgroundType == undefined ) {
			this.seriesBackground = null;
		} else {
			var backgroundType = js.backgroundType;
			if(backgroundType == "ColorBackground") {
				this.seriesBackground = new ColorBackground(js.seriesBackground);
			} else if(backgroundType == "TextureBackground" || backgroundType == "PatterBackground"
							|| backgroundType == "ImageBackground") {
				this.seriesBackground = new PatterBackground(js.seriesBackground);
			} else if(backgroundType == "GradientBackground") {
				this.seriesBackground = new GradientBackground(js.seriesBackground);
			}
			
//			this.seriesBackground = new window[backgroundType](js.seriesBackground);
		}
	},
	
	equals	:	function(condition) {
		if(condition instanceof SeriesAttrBackground) {
			return true;
		}
		
		return false;
	},
	
	setSeriesBackground		:		function(seriesBackground) {
		this.seriesBackground = seriesBackground;
	},
	
	getSeriesBackground		:		function() {
		return this.seriesBackground;
	}
}

function SeriesAttrColor(js) {
	this.initConstants(js);
}

SeriesAttrColor.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.seriesColor = js.seriesColor == undefined ? null : js.seriesColor;
	},

	equals	:	function(condition) {
		if(condition instanceof SeriesAttrColor) {
			return true;
		}
		return false;
	},
	
	setSeriesColor	:		function(seriesColor) {
		this.seriesColor = seriesColor;
	},
	
	getSeriesColor	:		function() {
		return this.seriesColor;
	}
}


function 	SeriesAttrLine(js) {
	this.initConstants(js);
}

SeriesAttrLine.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.seriesLineColor = js.seriesLineColor == undefined ? null : js.seriesLineColor;
		this.seriesLineStyle = js.seriesLineStyle == undefined ? Constants.prototype.LINE_THIN : js.seriesLineStyle;
	},
	
	equals	:	function(condition) {
		if(condition instanceof SeriesAttrLine) {
			return true;
		}
		return false;
	},
	
	setSeriesLineStyle 	:		function(lineStyle) {
		this.seriesLineStyle = lineStyle;
	},
	
	getSeriesLineStyle	:		function() {
		return this.seriesLineStyle;
	},
	
	setSeriesLineColor	:		function(lineColor) {
		this.seriesLineColor = lineColor;
	},
	
	getSeriesLineColor	:		function() {
		return this.seriesLineColor;
	}
}


	function SeriesAttrContents(js) {
		this.initConstants(js);
	}
	
	SeriesAttrContents.prototype = {
		
		initConstants	:	function(js) {
			js = js || {};
			
			this.seriesLabel = js.seriesLabel == undefined ? null : js.seriesLabel;
			this.isShowGuidLine = js.isShowGuidLine = undefined ? false : js.isShowGuidLine;
		},
		
		equals	:	function(condition) {
			condition = condition || {};
			if(condition instanceof SeriesAttrContents) {
				return true;
			}
			return false;
		},
		
		setSeriesLabel	:	function(seriesLabel) {
			this.seriesLabel = seriesLabel;
		},
		
		getSeriesLabel 	:	function() {
			return this.seriesLabel;
		},
		
		setShowGuidLine	:	function(isShowGuidLine) {
			this.isShowGuidLine = isShowGuidLine;
		},
		
		getIsShowGuidLine	:	function() {
			return this.isShowGuidLine;
		}
	}
	
	function	SeriesAttrPosition(js) {
		this.initConstants(js);
	}
	
	SeriesAttrPosition.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.position = js.position == undefined ? Constants.prototype.TOP : js.position;
		},
		
		equals	:	function(condition) {
			if(condition instanceof SeriesAttrPosition) {
				return true;
			}
			return false;
		},
		
		setPosition	:	function(position) {
			this.position = position;
		},
		
		getPosition	:	function() {
			return this.position;
		}
	}
	
	
	function	SeriesAttrStyle(js) {
		this.initConstants(js);	
	}
	
	SeriesAttrStyle.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.separation = js.separation == undefined ? "," : js.separation;
			this.textAttr = js.textAttr == undefined ? null : new TextAttr(js.textAttr);
			this.format = js.format == undefined ? null : js.format
		},
		
		equals	:	function(condition) {
			if(condition instanceof SeriesAttrStyle) {
				return true;
			}
			return false;
		},
		
		setSeparation	:	function(separation) {
			this.separation = separation;
		},
		
		getSeparation	:	function() {
			return this.separation;
		},
		
		setTextAttr	:	function(textAttr) {
			this.textAttr = textAttr;
		},
		
		getTextAttr	:	function() {
			return this.textAttr;
		},
		
		setFormat	:	function() {
			this.format	= format;
		},
		
		getFormat	:	function() {
			return this.format;
		}
	}
		
	function ColorBackground(js) {
		this.initConstants(js);
	}
	
	ColorBackground.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.color = js.color == undefined ? null : js.color;
			
			this.isSimulation3D = js.isSimulation3D == undefined ? false : js.isSimulation3D;
			this.isHorizontal = js.isHorizontal == undefined ? false : js.isHorizontal;
		},
		
		getColor	:		function() {
			return this.color;
		},
		
		paint		:		function(ctx, shape) {
			var fillColor = this.color;
			if(fillColor == null) {
				return ;
			}
			
			ctx.save();
			ctx.fillStyle = fillColor;
			shape.paint(ctx);
			ctx.restore();
		},
		
		paint3DSimulation	:	function(ctx, shape, isHorizontal) {
			var fillColor = this.color;
			if(fillColor == null) {
				return ;
			}
			
			ctx.save();
			var linegrad = shape.getLineGradient(ctx, this.isHorizontal);
			
			linegrad.addColorStop(0, fillColor);
			linegrad.addColorStop(1/3, Color.brighter(fillColor));
			linegrad.addColorStop(1, fillColor);
			
			ctx.fillStyle = linegrad;
			shape.paint(ctx);
			
			ctx.restore();
		}
	}
	
	function GradientBackground(js) {
		this.initConstants(js);
	}
	
	GradientBackground.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.LEFT2RIGHT = 0;
			this.TOP2BOTTOM = 1;
			
			this.useCell = js.useCell == undefined ? true : js.useCell;
			this.direction = js.direction == undefined ? 0 : js.direction;
			this.cyclic = js.cyclic == undefined ? false : js.cyclic;
			this.begin = js.begin == undefined ? 0 : js.begin;
			this.finish = js.finish == undefined ? 0 : js.finish;
			this.beginColor = js.beginColor == undefined ? null : js.beginColor;
			this.endColor = js.endColor == undefined ? null : js.endColor;
		},
		
		paint	:	function(ctx, shape) {
			if(this.beginColor == null || this.endColor == null) {
				return;
			}
			
			ctx.save();
			
			var bounds = shape.getBounds2D();
			var lineGradient ;
//			if(this.useCell) {
				// kunsnat: TODO, Ĭϵǰ
				if(this.direction == this.LEFT2RIGHT) {
					lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x + bounds.width, bounds.y);
				} else if(this.direction == this.TOP2BOTTOM) {
					lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height);
				}
					lineGradient.addColorStop(0, this.beginColor);
					lineGradient.addColorStop(1, this.endColor);
//			} else {
//				
//			}
			
			ctx.fillStyle = lineGradient;
			shape.paint(ctx);
			
			ctx.restore();
		}
	}
	
	ColorBackground.getInstance = function(color) {
		var background = new ColorBackground();
		background.color = color;
		return background;
	}		
	
	// ͼ + ԶͼƬ + 
	function	PatterBackground(js) {
		this.initConstants(js);
	}
	
	PatterBackground.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.src = js.src == undefined ? null : js.src;
			this.iesrc = js.iesrc == undefined ? null : js.iesrc;
			
			this.layout = js.layout == undefined ? null : js.layout;
			
			this.specifiedImageHeight = js.specifiedImageHeight == undefined ? null : js.specifiedImageHeight;
			this.specifiedImageWidth = js.specifiedImageWidth == undefined ? null : js.specifiedImageWidth;
			
			this.imgWidth = js.imgWidth == undefined ? null : js.imgWidth;
			this.imgHeight = js.imgHeight == undefined ? null : js.imgHeight;
		},
		
		paint	:	function(ctx, shape) {
			if (!this.src|| this.src == "" || !this.iesrc || this.iesrc == "") {
	            return;
	        }
	        
	        var image = new Image();
	        
	       	if($.browser.msie){
		        image.src =  "${servletURL}?op=attach_image&id=" + this.iesrc;
	        } else {
	        	image.src = this.src;
	        }
	        
	        var bounds = shape.getBounds2D();
	        
	        var width = bounds.width;
	        var height = bounds.height;
	        
	        var imgWidth;
	        if (this.specifiedImageWidth == -1) {
	            imgWidth = this.imgWidth;
	        } else {
	            imgWidth = this.specifiedImageWidth;
	        }
	
	        var imgHeight;
	        if (this.specifiedImageHeight == -1) {
	            imgHeight = this.imgHeight;
	        } else {
	            imgHeight = this.specifiedImageHeight;
	        }
	        
	        if (this.layout == Constants.prototype.IMAGE_TILED) {
	        	
	            if (imgWidth < 0 || imgHeight < 0) {
	                return;
	            }
	            for (var x = 0; x < width; x += imgWidth) {
	                for (var y = 0; y < height; y += imgHeight) {
	                    ctx.drawImage(image, bounds.x + x, bounds.y + y, imgWidth, imgHeight);
	                }
	            }
	            
	        } else if (this.layout == Constants.prototype.IMAGE_CENTER) {
	        	var dx, dy, dwidth, dheight, sx, sy, swidth, sheight;
	        	if(width < imgWidth) {
	        		dx = (imgWidth - width)*0.5; 
	        		sx = 0;
	        	} else {
	        		dx = 0;
	        		sx = (width - imgWidth)*0.5;
	        	}
	        	if(height < imgHeight) {
	        		dy = (imgHeight - height)*0.5;
	        		sy = 0;
	        	} else {
	        		dy = 0;
	        		sy = (height - imgHeight)*0.5;
	        	}
	        	
	        	dwidth = Math.min(width, this.imgWidth);
	        	swidth = Math.min(width, imgWidth);
	        	dheight = Math.min(height, this.imgHeight);
	        	sheight = Math.min(height, imgHeight);
	        	
        		ctx.drawImage(image, dx, dy, dwidth, dheight, bounds.x + sx, bounds.y + sy, swidth, sheight);
	        	
	        } else if (this.layout == Constants.prototype.IMAGE_EXTEND) {
	        	
	            ctx.drawImage(image, bounds.x, bounds.y, width, height);
	            
	        } else if (this.layout == Constants.prototype.IMAGE_DEFAULT) {
                
                ctx.drawImage(image,0, 0, Math.min(width, this.imgWidth), Math.min(height, this.imgHeight), 
                			bounds.x, bounds.y, Math.min(width, imgWidth), Math.min(height, imgHeight));
	        } else {
    			ctx.drawImage(image, bounds.x, bounds.y, width, height);
        	}
		}
	}
	
	function GeneralInfo(js) {
		this.init(js);
	}
	
	GeneralInfo.prototype = {
		init		:		function(js) {
			js = js || {};
			this.seriesAttrAlpha = js.seriesAttrAlpha == undefined ? new SeriesAttrAlpha() : new SeriesAttrAlpha(js.seriesAttrAlpha);
			this.seriesAttrBorder = js.seriesAttrBorder == undefined ? new SeriesAttrBorder() : new SeriesAttrBorder(js.seriesAttrBorder);
			this.seriesAttrBackground = js.seriesAttrBackground == undefined ? new SeriesAttrBackground() : new SeriesAttrBackground(js.seriesAttrBackground);
		},
	
		shadow			:	null,
		
		GeneralInfo		:		function(background, borderColor, borderStyle, alpha) {
			this.getSeriesAttrBackground().setSeriesBackground(background);
				
			this.getSeriesAttrBorder().setBorderColor(borderColor);
			this.getSeriesAttrBorder().setBorderStyle(borderStyle);
			this.getSeriesAttrAlpha().setAlpha(alpha);
		},
		
		getBackground		:		function() {
			return this.getSeriesAttrBackground().getSeriesBackground();
		},
		
		setBackground		:		function(background) {
			this.getSeriesAttrBackground().setSeriesBackground(background);
		},
		
		setSereisAttrAlpha	:		function(seriesAttrAlpha) {
			this.seriesAttrAlpha = seriesAttrAlpha;
		},
		
		getSeriesAttrAlpha	:		function() {
			return this.seriesAttrAlpha;
		},
		
		setSeriesAttrBorder	:		function(seriesAttrBorder) {
			this.seriesAttrBorder = seriesAttrBorder;
		},
		
		getSeriesAttrBorder	:		function() {
			return this.seriesAttrBorder;
		},
		
		setSeriesAttrBackground		:		function(seriesAttrBackground) {
			this.seriesAttrBackground = seriesAttrBackground;
		},
		
		getSeriesAttrBackground		:		function() {
			return this.seriesAttrBackground;
		},
		
		getBorderStyle		:		function() {
			return this.getSeriesAttrBorder().getBorderStyle();
		},
		
		setBorderStyle		:		function(borderStyle) {
			this.getSeriesAttrBorder().setBorderStyle(borderStyle);
		},
		
		getBorderColor		:		function() {
			return this.getSeriesAttrBorder().getBorderColor();
		},
		
		setBorderColor		:		function(borderColor) {
			this.getSeriesAttrBorder().setBorderColor(borderColor);
		},
		
		getAlpha		:		function() {
			return this.seriesAttrAlpha.getAlpha();
		},
		
		setAlpha		:		function(alpha) {
			this.seriesAttrAlpha.setAlpha(alpha);
		},
		
		paint		:		function(ctx, shape) {
			if(shape == null) {
				return;
			}
			ctx.save();
			
			ctx.globalAlpha  = this.seriesAttrAlpha.alpha;
		
			if (this.seriesAttrBackground.seriesBackground != null) {
				this.seriesAttrBackground.seriesBackground.paint(ctx, shape);
			}
			
	        if (this.seriesAttrBorder.borderStyle != Constants.prototype.LINE_NONE) {
				// TODO
	            //GraphHelper.draw(g2d, shape, borderStyle);
	        }
		
			ctx.restore();
		},
		
		dealCondition		:		function(collection, index) {
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(), index);
			this.setSereisAttrAlpha(attrAlpha);
		
			var attrBackground = collection.getSeriesCondition(new SeriesAttrBackground(),index);
			this.setSeriesAttrBackground(attrBackground);
		
			var attrBorder = collection.getSeriesCondition(new SeriesAttrBorder(),index);
			this.setSeriesAttrBorder(attrBorder);
		}
	}
	
	function General3DInfo() {
		this.initConstants();
	}
	
	FR.extend(General3DInfo, GeneralInfo, {
		initConstants 	:	function() {
			this.isHorizontal = false;
		},
		
		paint		:		function(ctx, shape) {
			if(shape == null) {
				return;
			}
			ctx.save();
			
			ctx.globalAlpha  = this.seriesAttrAlpha.alpha;
		
			if (this.seriesAttrBackground.seriesBackground instanceof ColorBackground ) {
				this.seriesAttrBackground.seriesBackground.paint3DSimulation(ctx, shape, this.isHorizontal);
			} else if(this.seriesAttrBackground.seriesBackground != null){
				this.seriesAttrBackground.seriesBackground.paint(ctx, shape);
			}
			
	        if (this.seriesAttrBorder.borderStyle != Constants.prototype.LINE_NONE) {
				// TODO
	            //GraphHelper.draw(g2d, shape, borderStyle);
	        }
		
			ctx.restore();
		}
	});

	function	Marker(js) {
		this.initConstants(js);
	}
	
	Marker.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.size = js.size == undefined ? 5.0 : js.size;
			this.color = js.color == undefined ? null : js.color;
		},
		size	:	5.0,
		color	:	null,
		
		getSize	:	function() {
			return this.size;
		},
		
		setSize	:	function(size) {
			this.size = size;
		},
		
		setColor	:	function(color) {
			this.color = color;
		},
		
		getColor	:	function() {
			return this.color;
		},
		
		paint	:	function(ctx, x, y) {
			ctx.save();
			
			if(this.color != null) {
				ctx.fillStyle = this.color;
			}
			
			this.paintMarker(ctx, x, y);
			
			ctx.restore();
		}
	}
	
	function	MarkerFactory() {
		
	}
	
	MarkerFactory.createIndexMarker	= function(index) {
		switch(index % 17) {
			case 0:	return new DiamondFilledMarker();
			case 1: return new StarMarker();
			case 2: return new SquareFilledMarker();
			case 3: return new XMarker();
			case 4: return new TriangleFilledMarker();
			case 5: return new CrossMarker();
			case 6: return new PlusSignMarker();
			case 7: return new CircleFilledMarker();
			case 8: return new MinusSignMarker();
			case 9: return new DiamondMarker();
			case 10: return new SquareMarker();
			case 11: return new TriangleMarker();
			case 12: return new CircleMarker();
			case 13: return new AllEqualMarker();
			case 14: return new ClockLineMarker();
			case 15: return new AntiClockLineMarker();
//			case 16: return new PointMarker();
			
			default: return new DiamondFilledMarker();
		}
	}
	
	function	MarkerGlyph(js) {
		this.initConstants(js);
	}
	
	MarkerGlyph.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.marker = null;
			this.x = 0;
			this.y = 0;
			this.width = 0;
			this.height = 0;
			
			// js򴫹ֻcoloralpha, ĶplotGlyphdolayoutʱ
			this.alpha = js.alpha == undefined ? 1.0 : js.alpha;
			this.color = js.color == undefined ? null : js.color;
		},
		
		draw	:	function(ctx) {
			if (this.getMarker() == null) {
				return;
			}
			
			ctx.save();
			ctx.globalAlpha = this.getAlpha();			
			
			if (this.getColor() != null) {
				// ΪҲл.
				ctx.fillStyle = this.getColor();
				ctx.strokeStyle = this.getColor();
			}
			
			this.getMarker().paint(ctx, this.x + this.width / 2.0, this.y + this.height / 2.0);
			
			ctx.restore();
		},
		
		getShape	:	function() {
			return new Bounds(this.x, this.y, this.width, this.height);
		},
		
		setShape	:	function(bounds) {
			this.x = bounds.getX();
			this.y = bounds.getY();
			this.width = bounds.getWidth();
			this.height = bounds.getHeight();
		},
		
		setMarker	:	function(marker) {
			this.marker = marker;
		},
		
		getMarker	:	function() {
			return this.marker;
		},
		
		setColor	:	function(color) {
			this.color = color;
		},
		
		getColor	:	function() {
			return this.color;
		},
		
		setAlpha	:	function(alpha) {
			this.alpha = alpha;
		},
		
		getAlpha	:	function() {
			return this.alpha;
		},
		
		dealCondition	:	function(collection, index) {
			var markerType = collection.getSeriesCondition(new SeriesAttrMarkerType(), index);
			this.setMarker(MarkerFactory.createIndexMarker(markerType.markerTypeIndex));
		
			var attrColor = collection.getSeriesCondition(new SeriesAttrColor(), index);
			this.setColor(attrColor.getSeriesColor());
			
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(), index);
			this.setAlpha(attrAlpha.getAlpha());
		},
		
		dealCondition4Line	:	function(collection, index) {
			var markerType = collection.getSeriesCondition(new SeriesAttrMarkerType(), index);
			this.setMarker(MarkerFactory.createIndexMarker(markerType.markerTypeIndex));
		
			var attrLine = collection.getSeriesCondition(new SeriesAttrLine(), index);
			this.setColor(attrLine.getSeriesLineColor());
			
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(), index);
			this.setAlpha(attrAlpha.getAlpha());
		},
		
		getBounds2D	:	function() {
			return this.getBounds();
		}
	}
	
	function AntiClockLineMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(AntiClockLineMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			AntiClockLineMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			var size = this.size;
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size * 0.5, y - size), new Point2D(x + size, y + size * 0.5)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x, y - size), new Point2D(x + size, y)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y - size), new Point2D(x + size, y + size)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x + size * 0.5, y - size), new Point2D(x + size, y - size * 0.5)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y - size * 0.5), new Point2D(x + size * 0.5, y + size)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y), new Point2D(x, y + size)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y + size * 0.5), new Point2D(x - size * 0.5, y + size)));
		}
	});
	
	function ClockLineMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(ClockLineMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			ClockLineMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			var size = this.size;
			
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y - size * 0.5), new Point2D(x - size * 0.5, y - size)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y), new Point2D(x, y - size)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y + size * 0.5), new Point2D(x + size * 0.5, y - size)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size, y + size), new Point2D(x + size, y - size)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - size * 0.5, y + size), new Point2D(x + size, y - size * 0.5)));
			 
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x, y + size), new Point2D(x + size, y)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x + size * 0.5, y + size), new Point2D(x + size, y + size * 0.5)));
		}
	});
	
	function PointMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(PointMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			PointMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			var size = this.size;
			var pointNumber = 4;
			for(var i = 0; i < pointNumber; i ++) {
				for(var j = 0; j < pointNumber; j++) {
					var x1 = x - size + 2 * size * i/pointNumber;
					var y1 = y - size + 2 * size * j/pointNumber;
					GraphHelper.drawLine (ctx, new Line2D(new Point2D(x1, y1), new Point2D(x1, y1)));
				}
			}
		}
	});
	
	function  AllEqualMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(AllEqualMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			AllEqualMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y - this.size), new Point2D(x + this.size, y - this.size)));
			 GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y), new Point2D(x + this.size, y)));
		     GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y + this.size), new Point2D(x + this.size, y + this.size)));
		}
	});

	function	CircleFilledMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(CircleFilledMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			CircleFilledMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			ctx.beginPath();
			ctx.arc(x, y, this.size, 0, 360, true);
			ctx.fill();
		}
	});
	
	function	CircleMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(CircleMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			CircleMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			ctx.beginPath();
			ctx.arc(x, y, this.size, 0, 360, true);
			ctx.stroke();
		}
	});
	
	
	function	CrossMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(CrossMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			CrossMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			ctx.beginPath();
			
			ctx.moveTo(x - this.size, y);
			ctx.lineTo(x + this.size, y);
			ctx.moveTo(x, y + this.size);
			ctx.lineTo(x, y - this.size);
			
			ctx.stroke();
		}
	});	
	

	function	DiamondFilledMarker(js) {
		this.initConstants(js);
	}
	
	FR.extend(DiamondFilledMarker, Marker, {
		initConstants	:	function(js) {
			js = js || {};
			
			DiamondFilledMarker.superclass.initConstants.apply(this, [js]);
		},
		
		paintMarker		:	function(ctx, x, y) {
			var px = [x - this.size, x, x + this.size, x];
	        var py = [y, y - this.size, y, y + this.size];
	
			ctx.beginPath();
	
	        ctx.moveTo(px[px.length - 1], py[px.length - 1]);
	        for (var i = 0; i < px.length; i++) {
	            ctx.lineTo( px[i], py[i]);
	        }
			
			ctx.fill()
		}
	});
	
		function	DiamondMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(DiamondMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				DiamondMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				var px = [x - this.size, x, x + this.size, x];
		        var py = [y, y - this.size, y, y + this.size];
		        
		        ctx.beginPath();
		
		        ctx.moveTo(px[px.length - 1], py[px.length - 1]);
		        for (var i = 0; i < px.length; i++) {
		            ctx.lineTo(px[i], py[i]);
		        }
		        
		        ctx.stroke();
			}
		});
		
		function	DowJonesMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(DowJonesMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				DowJonesMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				this.size = this.size / 2;
				
				ctx.lineWidth = Constants.prototype.LINE_THIN;
				ctx.beginPath();
				ctx.moveTo(x, y);
				ctx.lineTo(x + this.size, y);
				ctx.stroke();
			}
		});
		
		function	NullMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(NullMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				NullMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				
			}
		});
		
		function	PlusSignMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(PlusSignMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				PlusSignMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				GraphHelPer.drawLine(ctx, new Line2D(new Point2D(x - thi.size, y + this.size), new Point2D(x + this.size, y + this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x, y + this.size), new Point2D(x, y - this.size)));
			}
		});
		
		function	SquareFilledMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(SquareFilledMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				SquareFilledMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				ctx.fillRect(x - this.size/2, y - this.size/2, this.size, this.size);
			}
		});
		
		function	SquareMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(SquareMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				SquareMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				ctx.strokeRect(x - this.size, y - this.size, this.size, this.size);
			}
		});
		
		function	StarMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(StarMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				StarMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y), new Point2D(x + this.size, y)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x, y + this.size), new Point2D(x, y - this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y - this.size), new Point2D(x + this.size, y + this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y + this.size), new Point2D(x + this.size, y - this.size)));
			}
		});
		
		function	TriangleFilledMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(TriangleFilledMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				TriangleFilledMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				var px = [x - this.size, x + this.size, x];
				var py = [y + this.size, y + this.size, y - this.size];
				
				ctx.beginPath();
				
				ctx.moveTo(px[px.length - 1], py[py.length - 1]);
				for(var i = 0; i < px.length; i++) {
					ctx.lineTo(px[i], py[i]);
				}
				
				ctx.fill();
			}
		});
		
		function	TriangleMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(TriangleMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				TriangleMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y + this.size), new Point2D(x + this.size, y + this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y + this.size), new Point2D(x, y - this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x, y - this.size), new Point2D(x + this.size, y + this.size)));
			}
		});
		
		function	XMarker(js) {
			this.initConstants(js);
		}
		
		FR.extend(XMarker, Marker, {
			initConstants	:	function(js) {
				js = js || {};
				
				XMarker.superclass.initConstants.apply(this, [js]);
			},
		
			paintMarker		:	function(ctx, x, y) {
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y - this.size), new Point2D(x + this.size, y + this.size)));
				GraphHelper.drawLine(ctx, new Line2D(new Point2D(x - this.size, y + this.size), new Point2D(x + this.size, y - this.size)));
			}
		});
		
	function	GeneralPath() {
		this.initConstants();
	}
	
	GeneralPath.prototype = {
		initConstants	:	function() {
			this.x	=	[];
			this.y	=	[];
			
			// kunsnat: ¼Ƿʼ, ΪlinePlotпжϵ׼
			// ֻڲӦ.
			this.isStart = [];
		},
		
		// TODO  ֧ߵ 
		drawStroke	:	function(ctx) {
			ctx.beginPath();
			for(var i = 0; i < this.x.length; i++) {
				if(this.isStart[i]) {
					ctx.moveTo(this.x[i], this.y[i]);
				} else {
					ctx.lineTo(this.x[i], this.y[i]);
				}
			}
			ctx.stroke();
		},
		
		paint	:	function(ctx) {
			ctx.beginPath();
			for(var i = 0; i < this.x.length; i++) {
				if(this.isStart[i]) {
					ctx.moveTo(this.x[i], this.y[i]);
				} else {
					ctx.lineTo(this.x[i], this.y[i]);
				}
			}
			ctx.fill();
		},
		
		// Areaͼ 
		getAnimateShape	:	function(step) {
			var pathArray = [];
			
			for(var actionStep = 0; actionStep < step; actionStep ++) {
				
				var generalPath = new GeneralPath();
				pathArray[actionStep] = generalPath;
						
				var pathLength = this.x.length;
				for(var i = 0; i < pathLength; i++) {
					if(i == 0) {
						generalPath.moveTo(this.x[i], this.y[0]);
					} else if(i < pathLength/2) {
						var x1 = this.x[i];
						var y1 = this.y[i];
						var x2 = this.x[pathLength - i];
						var y2 = this.y[pathLength - i];
						
						generalPath.lineTo(x2 + (x1 - x2) * (actionStep + 1) / step, 
											y2 + (y1 - y2) * (actionStep + 1) / step);
					} else {
						generalPath.lineTo(this.x[i], this.y[i]);
					}
				}
			}
			
			return pathArray;
		},
		
		// ߲.  Yмֵy, (, ɢ) ״ͼ
		getAnimatePath	:	function(step) {
			var pathArray = new Array();
			
			var pointCount = this.x.length;
			
			// kunsnat: û취İ취, ٵСĲ, Ȼ̫, IE. 
			if(pointCount > 10) {
				step = 1;
			}
			
			// kunsnat: һֶ̬ʽ, ûô.
//			// kunsnat: layoutʱ
//			var y = this.centerValue; 
//			
//			for(var i = 0; i < step; i++) {
//				var path = new GeneralPath();
//				for(var points = 0; points < pointCount; points++) {
//					var stepY = y + (this.y[points] - y) * i / (step - 1);
//					if(points == 0) {
//						path.moveTo(this.x[points], stepY);
//					} else {
//						path.lineTo(this.x[points], stepY);
//					}
//				}
//				pathArray.push(path);
//			}
//			
//			return pathArray;
			
			var animateX = new Array();
			var animateY = new Array();
			// pointCuount - 1, 
			for(var i = 0; i < pointCount - 1; i++) { 
				
				// ͳƶϵ, һʼ ˵. ֮isStart--> 
//				var startPoint = 0;  Ȳ, Ϊڻ֧ߵĶϵ
//				for(var isStart = 0; isStart < this.isStart.length; isStart++) {
//					if(this.isStart[i])startPoint++;
//				}
				
				// ȷֳsep. isStart ÿֱӷֳstep
				for(var j = 0; j < step; j++) {
					animateX.push(this.x[i] + (this.x[i+1] - this.x[i]) * j / step);
					animateY.push(this.y[i] + (this.y[i+1] - this.y[i]) * j / step);
				}
				// ټ һ˵.
				if(i == pointCount - 2) {
					animateX.push(this.x[i + 1]);
					animateY.push(this.y[i + 1]);
				}
			}
			
			//  pathĿanimatelength1
			for(var animateNumber = 1; animateNumber < animateX.length; animateNumber++) {
				var path = new GeneralPath();
				pathArray[animateNumber - 1] = path;
				for(var i = 0; i < animateNumber + 1; i++) {
					if(i == 0) {
						path.moveTo(animateX[i], animateY[i]);
					} else {
						path.lineTo(animateX[i], animateY[i]);
					}
				}
			}
			
			return pathArray;
		},
		
		moveTo	:	function(x, y) {
			this.isStart[this.isStart.length] = true;
			this.x[this.x.length] = x;
			this.y[this.y.length] = y;
		},
		
		lineTo	:	function(x, y) {
			this.isStart[this.isStart.length] = false;
			this.x[this.x.length] = x;
			this.y[this.y.length] = y;
		},
		
		closePath	:	function() {
			this.lineTo(this.x[0], this.y[0]);
		},
		
		//  Χ.
		getBounds2D	:	function() {
			var x = this.x[0],y = this.y[0],width = this.x[0],height = this.y[0];
			for(var i = 0; i < this.x.length; i++) {
				x = Math.min(this.x[i], x);
				y = Math.min(this.y[i], y);
				width = Math.max(this.x[i], width);
				height = Math.max(this.y[i], height);
			}
			return new Bounds(x,y,width-x,height-y)
		}
	}
	
	function	LineStyleInfo() {
		this.initConstants();
	}
	
	LineStyleInfo.prototype = {
		initConstants	:	function() {
			this.seriesAttrLine = new SeriesAttrLine();
			this.seriesAttrAlpha = new SeriesAttrAlpha();
		},
		
		setDefaultAlpha 	:	function(alpha) {
			this.getSeriesAttrAlpha().setAlpha(alpha);
		},
		
		getDefaultAlpha 	:	function() {
			return this.getSeriesAttrAlpha().getAlpha();
		},
		
		setSeriesAttrAlpha	:	function(seriesAttrAlpha) {
			this.seriesAttrAlpha = seriesAttrAlpha;
		},
		
		getSeriesAttrAlpha 	:	function() {
			return this.seriesAttrAlpha;
		},
		
		setSeriesLineColor	:	function(seriesLineColor) {
			this.seriesAttrLine.setSeriesLineColor(serieLineColor);
		},
		
		getSeriesLineColor	:	function() {
			return this.seriesAttrLine.getSeriesLineColor();
		},
		
		setSeriesLineStyle	:	function(seriesLineStyle) {
			this.seriesAttrLine.setSeriesLineStyle(seriesLineStyle);
		},
		
		getSeriesLineStyle	:	function() {
			return this.seriesAttrLine.getSeriesLineStyle();
		},
		
		setSeriesAttrLine	:	function(attrLine) {
			this.seriesAttrLine = attrLine;
		},
		
		getSeriesAttrLine	:	function() {
			return this.seriesAttrLine;
		},
		
		paint	:	function(ctx, path, time, xylist) {
			if (path == null || this.getSeriesLineColor() == null 
				|| this.getSeriesLineStyle() == Constants.LINE_NONE) {
				return;	
			}
			ctx.save();
			
			ctx.strokeStyle = this.getSeriesLineColor();
			ctx.globalAlpha = this.getDefaultAlpha();
			ctx.lineWidth = this.getSeriesLineStyle();
			
			path.drawStroke(ctx, time, xylist, this.getSeriesLineColor());
			
			ctx.restore();
		},
		
		dealCondition	:	function(collection, index) {
			var seriesAttrLine = collection.getSeriesCondition(new SeriesAttrLine(), index);
			this.setSeriesAttrLine(seriesAttrLine);
			
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(), index);
			this.setSeriesAttrAlpha(attrAlpha);
		}
	}
	
	function	FoldLine(generalPath) {
		this.initConstants();
		
		this.generalPath = generalPath;
	}
	
	FoldLine.prototype = {
		initConstants	:	function() {
			this.lineStyleInfo = new LineStyleInfo();
		},
		
		generalPath	:	null,
		
		draw	:	function(ctx, time, xylist) {
			this.lineStyleInfo.paint(ctx, this.getGeneralPath(), time, xylist);
		},
		
		getShape	:	function() {
			return this.getGeneralPath();
		},
		
		setGeneralPath :	function(generalPath) {
			this.generalPath = generalPath;
		},
		
		getGeneralPath	:	function() {
			return this.generalPath;
		},
		
		setLineStyleInfo	:	function(lineStyleInfo) {
			this.lineStyleInfo = lineStyleInfo;
		},
		
		getLineStyleInfo 	:	function() {
			return this.lineStyleInfo;
		},
		
		getAnimateGlyph	:	function(step) {
			var lineArray = [];
			
			if(this.generalPath != null) {
				// step ĳ4, Сһ. IEʵ̫.
				var pathArray = this.generalPath.getAnimatePath(10);
				for(var i = 0; i < pathArray.length; i++) {
					var line = new FoldLine(pathArray[i]);
					lineArray[i] = line;
					
					line.setLineStyleInfo(this.lineStyleInfo);
				}
			}
			
			return lineArray;
		}
	}
	
function ChartGlyphLayout() {
	
}

ChartGlyphLayout.prototype = {
	bounds	:	null,
	
	setLayoutBounds 	:		function(bounds) {
		this.bounds = bounds;
	},
	
	getLayoutBounds		:		function() {
		return this.bounds;
	},
	
	doLayout	:		function(glyph) {
		if(glyph == null) {
			return;
		}
		if(glyph instanceof ChartGlyph) {
			var titleGlyph = glyph.titleGlyph;
			if(titleGlyph != null) {
				var dimension = titleGlyph.preferredDimension();
				var titleBounds = new Bounds(
					(this.bounds.getWidth() - dimension.getWidth()) / 2.0,
					this.bounds.getY(),
					dimension.getWidth(),
					dimension.getHeight()
				);
				titleGlyph.setBounds(titleBounds);	
			} 
		
			var legendGlyph = glyph.legendGlyph;
			if(legendGlyph != null) {
				var position = legendGlyph.getPosition();
				var dimension = legendGlyph.prefferedSizeByItems();
		
				var legendBounds;
				if(position == Constants.prototype.TOP) {
					legendBounds = new Bounds(
						(this.bounds.getWidth() - dimension.getWidth())/2.0, this.bounds.getY() + this.bounds.getHeight()*0.1,
						dimension.getWidth(), dimension.getHeight()
					);
				} else if(position == Constants.prototype.RIGHT) {
					legendBounds = new Bounds(
						this.bounds.getWidth() - dimension.getWidth() - 8, (this.bounds.getHeight() - dimension.getHeight())/2.0,
						dimension.getWidth(), dimension.getHeight()
					);
				} else if(position == Constants.prototype.BOTTOM) {
					legendBounds = new Bounds(
						(this.bounds.getWidth() - dimension.getWidth())/2.0, this.bounds.getHeight() - dimension.getHeight() - 8.0,
						dimension.getWidth(), dimension.getHeight()
					);
				} else if(position == Constants.prototype.LEFT) {
					legendBounds = new Bounds(
						this.bounds.getX() + 8, (this.bounds.getHeight() - dimension.getHeight())/2.0,
						dimension.getWidth(), dimension.getHeight()
					);
				}
				legendGlyph.setBounds(legendBounds);
				legendGlyph.refreshItemBounds();
			} 
		
			var plotGlyph = glyph.plotGlyph;
			if(plotGlyph != null) {
				var centerBounds = new Bounds(
					this.bounds.getX() + 0.1*this.bounds.getWidth(),
					this.bounds.getY() + 0.2*this.bounds.getHeight(),
					0.8*this.bounds.getWidth(),
					0.7*this.bounds.getHeight()
				);
				plotGlyph.setBounds(centerBounds);
				
				if(plotGlyph instanceof Bar3DPlotGlyph || plotGlyph instanceof Line3DPlotGlyph || plotGlyph instanceof Area3DPlotGlyph) {
					var centerBounds = new Bounds(
						this.bounds.getX() + 0.1*this.bounds.getWidth(),
						this.bounds.getY() + 0.2*this.bounds.getHeight(),
						0.7*this.bounds.getWidth(),
						0.7*this.bounds.getHeight()
					);
					plotGlyph.setBounds(centerBounds);
				}
				plotGlyph.layoutAxisGlyph();
				plotGlyph.layoutDataSeriesGlyph();
			}
		}
	}
}

function GeneralGlyph(js) {	
	this.initConstants(js);
}

GeneralGlyph.prototype = {
	initConstants		:		function(js) {
		js = js || {};
		this.info = js.info == undefined ? new GeneralInfo() : new GeneralInfo(js.info);
	},
		
	setInfo		:		function(info) {
		this.info = info;
	},
	
	getInfo		:		function() {
		return this.info;
	},
	
	getBackground		:		function() {
		return this.info.getBackground();
	},
	
	setBackground		:		function(background) {
		this.info.setBackground(background);
	},
	
	getBorderStyle		:		function() {
		return this.info.getBorderStyle();
	},
	
	setBorderStyle		:		function(borderStyle) {
		this.info.setBorderStyle(borderStyle);
	},
	
	getBorderColor		:		function() {
		return this.info.getBorderColor();
	},
	
	setBorderColor		:		function(borderColor) {
		this.info.setBorderColor(borderColor);
	},
	
	getAlpha		:		function() {
		return this.info.getAlpha();
	},
	
	setAlpha		:		function(alpha) {
		this.info.setAlpha(alpha);
	},
	
	draw		:		function(ctx) {
		this.info.paint(ctx, this.getOutline4Fill());
	}
}

function RectangleGlyph(js) {
	this.initConstants(js);
}

FR.extend(RectangleGlyph, GeneralGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		this.visible = js.visible == undefined ? true : js.visible;
		
		RectangleGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	bounds	:	null,
		
	setBounds		:		function(bounds) {
		this.bounds = bounds;
	},
	
	getBounds		:		function() {
		return this.bounds;
	},
	
	setVisible		:		function(visible) {
		this.visible = visible;
	},
	
	getVisible		:		function() {
		return this.visible;
	},
	
	getOutline4Fill		:		function() {
		return this.getBounds();
	},
	
	getShape		:		function() {
		return this.getBounds();
	}
});

function ShapeGlyph(js) {
	this.initConstants(js);
}

FR.extend(ShapeGlyph, GeneralGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		// kunsnat: shape jsֻõһЩbackground, border, borderColor, õshape. 
		this.shape = null;
		
		ShapeGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	setShape	:		function(shape) {
		this.shape = shape;
	},
	
	getShape	:		function() {
		return this.shape;
	},
	
	getOutline4Fill		:		function() {
		return this.getShape();
	},
	
	getAnimateGlyph	:	function(step) {
		if(this.shape != null) {
			this.animateShape = this.shape.getAnimateShape(step);
		}
		
		var animateGlyph = [];
		for(var i = 0; i < this.animateShape.length; i++) {
			animateGlyph[i] = new ShapeGlyph();
			animateGlyph[i].shape = this.animateShape[i];
			animateGlyph[i].setInfo(this.getInfo());
		}
		 
		return animateGlyph;
	}
});

	function TextGlyph(js) {
		this.initConstants(js);
	}

	FR.extend(TextGlyph, RectangleGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.text = js.text == undefined ? null : js.text;
			
			// kunsnat: FFµĻз\n --> \n\r
//			if(this.text != null) {
//				if(this.text.match(/\n/)) {
//					this.text = this.text.replace(/\n/, "\br");
//				}
//			}
			
			this.textAttr = js.textAttr == undefined ? null : new TextAttr(js.textAttr);
			
			TextGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		setText		:		function(text) {
			this.text = text;
		},
		
		getText		:		function() {
			return this.text;
		},
		
		getTextAttr		:		function() {
			return this.textAttr;
		},
		
		setTextAttr		:		function(textAttr) {
			this.textAttr = textAttr;
		},
		
		draw		:		function(ctx) {
			RectangleGlyph.superclass.draw.apply(this,[ctx]);
		
			// kunsnat: ǿΪ1, ͸Ч
			var oldAlpha = ctx.globalAlpha;
			ctx.globalAlpha = 1.0;
			TextGlyph.drawLabel(ctx, this.getText(),this.getTextAttr(),this.getBounds());
			ctx.globalAlpha = oldAlpha;
		},
		
		preferredDimension		:		function() {
			return TextGlyph.calculateTextDimension(this.text, this.textAttr);
		},
		
		preferredLabelBounds	:		function(dataPoint, position) {
			var labelBounds = null;
			// refreshBounds
			var dim = this.preferredDimension();
			var rect = dataPoint.getShape().getBounds2D();
			
			// ȼ4, ԭ: MeterPlot ֿȲ  ʾ.(ֵʱ.)
			if (position == Constants.prototype.RIGHT) {
				labelBounds = new Bounds(
						rect.getX() + rect.getWidth(), rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, dim.getWidth() + 4, dim.getHeight()
				);
			} else if (position == Constants.prototype.TOP){	
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() - dim.getHeight(), dim.getWidth() + 4, dim.getHeight()
				);
			} else if (position == Constants.prototype.LEFT) {
				labelBounds = new Bounds(
						rect.getX() - dim.getWidth(), rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, dim.getWidth() + 4, dim.getHeight()
				);
			} else if (position == Constants.prototype.BOTTOM) {
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() + rect.getHeight(), dim.getWidth() + 4, dim.getHeight()
				);
			} else if (position == Constants.prototype.CENTER) {
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, dim.getWidth() + 4, dim.getHeight()
				);
			} // kunsnat: ڲ  ͼ. ᲻ͬ. createSeriesChildrenʱҪ¶λ.
			else if (position == Constants.prototype.AXISINSIDE) {
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() + rect.getHeight() - dim.getHeight(), dim.getWidth() + 4, dim.getHeight()
				);
			} // ݱ
			else if (position == Constants.prototype.INSIDE) {
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY(), dim.getWidth() + 4, dim.getHeight()
				);
			} // ݱ
			else if (position == Constants.prototype.OUTSIDE) {
				labelBounds = new Bounds(
					    rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() - dim.getHeight(), dim.getWidth() + 4, dim.getHeight()	
				);
			}
			else {
				// Ĭ ӱͼתʱ, ûдλ, ĬΪTopͬ.
				labelBounds = new Bounds(
						rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, rect.getY() - dim.getHeight(), dim.getWidth() + 4, dim.getHeight()
				);
			}
			
			// kunsnat: ͼλô (ݱǩں)пõǶ  ÿĽǶ ԷPiePlotȥ.. ṹ.
			this.setBounds(labelBounds);
		},
		
		dealCondition		:		function(collection,index) {
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(),index);
			this.setAlpha(attrAlpha.getAlpha());
		}
	});

	TextGlyph.calculateTextDimension = function(text,textAttr) {
		if(text == "") {
			return new Dimension2D();
		}
		
		if(textAttr == null) {
			textAttr = new TextAttr();
		}
		
		var font = textAttr.getFrFont();
		
		if(font == null) {
			font = new FRFont(); 
		}
	
		return GraphHelper.stringDimension(text, font, textAttr.getRotation());
	}
	
	TextGlyph.drawLabel = function(ctx, text, textAttr, bounds) {
		if(text == null || bounds == null) {
			return;
		}	
		
		if(textAttr == null) {
			textAttr = new TextAttr();
		}
	
		ctx.translate(bounds.getX(),bounds.getY());
	
		if(textAttr.getFrFont() == null) {
			textAttr.setFrFont(new FRFont());
		} 
		
		// kunsnat: widthе4Ϊ ʵķſ preferredDim Ȼȿܲ
		PaintUtils.paintContent(ctx, text, textAttr, bounds.getWidth(), bounds.getHeight());
	
		ctx.translate(-bounds.getX(), -bounds.getY());
	}

function HashMap(jsMap)
{
   	this.initConstants(jsMap);
}

HashMap.prototype = {
	initConstants	:	function(jsMap) {
		this.length = 0;
		
		jsMap = jsMap || {};
		if(jsMap.length > 0) {
			for(var i = 0; i < jsMap.length; i++) {
				var keyValue = jsMap[i];
			 	var seriesAttrType = keyValue.value.seriesAttrType;
			 	
			 	var seriesAttr;
			 	if(seriesAttrType == "SeriesAttr") {
			 		seriesAttr = new SeriesAttr(keyValue.value);
			 	} else if(seriesAttrType == "CustomAttr") {
			 		seriesAttr = new CustomAttr(keyValue.value);
			 	}
			 	
			 	this.put(keyValue.key, seriesAttr);
		 	}
		 }
	},
	
	put	:	function (key, value)
	{
	    this[key] = value;
	    this.length ++;
	},
	
	get	:	function(key) {
		return this[key];
	},
	
	containsKey	:	function(key) {
		if(this[key] === undefined) {
			return false;
		}
		return true;
	}
}

function SeriesAttr(js) {
	this.initConstants(js);
}

SeriesAttr.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		if(js.conditionList == undefined) {
			this.conditionList = new Array();
		} else {
			this.conditionList = new Array();
			var list = js.conditionList;
			for(var i = 0; i < list.length; i++) {
				var conditionObject = list[i];
				var conditionType = conditionObject.conditionType;
				
				var condition = conditionObject.condition;
				if(conditionType == "SeriesAttrAlpha") {
					this.conditionList.push(new SeriesAttrAlpha(condition));
				} else if(conditionType == "SeriesAttrBorder") {
					this.conditionList.push(new SeriesAttrBorder(condition));
				} else if(conditionType == "SeriesAttrBackground") {
					this.conditionList.push(new SeriesAttrBackground(condition));
				} else if(conditionType == "SeriesAttrColor") {
					this.conditionList.push(new SeriesAttrColor(condition));
				} else if(conditionType == "SeriesAttrContents") {
					this.conditionList.push(new SeriesAttrContents(condition));
				} else if(conditionType == "SeriesAttrLine") {
					this.conditionList.push(new SeriesAttrLine(condition));
				} else if(conditionType == "SeriesAttrPosition") {
					this.conditionList.push(new SeriesAttrPosition(condition));
				} else if(conditionType == "SeriesAttrStyle") {
					this.conditionList.push(new SeriesAttrStyle(condition));
				} else if(conditionType == "SeriesAttrMarkerType") {
					this.conditionList.push(new SeriesAttrMarkerType(condition));
				}
			}
		}
	},
	
	conditonCount	:		function() {
		return this.conditionList.length;
	},
	
	getCondition	:		function(index) {
		if(index >= this.conditionList.length) {
			return null;
		}
		return this.conditionList[index];
	},
	
	addConditon		:		function(condition) {
		this.conditionList.push(condition);
	},
	
	isContains		:		function(condition) {
		for(var i = 0; i < this.conditionList.length; i++) {
			if(this.getCondition(i).equals(condition)) {
				return this.getCondition(i);
			}
		}
		return null;
	}
}

	function CustomAttr(js) {
		this.initConstants(js);
	}
	
	FR.extend(CustomAttr, SeriesAttr, {
		initConstants	:	function(js) {
			js = js || {};
			CustomAttr.superclass.initConstants.apply(this, [js]);
			
			this.renderer = js.renderer == undefined ? 1 : js.renderer;
			this.axisPosition = js.axisPosition == undefined ? 1 : js.axisPosition;
		},
		
		// CustomPlotеstatic
		BAR_RENDERER	:	1,
		LINE_RENDERER	:	2,
		AREA_RENDERER	:	4,
		
		Axis_LEFT	:	"LEFT",
		Axis_RIGHT	:	"RIGHT",
		
		renderer	:	1, //BAR_RENDERER
		axisPosition	:	"LEFT",// Axis_LEFT
		
		setRenderer	:	function(renderer) {
			this.renderer = renderer;
		},
		
		getRenderer	:	function() {
			return this.renderer;
		},
		
		setAxisPosition	:	function(axisPosition) {
			this.axisPosition = axisPosition;
		},
		
		getAxisPosition	:	function() {
			return this.axisPosition;
		}
	});
	
	
	
function SeriesCollection(js) {
	this.init(js);
}

SeriesCollection.prototype = {
	init		:		function(js) {
		js = js || {};
		
		this.seriesAttrMap =  js.seriesAttrMap == undefined ? new HashMap() : new HashMap(js.seriesAttrMap);
		
		if(js.defaultSeriesAttr == undefined) {
			this.defaultSeriesAttr = new SeriesAttr();
		} else {
			if(js.defaultSeriesAttr.seriesAttrType != undefined) {
				if(js.defaultSeriesAttr.seriesAttrType == "CustomAttr") {
					this.defaultSeriesAttr = new CustomAttr(js.defaultSeriesAttr);
				} else {
					this.defaultSeriesAttr = new SeriesAttr(js.defaultSeriesAttr);
				}
			}
		}
	},
	
	setSeriesAttrMap	:		function(map) {
		this.seriesAttrMap = map;
	},
	
	getSeriesAttrMap	:		function() {
		return this.seriesAttrMap;
	},
	
	putSeriesAttr 		:		function(index, seriesAttr) {
		this.getSeriesAttrMap().put(index, seriesAttr);
	},
	
	getSeriesAttr 		:		function(index) {
		if(this.getSeriesAttrMap().containsKey(index)) {
			return this.getSeriesAttrMap().get(index);
		}
		return this.defaultSeriesAttr;
	},
	
	getDefaultSeriesAttr	:		function() {
		return this.defaultSeriesAttr;
	},
	
	setDefaultSeriesAttr	:		function(seriesAttr) {
		this.defaultSeriesAttr	= seriesAttr;
	},
	
	getSeriesCondition		:		function(conditionInstance, index) {
		var seriesCondition = this.getSeriesAttr(index).isContains(conditionInstance);
    	if(seriesCondition == null) {
    		seriesCondition = this.getDefaultSeriesAttr().isContains(conditionInstance);
    		if(seriesCondition == null) {
    			// kunsnat: ĬϵȡضColor Background..
    			if(conditionInstance instanceof SeriesAttrColor) {
    				var seriesColor = new SeriesAttrColor();
    				seriesColor.seriesColor = ChartCoreConstants.prototype.CHART_COLOR_ARRAY[index];
    				seriesCondition = seriesColor;
    			} else if(conditionInstance instanceof SeriesAttrBackground) {
    				var seriesBackground = new SeriesAttrBackground();
    				var colorBackground = ColorBackground.getInstance(ChartCoreConstants.prototype.CHART_COLOR_ARRAY[index]);
    				colorBackground.isSimulation3D = true;
    				seriesBackground.seriesBackground = colorBackground;
    				seriesCondition = seriesBackground;
    			} else if(conditionInstance instanceof SeriesAttrLine) {
    				var seriesLine = new SeriesAttrLine();
    				seriesLine.seriesLineColor = ChartCoreConstants.prototype.CHART_COLOR_ARRAY[index];
    				seriesLine.seriesLineStyle = Constants.prototype.LINE_THIN;
    				seriesCondition = seriesLine;
    			} else if(conditionInstance instanceof SeriesAttrMarkerType) {
    				var markerType = new SeriesAttrMarkerType();
    				markerType.markerTypeIndex = index;
    				seriesCondition = markerType;
    			} 
    			else {
    				return conditionInstance;
    			}
    		}
    	}
    	return seriesCondition;
	}
}


	function Axis(js) {
	 	this.initConstants(js);
	}
	
	Axis.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.tickMarkType = js.tickMarkType == undefined ? Constants.prototype.TICK_MARK_OUTSIDE : js.tickMarkType;
			this.tickLength = js.tickLength == undefined ? 8 : js.tickLength;
			this.secTickMarkType = js.secTickMarkType == undefined ? Constants.prototype.TICK_MARK_INSIDE : js.secTickMarkType;
			this.secTickLength = js.secTickLength == undefined ? 0 : js.secTickLength;
			
			this.mainStroke = js.mainStroke == undefined ? 1.0 : js.mainStroke;
			this.secStroke = js.secStroke == undefined ? 1.0 : js.secStroke;
			
			//this.title = js.title == undefined ? null : new Title(js.title); 
			this.position = js.position == undefined ? Constants.prototype.BOTTOM : js.position;
			
			this.mainGridStyle = js.mainGridStyle == undefined ? Constants.prototype.LINE_NONE : js.mainGridStyle;
			this.mainGridColor = js.mainGridColor == undefined ? null : js.mainGridColor;
			
			this.secondGridStyle = js.secondGridStyle == undefined ? Constants.prototype.LINE_NONE : js.secondGridStyle;
			this.secondGridColor = js.secondGridColor == undefined ? null : js.secondGridColor;
			
			this.lineColor = js.lineColor == undefined ? null : js.lineColor;
			this.lineStyle = js.lineStyle == undefined ? Constants.prototype.LINE_THIN : js.lineStyle;
			
			this.textAttr = js.textAttr == undefined ? null : new TextAttr(js.textAttr);
			this.format = js.format == undefined ? null : js.format;

			this.isStagger = js.isStagger == undefined ? false : js.isStagger;
			this.labelNumber = js.labelNumber == undefined ? -1 : js.labelNumber;
			this.axisLabelPosition = js.axisLabelPosition == undefined ? Constants.prototype.LABEL_AROUND : js.axisLabelPosition;
		},
	
		LINE_LABEL_GAP	:	4,	
		LABEL_TITLE_GAP	:	1,
		
		getTickMarkType		:		function() {
			return this.tickMarkType;
		},
		
		setTickMarkType		:		function(tickMarkType) {
			this.tickMarkType = tickMarkType;
		},
		
		getTickLength		:		function() {
			return this.tickLength;
		},
		
		setTickLength		:		function(tickLength) {
			this.tickLength = tickLength;
		},
		
		getSecTickMarkType	:		function() {
			return this.secTickMarkType;
		},
		
		setSecTickMarkType	:		function(secTickMarkType) {
			this.secTickMarkType = secTickMarkType;
		},
		
		getSecTickLength	:		function() {
			return this.secTickLength;
		},
		
		setSecTickLength	:		function(secTickLength) {
			this.secTickLength = secTickLength;
		},
		
		getMainStroke		:		function() {
			return this.mainStroke;
		},
		
		setMainStroke		:		function(mainStroke) {
			this.mainStroke = mainStroke;
		},
		
		getSecStroke		:		function() {
			return this.secStroke;
		},
		
		setSecStroke		:		function(secStroke) {
			this.secStroke = secStroke;
		},
		
		getPosition			:		function() {
			return this.position;
		},	
		
		setPosition			:		function(position) {
			this.position = position;
		},
		
		getTitle			:		function() {
			return this.title;
		},	
		
		setTitle			:		function(title) {
			this.title = title;
		},
		
		getMainGridStyle	:		function() {
			return this.mainGridStyle;
		},
		
		setMainGridStyle	:		function(mainGridStyle) {
			this.mainGridStyle = mainGridStyle;
		},	
		
		getMainGridColor	:		function() {
			return this.mainGridColor;
		},
		
		setMainGridColor	:		function(mainGridColor) {
			this.mainGridColor = mainGridColor;
		},
		
		getSecondGridStyle	:		function() {
			return this.secondGridStyle;
		},
		
		setSecondGridStyle	:		function(secondGridStyle) {
			this.secondGridStyle = secondGridStyle;
		},
		
		getSecondGridColor	:		function() {
			return this.secondGridColor;
		},	
		
		setSecondGridColor	:		function(secondGridColor) {
			this.secondGridColor = secondGridColor;
		},
		
		getLineColor		:		function() {
			return this.lineColor;
		},
		
		setLineColor		:		function(lineColor) {
			this.lineColor = lineColor;
		},
		
		getLineStyle		:		function() {
			return this.lineStyle;
		},
		
		setLineStyle		:		function(lineStyle) {
			this.lineStyle = lineStyle;
		},
		
		getTextAttr			:		function() {
			return this.textAttr;
		},
		
		setTextAttr			:		function(textAttr) {
			this.textAttr = textAttr;
		},
		
		getFormat			:		function() {
			return this.format;
		},
		
		setFormat			:		function(format) {
			this.format = format;
		},
		
		getIsStagger		:		function() {
			return this.isStagger;
		},
		
		setStagger			:		function(isStagger) {
			this.isStagger = isStagger;
		},
		
		getLabelNumber		:		function() {
			return this.labelNumber;
		},
		
		setLabelNumber		:		function(labelNumber) {
			this.labelNumber = labelNumber;
		},
		
		getAxisLabelPosition	:	function() {
			return this.axisLabelPosition;
		},
		
		setAxisLabelPosition 	:	function(axisLabelPostion) {
			this.axisLabelPosition = axisLabelPosition;
		}
	}
	
	Axis.calculateIncrement	  =  	function(minValue, maxValue) {
		var increValue = 1;
	
        var tmpValue = 0.0;
        increValue = (maxValue - minValue) / 3.0;
        var mult = 1.0;

        if (increValue <= 1) {
            tmpValue = Math.pow(10.0, Math.ceil(Math.log(1.0 / increValue) / Math.log(10.0)));
            mult = 1.0 / tmpValue;
            increValue *= tmpValue;
        }

        if (increValue > 10) {
            tmpValue = Math.pow(10.0, Math.ceil(Math.log(increValue) / Math.log(10.0)) - 1.0);
            mult = tmpValue;
            increValue /= tmpValue;
        }

        if (increValue <= 2.0) {
            increValue = 1.0;
        } else if (increValue <= 4) {
            increValue = 2.0;
        } else if (increValue <= 5) {
            increValue = 4.0;
        } else if (increValue <= 10) {
            increValue = 4.0;
        }

        increValue *= mult;

        return increValue;
	}


function ValueAxis(js) {
	this.initConstants(js);
}	

FR.extend(ValueAxis, Axis, {
	initConstants	:	function(js) {
		js = js || {};
		
		this.position = js.position == undefined ? Constants.prototype.LEFT : js.position;
		
		this.customMinValue = js.customMinValue == undefined ? false : js.customMinValue;
		this.minValue = js.minValue == undefined ? 0 : js.minValue;
		this.customMaxValue = js.customMaxValue == undefined ? false : js.customMaxValue;
		this.maxValue = js.maxValue == undefined ? 0 : js.maxValue;
		
		this.customIncrement = js.customIncrement == undefined ? false : js.customIncrement;
		this.increment = js.increment == undefined ? 0 : js.increment;
		
		this.customCrossValue = js.customCrossValue == undefined ? false : js.customCrossValue;
		this.crossValue = js.crossValue == undefined ? 0 : js.crossValue;
		this.showUnit = js.showUnit == undefined ? null : js.showUnit;
		
		this.isLog = js.isLog == undefined ? false : js.isLog;
		this.isPercentage = js.isPercentage == undefined ? false : js.isPercentage;
		
		this.hasAlertValue = js.hasAlertValue == undefined ? false : js.hasAlertValue;
		this.startAlertValue = js.startAlertValue == undefined ? null : js.startAlertValue;
		this.endAlertValue = js.endAlertValue == undefined ? null : js.endAlertValue;
		
		ValueAxis.superclass.initConstants.apply(this, [js]);
	},
	
	isCustomMinValue		:		function() {
		return this.customMinvalue;
	},
	
	setCustomMinValue		:		function(isCustomMinValue) {
		this.customMinValue = isCustomMinValue;
	},
	
	getMinValue			:		function() {
		return this.minValue;
	},
	
	setMinValue			:		function(minValue) {
		this.minValue = minValue;
	},
	
	isCustomMaxValue		:		function() {
		return this.customMaxValue;
	},
	
	setCustomMaxValue		:		function(isCustomMaxValue) {
		this.customMaxValue = isCustomMaxValue;
	},
	
	setMaxValue 		:		function(maxValue) {
		this.maxValue = maxValue;
	},
	
	getMaxValue 		:		function() {
		return this.maxValue;
	},
	
	isCustomIncrement		:		function() {
		return this.customIncrement;
	},
	
	setCustomIncrement		:		function(isCustomIncrement) {
		this.customIncrement = isCustomIncrement;
	},
	
	isCustomCrossValue		:		function() {
		return this.customCrossValue;
	},
	
	setCustomCrossValue		:		function(customCrossValue) {
		this.customCrossValue = customCrossValue;
	},
	
	getCrossValue		:		function() {
		return this.crossValue;
	},
	
	setCrossValue		:		function(crossValue) {
		this.crossValue = crossValue;
	},
	
	getShowUnit		:		function() {
		return this.showUnit;
	},
	
	setShowUnit		:		function(showUnit) {
		this.showUnit = showUnit;
	},
	
	getIsLog		:		function() {
		return this.isLog;
	},
	
	setIsLog		:		function(isLog) {
		this.isLog = isLog;
	},
	
	getIsPercentage		:		function() {
		return this.isPercentage;
	},
	
	setPercentage		:		function(isPercentage) {
		this.isPercentage = isPercentage;
	},
	
	getHasAlertValue		:		function() {
		return this.hasAlertValue;
	},
	
	setHasAlertValue		:		function(hasAlertValue) {
		this.hasAlertValue = hasAlertValue;
	},
	
	getStartAlertValue		:		function() {
		return this.startAlertValue;
	},
	
	setStartAlertValue		:		function(startAlertValue) {
		this.startAlertValue = startAlertValue;
	},
	
	getEndAlertValue		:		function() {
		return this.endAlertValue;
	},
	
	setEndAlertValue		:		function(endAlertValue) {
		this.endAlertValue = endAlertValue;
	}
});

	function CategoryAxis(js) {
		this.initConstants(js);
	}
	
	FR.extend(CategoryAxis, Axis, {
		initConstants	:	function(js) {
			CategoryAxis.superclass.initConstants.apply(this, [js]);
		}
	});
	
	function	RadarAxis(js) {
		this.initConstants(js);
	}
	
	FR.extend(RadarAxis, Axis, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.tickMarkType = js.tickMarkType == undefined ? Constants.prototype.TICK_MARK_CROSS : js.tickMarkType;
			this.customMinValue = js.customMinValue == undefined ? false : js.customMinValue;
			this.minValue = js.minValue == undefined ? 0 : js.minValue;
			this.customMaxValue = js.customMaxValue == undefined ? false : js.customMaxValue;
			this.maxValue = js.maxValue == undefined ? 0 : js.maxValue;
			
			RadarAxis.superclass.initConstants.apply(this, [js]);
		},
		
		getTitle	:	function(){
			return null;
		},
		
		setTitle	:	function() {
			
		},
		
		setCustomMinValue	:	function(customMinValue) {
			this.customMinValue	= customMinValue;
		},
		
		isCustomMinValue	:	function() {
			return this.customMinValue;
		},
		
		setMinValue	:	function(minValue) {
			this.minValue = minValue;
		},
		
		getMinValue	:	function() {
			return this.minValue;
		},
		
		setCustomMaxValue	:	function(customMaxValue) {
			this.customMaxValue	= customMaxValue;
		},
		
		isCustomMaxValue	:	function() {
			return this.cutomMaxValue;
		},
		
		setMaxValue	:	function(maxValue) {
			this.maxValu = maxValue;
		},
		
		getMaxValue	:	function() {
			return this.maxValue;
		}
		
	})
	
	function AxisGlyph(js) {
		this.initConstants(js);
	}
	
	AxisGlyph.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.titleGlyph = js.titleGlyph == undefined ? null : new TextGlyph(js.titleGlyph);
			this.axisLabelWidth = js.axisLabelWidth == undefined ? 8 : js.axisLabelWidth;
			this.unitLength = js.unitLength == undefined ? 0 : js.unitLength;
			this.tickLength = js.tickLength == undefined ? 0 : js.tickLength;
			this.smallTickLength = js.smallTickLength == undefined ? 0 : js.smallTickLength;
			this.axisLength = js.axisLength == undefined ? 0 : js.axisLength;
			this.axisGridLength = js.axisGridLength == undefined ? 0 : js.axisGridLength;
			
			this.bounds = js.bounds == undefined ? null: null;
			this.originPoint = js.originPoint == undefined ? null : null;
		},
		
		/**
	     * kunsnat: labelWidth, plotBounds, ȻȥcalculateAxisGlyph
	     */
	    dealPlotBoundsWithAxisLabel		:	function(plotBounds) {
	    	var cateLabelWidth =  this.getMaxLabelWidth();
	    	if (cateLabelWidth > 0) {
	    		this.setAxisLabelWidth(cateLabelWidth);
	    	}
	    	
	    	var plotX = plotBounds.getX(), plotY = plotBounds.getY();
	    	var labelPosition = this.getAxis().getAxisLabelPosition();
	    	
	    	switch(this.getAxis().getPosition()) {
	    	case Constants.prototype.LEFT:
    			plotBounds.width = plotBounds.getWidth() - cateLabelWidth;
	    		if (labelPosition == Constants.prototype.LABEL_TOP) {
	    		} else {
	    			plotBounds.x = plotX + cateLabelWidth;
	    		}
	    		break;
	    	case Constants.prototype.BOTTOM:
	    		if (labelPosition == Constants.prototype.LABEL_TOP) {
	    			plotBounds.height = plotBounds.getHeight() - cateLabelWidth;
	    			plotBounds.y = plotY + cateLabelWidth;
	    		} else {
	    			plotBounds.height = plotBounds.getHeight() - cateLabelWidth;
	    		}
	    		break;
	    	case Constants.prototype.RIGHT:
	    		if (labelPosition == Constants.prototype.LABEL_BOTTOM){
	    			plotBounds.width = plotBounds.getWidth() - cateLabelWidth;
	    			plotBonds.x = plotX + cateLabelWidth;
	    		} else {
	    			plotBounds.width = plotBounds.getWidth() - cateLabelWidth;
	    		}
	    		break;
	    	default:
				if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
					plotBounds.height = plotBounds.getHeight() - cateLabelWidth;
	    		} else {
					plotBounds.height = plotBounds.getHeight() - cateLabelWidth;
					plotBounds.y = plotY + cateLabelWidth;
	    		}
				break;
	    	}
	    },
		
		calculateAxisGlyph		:		function(bounds) {
			this.init(bounds);
			this.calculateAxisLengthUnit();
		},
		
		init		:		function(plotBounds) {
			var axisZero = null;
			var axisLength, axisGridLength;
			var bounds = null;
		
			var labelPosition = this.getAxis().getAxisLabelPosition();
		
			switch(this.getAxis().getPosition()) {
			case Constants.prototype.LEFT:
				axisLength = plotBounds.getHeight();
				axisGridLength = plotBounds.getWidth();
				
				if (labelPosition == Constants.prototype.LABEL_TOP) {
					bounds = new Bounds(plotBounds.getWidth(), 0, this.axisLabelWidth, plotBounds.getHeight());
					// ӵǰboundsԭ ǨƵǰԭ
					axisZero = new Point2D( -plotBounds.getWidth(), plotBounds.getHeight());
				} else {
					bounds = new Bounds(-this.axisLabelWidth, 0, this.axisLabelWidth,plotBounds.getHeight());
					axisZero = new Point2D(this.axisLabelWidth, plotBounds.getHeight());
				}
				break;
			case Constants.prototype.BOTTOM:
				axisLength = plotBounds.getWidth();
				axisGridLength = plotBounds.getHeight();
				
				if (labelPosition == Constants.prototype.LABEL_TOP) {
					bounds = new Bounds(0, -this.axisLabelWidth, plotBounds.getWidth(),this.axisLabelWidth);
					axisZero = new Point2D(0, plotBounds.getHeight() + this.axisLabelWidth);
				} 
				else {
					bounds = new Bounds(0, plotBounds.getHeight(), plotBounds.getWidth(), this.axisLabelWidth);    					
					axisZero = new Point2D(0, 0);
				}
				break;
			case Constants.prototype.RIGHT:
				axisLength = plotBounds.getHeight();
				axisGridLength = plotBounds.getWidth();
				
				if (labelPosition == Constants.prototype.LABEL_BOTTOM){
					bounds = new Bounds(-this.axisLabelWidth, 0, this.axisLabelWidth, plotBounds.getHeight());
					axisZero = new Point2D(this.axisLabelWidth + plotBounds.getWidth(), plotBounds.getHeight());
				} else {
					bounds = new Bounds(plotBounds.getWidth(), 0, this.axisLabelWidth, plotBounds.getHeight());
					axisZero = new Point2D(0, plotBounds.getHeight());
				}
				break;
			default:
				axisLength = plotBounds.getWidth();
				axisGridLength = plotBounds.getHeight();
				
				if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
					bounds = new Bounds(0, plotBounds.getHeight(), plotBounds.getWidth(), this.axisLabelWidth);    					
					axisZero = new Point2D(0, -this.axisLabelWidth - plotBounds.getHeight());
				} else {
					bounds = new Bounds(0, -this.axisLabelWidth, plotBounds.getWidth(), this.axisLabelWidth);
					axisZero = new Point2D(0, this.axisLabelWidth);
				}
				break;
			}
		
			this.setBounds(bounds);
			this.setOrigin(axisZero);
			this.setAxisLength(axisLength);
			this.setAxisGridLength(axisGridLength);
		},
		
		getMaxLabelWidth		:		function() {
			var labelWidth = 8;
			if (this instanceof CategoryAxisGlyph) {
				var list = this.getCategoryLabelList();
				for (var i = 0; i < list.length; i++ ) {
					var tmpWidth = this.getAxisLabelWidth(this, list[i].toString());
					labelWidth  = (tmpWidth < labelWidth  ? labelWidth  : tmpWidth );
				}
		
			} else if (this instanceof ValueAxisGlyph) {
				var minValue = this.getMinValue();
				var maxValue = this.getMaxValue();
				var axis = this.getAxis();
				var increment = 1;
				if(axis.isCustomIncrement()) {
					increment = axis.getIncrement();
				} else {
					increment = Axis.calculateIncrement(minValue, maxValue);
				}
		
				for (var min = minValue; min < maxValue; min = min + increment) {
					var tmpWidth = this.getAxisLabelWidth(this, this.value2String(min));
					labelWidth  = (tmpWidth < labelWidth  ? labelWidth  : tmpWidth );
				}
			}
			
			if(this.getAxis().getIsStagger()) {
				labelWidth *= 1.5;
			}
			
			return labelWidth ;
		},
		
		getAxisLabelWidth		:		function(axisGlyph, label) {
			if(label == null) {
		    		return 0;
			}
			var textAttr = axisGlyph.getAxis().getTextAttr();
			if (textAttr == null) {
				textAttr = new TextAttr();
			}
			
			var dim = TextGlyph.calculateTextDimension(label, textAttr);
			if (axisGlyph.getAxis().getPosition() == Constants.prototype.TOP 
				|| axisGlyph.getAxis().getPosition() == Constants.prototype.BOTTOM) {
		
				// ŵʱ labelWidth ҲҪ仯.	 Ϸ·ʱ.
				if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
					return dim.getHeight() * (label.length + 0.2);
				}
				return dim.getHeight();
			} else {
				return dim.getWidth();
			}
		},
		
		getOrigin		:		function() {
			return this.originPoint;
		},
		
		setOrigin		:		function(zero) {
			this.originPoint = zero;
		},
		
		getAxisLength		:		function() {
			return this.axisLength;
		},
		
		setAxisLength 		:		function(len) {
			return this.axisLength = len;
		},
		
		getUnitLen		:		function() {
			return this.unitLength;
		},
		
		getUnit		:		function() {
			return this.tickLength;
		},
		
		getSmallunit		:		function() {
			return this.smallTickLength;
		},
		
		getAxisGridLength		:		function() {
			return this.axisGridLength;
		},
		
		setAxisGridLength		:		function(axisGridLength) {
			this.axisGridLength = axisGridLength;
		},	
		
		setTitleGlyph		:		function(titleGlyph) {
			this.titleGlyph = titleGlyph;
		},
		
		getTitleGlyph		:		function() {
			return this.titleGlyph;
		},
		
		getBounds		:		function() {
			return this.bounds;
		},
		
		setBounds		:		function(bounds) {
			this.bounds = bounds;
		},
		
		getPoint2D		:		function(value) {
			value = value - this.getCrossValue();
			
			if(this.originPoint == null) {
				return new Point2D(0,0);
			}
			
			if (this.getAxis().getPosition() == Constants.prototype.LEFT ) {    		
				return new Point2D(this.originPoint.getX(), this.originPoint.getY() - this.unitLength * value);
			} else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
				return new Point2D(this.originPoint.getX(), this.originPoint.getY() - this.unitLength * value);
			} else if (this.getAxis().getPosition() == Constants.prototype.TOP) {
				return new Point2D(this.originPoint.getX() + this.unitLength * value, this.originPoint.getY());
			} else {
				return new Point2D(this.originPoint.getX() + this.unitLength * value, this.originPoint.getY());
			}
		},
		
		getPoint2DForSelf		:		function(value) {
			var value = this.getPoint2D(value);
			return value;
		},
		
		getTickLine		:		function(value, tickLength, tickMarkType) {
			var centerP = this.getPoint2DForSelf(value);
			
			var leftP = new Point2D(centerP.getX() - tickLength / 2.0, centerP.getY());
			var rightP = new Point2D(centerP.getX() + tickLength / 2.0, centerP.getY());
			var topP = new Point2D(centerP.getX(), centerP.getY() - tickLength / 2.0);
			var bottomP = new Point2D(centerP.getX(), centerP.getY() + tickLength / 2.0);
			
			if (tickMarkType == Constants.prototype.TICK_MARK_CROSS) {
				if (this.getAxis().getPosition() == Constants.prototype.LEFT) {
					return new Line2D(leftP, rightP);
				} else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
					return new Line2D(leftP, rightP);
				} else if (this.getAxis().getPosition() == Constants.prototype.TOP) {
					return new Line2D(topP, bottomP);
				} else {
					return new Line2D(topP, bottomP);
				}
			} else if (tickMarkType == Constants.prototype.TICK_MARK_INSIDE){
				if (this.getAxis().getPosition() == Constants.prototype.LEFT) {
		    		return new Line2D(centerP, rightP);
				} else if (this.getAxis().getPosition() == Constants.prototype.TOP) {
					return new Line2D(centerP, bottomP);
				} else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
					return new Line2D(centerP, leftP);
				} else {
					return new Line2D(centerP, topP);
				}
			} else if (tickMarkType == Constants.prototype.TICK_MARK_OUTSIDE) {
				if (this.getAxis().getPosition() == Constants.prototype.LEFT) {
		    		return new Line2D(centerP, leftP);
				} else if (this.getAxis().getPosition() == Constants.prototype.TOP) {
					return new Line2D(centerP, topP);
				} else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
					return new Line2D(centerP, rightP);
				} else {
					return new Line2D(centerP, bottomP);
				}
			} else {
				return new Line2D(centerP, centerP);
			}
		},
		
		drawLabel		:		function(ctx,value,offset,str) {
			var centerP = this.getPoint2DForSelf(value + offset);
			var textAttr = this.getAxis().getTextAttr();
			
			if (textAttr == null) {
				textAttr = new TextAttr();
			}
			
			// СӰ.==> TODO õ һַ  Ϊַ
			var dim = TextGlyph.calculateTextDimension(str, textAttr);
			dim.width = ctx.measureText("" + str).width;
			
			var labelBounds = null;
			
			var unitStringWidth = dim.width / str.length;
			
			var position = this.getAxis().getPosition();
			var labelPosition = this.getAxis().getAxisLabelPosition();
			if (labelPosition == Constants.prototype.LABEL_NONE) {
				return;
			}
			// ʱ ʱ ߶.
			var tmpHeight = dim.height*(str.length + 0.2);
			
			// ַ һַʱ Ϊƫ PaintUtils
			var resetTmp = 0;
			if(str.length == 1) {
				// 15
				resetTmp = dim.height;
			}
			
			if (position == Constants.prototype.LEFT) {
				if(labelPosition == Constants.prototype.LABEL_BOTTOM || labelPosition == Constants.prototype.LABEL_AROUND) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT ) {
						labelBounds = new Bounds(
							centerP.getX() - Axis.prototype.LINE_LABEL_GAP - unitStringWidth - resetTmp, 
							centerP.getY() - tmpHeight / 2.0, 
							unitStringWidth, tmpHeight);
					} else {
						labelBounds = new Bounds(
						    //  һ̶ȵƫ
							centerP.getX() - Axis.prototype.LINE_LABEL_GAP - dim.getWidth() - this.getAxis().getTickLength(), 
							centerP.getY() - dim.height/2, dim.width, dim.height);
					}
				} else if (labelPosition == Constants.prototype.LABEL_TOP) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
							labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + this.getAxisGridLength() - resetTmp, 
									centerP.getY() - dim.getHeight() / 2, unitStringWidth, tmpHeight);
					} else {
							labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + this.getAxisGridLength(), 
									centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
					}
				}
			} else if (position == Constants.prototype.TOP) {
				if (labelPosition == Constants.prototype.LABEL_AROUND || labelPosition == Constants.prototype.LABEL_TOP) {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, centerP.getY() - dim.getHeight(), 
												dim.getWidth(), dim.getHeight());
				} else if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth(), centerP.getY() + this.getAxisGridLength(), 
												dim.getWidth(), dim.getHeight());
				}
			} else if (position == Constants.prototype.RIGHT) {
				if (labelPosition == Constants.prototype.LABEL_AROUND || labelPosition == Constants.prototype.LABEL_TOP) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP, 
												centerP.getY() - tmpHeight / 2, unitStringWidth, tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP, 
												centerP.getY() - dim.getHeight() / 2, 
												dim.getWidth(), dim.getHeight());
					}
				} else if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - this.getAxisGridLength() - unitStringWidth, 
												centerP.getY() - tmpHeight / 2, unitStringWidth, tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - this.getAxisGridLength() - dim.getWidth(), 
												centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
					}
				}
			} else {
				if (labelPosition == Constants.prototype.LABEL_AROUND || labelPosition == Constants.prototype.LABEL_BOTTOM) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						// ŵʱ ƿ ӳ߶. 
						labelBounds = new Bounds(centerP.getX() - unitStringWidth / 2.0, centerP.getY(), unitStringWidth, tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, centerP.getY(), 
												dim.getWidth(), dim.getHeight());
					}
				} else if (labelPosition == Constants.prototype.LABEL_TOP) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() - unitStringWidth / 2.0, 
												centerP.getY() - this.getAxisGridLength() - tmpHeight,
												unitStringWidth, tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, 
												centerP.getY() - this.getAxisGridLength() - dim.getHeight(), 
												dim.getWidth(), dim.getHeight());
					}
				}
			}
			TextGlyph.drawLabel(ctx, str, textAttr, labelBounds);
		},
		
		drawBGLabel		:		function(ctx, value, offset, str, labelNumber) {
			var centerP = this.getPoint2DForSelf(value + offset);
			var textAttr = this.getAxis().getTextAttr();
			if (textAttr == null) {
				textAttr = new TextAttr();
			}
			
			var dim = TextGlyph.calculateTextDimension(str, textAttr);
			// Ϊֶֺǰ5. Ҫȷ.
			var width  = ctx.measureText(str).width;
			dim.setWidth(width);
			 
			var labelBounds = null;
			
			var test = str;
			var unitStringWidth = dim.getWidth() / str.length;
			
			var position = this.getAxis().getPosition();
			var labelPosition = this.getAxis().getAxisLabelPosition();
			if (labelPosition == Constants.prototype.LABEL_NONE) {
				return;
			}
			// ʾ
			var bgStagger = (labelNumber % 2 == 0);
			// Ϊtrueʱ ʾ. λƶ.
			// falseʱ Ϊ.
			if(!bgStagger) {
				this.drawLabel(ctx, value, offset, str);
				return;
			}
			
			// ʱ ַĸ߶ ʱ
			var dim_tmpHeight = dim.getHeight() * (str.length + 0.2);
			
			if (position == Constants.prototype.LEFT) {
					if(labelPosition == Constants.prototype.LABEL_BOTTOM || labelPosition == Constants.prototype.LABEL_AROUND) {
						if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
							labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - 2 * unitStringWidth, centerP.getY() - dim.getHeight() / 2, unitStringWidth, dim_tmpHeight);
						} else {// this.axisLabelWidth ʹַͳһСĻ, ҲԶ߿ʼ.
							labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - this.axisLabelWidth, centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
						}
					} else if (labelPosition == Constants.prototype.LABEL_TOP) {
						if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
							labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + this.getAxisGridLength() + 2 * unitStringWidth , centerP.getY() - dim.getHeight() / 2, unitStringWidth, dim_tmpHeight);
						} else {
							labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + this.getAxisGridLength() + 0.5 * dim.getWidth(), centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
						}
					}
			} else if (position == Constants.prototype.TOP) {
				// ڻûоϵ
			} else if (position == Constants.prototype.RIGHT) {
				if (labelPosition == Constants.prototype.LABEL_AROUND || labelPosition == Constants.prototype.LABEL_TOP) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) { 
						labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + 0.5 * unitStringWidth, centerP.getY() - dim_tmpHeight / 2, unitStringWidth, dim_tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() + Axis.prototype.LINE_LABEL_GAP + 0.5 * dim.getWidth(), centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
					}
				} else if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - this.getAxisGridLength() - 2 * unitStringWidth, centerP.getY() - dim_tmpHeight / 2, unitStringWidth, dim_tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() - Axis.prototype.LINE_LABEL_GAP - this.getAxisGridLength() - dim.getWidth() * 1.5, centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
					}
				}
			} else {
				if (labelPosition == Constants.prototype.LABEL_AROUND || labelPosition == Constants.prototype.LABEL_BOTTOM) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() - unitStringWidth / 2.0, centerP.getY() + 0.5 * dim_tmpHeight + 14, unitStringWidth, dim_tmpHeight);
					} else {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, centerP.getY() + 0.5 * dim.getHeight() + 14, dim.getWidth(), dim.getHeight());
					}
				} else if (labelPosition == Constants.prototype.LABEL_TOP) {
					if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
						labelBounds = new Bounds(centerP.getX() - unitStringWidth / 2.0, centerP.getY() - this.getAxisGridLength() - dim_tmpHeight * 1.5 - Axis.prototype.LINE_LABEL_GAP - 14, unitStringWidth, dim_tmpHeight);
					} {
						labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, centerP.getY() - this.getAxisGridLength() - dim_tmpHeight * 1.5 - Axis.prototype.LINE_LABEL_GAP - 14, dim.getHeight(), dim_tmpHeight);
					}
				}
			}
			TextGlyph.drawLabel(ctx, str, textAttr, labelBounds);
		},
		
		drawTickLine		:		function(ctx, line, basicStroke) {
			var width = ctx.lineWidth;
			
			ctx.lineWidth = basicStroke;
			GraphHelper.drawLine(ctx,line);
			
			ctx.lineWidth = width;
		},
		
		draw		:		function(ctx) {
		    ctx.translate(this.getBounds().getX(), this.getBounds().getY());//ƽ
		        
			this.drawAxisGrid(ctx);
		    	
		   	this.drawAxisLine(ctx);
		    	
		   	this.drawAxisTitle(ctx);
		    	
		  	ctx.translate(-this.getBounds().getX(), -this.getBounds().getY());//ƽ
		},
		
		getShape		:		function() {
			return this.getBounds();
		},
		
		setAxisLabelWidth		:		function(labelWidth) {
			this.axisLabelWidth = labelWidth;
		},
		
//		getAxisLabelWidth		:		function() {
//			return this.axisLabelWidth;
//		},
		
		calculatorTitleBounds	:		function(titleGlyph) {
			var textAttr = titleGlyph.getTextAttr();
			var str = titleGlyph.getText();
			var dim = TextGlyph.calculateTextDimension(str, textAttr);
			// λ
			var titleBounds = null;
			//  ʱĸ߶.
				var tmpH = dim.getHeight()*(str.length + 0.2);
			if (this.getAxis().getPosition() == Constants.prototype.TOP) {
				// Nothing ʱû .
			} 
			else if (this.getAxis().getPosition() == Constants.prototype.LEFT ) {
				if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						// ŵʱ-16һַĿ Ȼ+4 .  ǩĿ+Ŀ
					titleBounds = new Bounds(-this.getMaxLabelWidth()- textAttr.frFont.size, (this.axisLength - tmpH)/2.0, dim.getHeight(),tmpH);
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds(this.axisLabelWidth + 4, (this.axisLength - tmpH)/2.0, dim.getHeight(), tmpH);
					}
				} else {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						titleBounds = new Bounds(-dim.getWidth() - 4, (this.axisLength - dim.getHeight())/2.0 , dim.getWidth(), dim.getHeight()); 
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds(this.axisLabelWidth + 4, (this.axisLength - dim.getHeight())/2.0 , dim.getWidth(), dim.getHeight()); 
					}
				}
			} 
			else if (this.getAxis().getPosition() == Constants.prototype.BOTTOM ) {
				if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						titleBounds = new Bounds(this.axisLength / 2, this.axisLabelWidth, dim.getHeight(), tmpH); 
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds(this.axisLength / 2, -tmpH, dim.getHeight(), tmpH); 
					}
				} else {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						titleBounds = new Bounds( (this.axisLength- dim.getWidth()) / 2, this.axisLabelWidth, dim.getWidth(), dim.getHeight()); 
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds( (this.axisLength - dim.getWidth()) / 2, -dim.getHeight()-4, dim.getWidth(), dim.getHeight()); 
					}
				}
			} 
			else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
				if(textAttr.getAlignText() == Style.prototype.VERTICALTEXT) {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds(this.axisLabelWidth + 4, (this.axisLength - tmpH) / 2, dim.getHeight(), tmpH);
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						titleBounds = new Bounds(-this.axisLabelWidth - 4, (this.axisLength - tmpH) / 2, dim.getHeight(), tmpH);
					}
				} else {
					if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_AROUND 
							|| this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_TOP) {
						titleBounds = new Bounds(this.axisLabelWidth, (this.axisLength - dim.getHeight()) / 2, dim.getWidth(), dim.getHeight()); 
					} else if(this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_BOTTOM) {
						titleBounds = new Bounds(-this.axisLabelWidth - dim.getWidth(), (this.axisLength - dim.getHeight()) / 2, dim.getWidth(), dim.getHeight()); 
					}
				}
			}
			return titleBounds;
		}
	}
	
	function CategoryAxisGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(CategoryAxisGlyph, AxisGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.categoryLabelList = new Array();
			if(js.categoryLabelList != undefined && js.categoryLabelList.length > 0 ) {
				for(var i = 0; i < js.categoryLabelList.length; i++) {
					this.categoryLabelList.push(js.categoryLabelList[i]);
				}
			}
			this.categoryAxis = js.categoryAxis == undefined ? null : new CategoryAxis(js.categoryAxis);
			
			CategoryAxisGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		calculateAxisLengthUnit		:		function() {
			this.unitLength = (this.axisLength) / this.getCategoryCount();
			this.tickLength = 1;
			this.smallTickLength = this.tickLength / 5;
		
		},
		
		getCategoryCount			:		function() {
			return this.categoryLabelList.length;
		},
		
		getAxis				:		function() {
			return this.categoryAxis;
		},
		
		setAxis				:		function(categoryAxis) {
			this.categoryAxis = categoryAxis;
		},
		
		addCategoryLabel	:		function(label) {
			this.categoryLabelList.push(label);
		},
		
		getCategoryLabelList		:		function() {
			return this.categoryLabelList;
		},
		
		setCategoryLabelList		:		function(labelList) {
			this.categoryLabelList = labelList;
		},
		
		drawAxisGrid			:		function(ctx) {
			// Ȼߣ
			ctx.save();
    		if (this.getAxis().getSecondGridStyle() != Constants.prototype.LINE_NONE && this.smallTickLength > 0) {
				ctx.strokeStyle = this.getAxis().getSecondGridColor();
	    		
	        	for (var value = this.smallTickLength; value <= this.getCategoryCount(); value += this.smallTickLength) {
	        		var lines = this.getGridLine(value);
	        		for (var i = 0; i < lines.length; i ++) {
	        			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getSecondGridStyle());
	        		}
	        	}
	    	}
	    	
	    	if (this.getAxis().getMainGridStyle() != Constants.prototype.LINE_NONE && this.tickLength > 0) {
				ctx.strokeStyle = this.getAxis().getMainGridColor();
	    		
	        	for (var value = this.tickLength; value <= this.getCategoryCount(); value += this.tickLength) {
	        		var lines = this.getGridLine(value);
	        		for (var i = 0; i < lines.length; i ++) {
	        			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getMainGridStyle());
	        		}
	        	}
	    	}
        	ctx.restore();
		},
		
		drawAxisLine		:		function(ctx) {
			// ûбǩʱ򲻻
			if(this.getCategoryCount() == 0) {
				return;
			}
			
			ctx.save();
		
			var line = new Line2D(this.getPoint2DForSelf(0),this.getPoint2DForSelf(this.getCategoryCount()));
		
			var lineColor = this.getAxis().getLineColor();
			var lineStyle = this.getAxis().getLineStyle();
			if(lineColor != null && lineStyle != Constants.prototype.LINE_NONE) {
				ctx.strokeStyle = lineColor;
				GraphHelper.drawLine(ctx,line, lineStyle);
			}
			
			this.drawTicks(ctx);
		
			ctx.restore();
		},
		
		drawTicks			:		function(ctx) {
			var tickValue = this.getCategoryCount();
			var mainStroke = this.getAxis().getMainStroke();
			var secStroke = this.getAxis().getSecStroke();
		
			for(var value = 0; value < tickValue;value += this.tickLength) {
			 	// ̶
	    		var line = this.getTickLine(value, this.categoryAxis.getTickLength(), this.categoryAxis.getTickMarkType());
	    		if (this.categoryAxis.getTickLength() == 0 || this.categoryAxis.getMainStroke() == 0) {
		    		continue;
				}
		    	this.drawTickLine(ctx, line, mainStroke);
		    }
		    	
	    	for(var value = 0; value <= tickValue; value += this.smallTickLength) {
	    		// ̶ֵͬ
	    		if ((value - 0) / this.smallTickLength == 5 ) {
	    			continue;
	    		}
				// Ҫ̶
	    		var line = this.getTickLine(value, this.categoryAxis.getSecTickLength(), this.categoryAxis.getSecTickMarkType());
	    		if (this.categoryAxis.getSecTickLength() == 0 || this.categoryAxis.getSecStroke() == 0) {
	    			continue;
				}
	    		this.drawTickLine(ctx, line, secStroke);
	    	}
	    	
	    	// жǷתΪnumber е
	    	var isToNumber = true;
	    	for (var i = 0; i < this.categoryLabelList.length; i ++) {
			    // ڲַ ֲǵʱ   ֤ͬĸʽ ѭ
			    for (var p = 0; p < this.categoryLabelList[i].toString().length; p ++ ) {
			    	if (isNaN(this.categoryLabelList[i].toString().charAt(p))){
			    		isToNumber = false;    
			    		break;
			    	} 
			    }
			    
			    if(!isToNumber) {
			    	break;
			    }
	    	}
	    	
	    	var number = 0;
	    	// ǩ
	    	var labelNumber = this.getAxis().getLabelNumber();
	    	for (var value = 0; value < this.categoryLabelList.length; value++ ) {
	    		// -1Ĭ ʾ
	    		if (!(labelNumber == -1)) {
	    			if (labelNumber <= number) {
	    				// .
	    				continue;
	    			} 
	    		}
	    		
		    	// ݸʽ
		    	var format = this.getAxis().getFormat();
	    		if (format != null) {
	    		    if(isToNumber) {
	    		    	var labelString = FR.contentFormat(this.categoryLabelList[value], format);
	    		    	if(this.getAxis().getIsStagger()) {
	    		    		this.drawBGLabel(ctx, value, 0.5, labelString, number);
	    		    	} else {
	    		    		this.drawLabel(ctx, value, labelString);
	    		    	}
	    		    } else {
	    		    	// kunsnat: dateתֻ֧(2010-06-02 && 06/23/2010)
	    		    	var categoryLabel = this.categoryLabelList[value].toString();
	    		    	categoryLabel = categoryLabel.replace(/-/g, "/");
	    		    	var date = new Date(categoryLabel);
	    		    	// IEFFĲ, ദ, ж
	    		    	var labelString;
	    		    	if(isNaN(date)) {
	    		    		labelString = FR.contentFormat(categoryLabel, format);
	    		    	} else {
		    		    	labelString = FR.contentFormat(date, format);
	    		    	}
	    		    	if(this.getAxis().getIsStagger()) {
	    		    		this.drawBGLabel(ctx, value, 0.5, labelString, number);
	    		    	} else {
	    		    		this.drawLabel(ctx, value, labelString);
	    		    	}
	    		    }
	    		} else {
	    			if(this.getAxis().getIsStagger()) {
	    				this.drawBGLabel(ctx, value, 0.5, this.categoryLabelList[value].toString(), number);
	    			} else {
	    				this.drawLabel(ctx, value, this.categoryLabelList[value].toString());
	    			}
	    		}
	    		number++;
	    	}
		},
		
		getGridLine			:		function(value) {
			var centerP = this.getPoint2DForSelf(value);
		        
	        var line;
	        
	        if(this.getAxis().getPosition() == Constants.prototype.LEFT ){
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY()), new Point2D(centerP.getX() + this.getAxisGridLength() , centerP.getY()));
	        } else if(this.getAxis().getPosition() == Constants.prototype.RIGHT){
	        	line = new Line2D(new Point2D(centerP.getX() - this.getAxisGridLength()), new Point2D(centerP.getY(), centerP.getX(), centerP.getY()));
	        } else if(this.getAxis().getPosition() == Constants.prototype.TOP){
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY() + this.getAxisGridLength()), new Point2D(centerP.getX(), centerP.getY()));
	        } else {
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY() - this.getAxisGridLength()), new Point2D(centerP.getX(), centerP.getY()));
	        }
	        
	        return new Array(line);
		},
		
		getCrossValue		:		function() {
			return 0;
		},
		
		drawLabel			:		function(ctx,value,str) {
			CategoryAxisGlyph.superclass.drawLabel.apply(this,[ctx,value,0.5,str]);
		},
		
		drawAxisTitle		: 		function(ctx) {
			var titleGlyph = this.getTitleGlyph();
			if(titleGlyph != null) {
				var chartBounds = this.calculatorTitleBounds(titleGlyph);
				titleGlyph.setBounds(chartBounds);
				titleGlyph.draw(ctx);
			}
		}
		
	});
	
	function ValueAxisGlyph(js){
		this.initConstants(js);
	}
	
	FR.extend(ValueAxisGlyph, AxisGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.minValue = js.minValue == undefined ? 0 : js.minValue;
			this.maxValue = js.maxValue == undefined ? 0 : js.maxValue;
			this.valueAxis = js.valueAxis == undefined ? null : new ValueAxis(js.valueAxis);
			
			ValueAxisGlyph.superclass.initConstants.apply(this, [js]);
		},

		calculateAxisLengthUnit		:		function() {
			if(this.valueAxis.getIsLog()) {
				if (this.valueAxis.isCustomIncrement()) {
					// Զǩ
					this.tickLength = this.getValueAxis().getIncrement();
				} else {
					this.tickLength = 10; //̶
				}
				//С̶
				this.smallTickLength = this.tickLength / 5;  
			
				this.unitLength = this.axisLength / (Math.log(this.maxValue) / Math.log(this.tickLength) - 
					Math.log(minVale) / Math.log(this.tickLength));
			} else if (this.maxValue - this.minValue > 0){	
				this.unitLength = this.axisLength / (this.maxValue - this.minValue);
			
				if (this.valueAxis.isCustomIncrement()) {
				this.tickLength = this.getValueAxis().getIncrement();
					if(this.valueAxis.isPercentage()) {
					this.tickLength = this.tickLength / 100.0;
				}
			} else {
				this.tickLength = Axis.calculateIncrement(this.minValue, this.maxValue); //̶
			}
			this.smallTickLength = this.tickLength / 5; 
			}
	
		},
		
		initMinMaxValue		:		function(autoMin, autoMax) {
			if(this.valueAxis.getIsPercentage()) {
				if (this.valueAxis.isCustomMinValue()) {
		    		this.minValue = this.valueAxis.getMinValue() / 100.0;
		    	} else {
		    		this.minValue = 0;
		    	}
		    	if (this.valueAxis.isCustomMaxValue()) {
		    		this.maxValue = this.valueAxis.getMaxValue() / 100.0;
		    	} else {
		    		this.maxValue = 1;
		    	}
			} else {
				if (this.valueAxis.isCustomMinValue()) {
					this.minValue = this.valueAxis.getMinValue();
				} else {
					this.minValue = autoMin;
				}
				
				if (this.valueAxis.isCustomMaxValue()) {
					this.maxValue = this.valueAxis.getMaxValue();
				} else {
					this.maxValue = autoMax;
				}
			}
			
			// ߴ ԶСֵ  ݼԶȡֵautoMax.
			if (this.minValue > this.maxValue) {
				this.maxValue = this.minValue * 1.1;
			}
			
			if (this.valueAxis.getIsLog()) {
				this.minValue = Math.max(1, this.minValue);
			}
		},
		
			
		getAxis			:		function() {
			return this.valueAxis;
		},
		
		setAxis			:		function(axis) {
			this.valueAxis = axis;
		},
		
		getMinValue		:		function() {
			return this.minValue;
		},
		
		setMinValue		:		function(minValue) {
			this.minValue = minValue;
		},
		
		getMaxValue		: 		function() {
			return this.maxValue;
		},
		
		setMaxValue		:		function(maxValue) {
			this.maxValue = maxValue;
		},
		
		getCrossValue	:		function() {
			if(this.valueAxis.isCustomCrossValue()) {
				return this.valueAxis.getCrossValue();
			} else {
				return this.minValue;
			}
		},
		
		value2String 	:		function(value) {
			var format = this.getAxis().getFormat();
			var string;
			if(format != null) {
				// write.jsеformat
				string = FR.contentFormat(value, format);
			} else {
				string = value.toString();
				// kunsnat: 0, Ϊʽʱdouble, jsʡ0, 20.0--> 20 Ҫȥ
				if(string.indexOf(".") == -1) {
					string = new Number(value).toFixed(1).toString();
				}
			}
			return string;
		},
		
		getPoint2D		: 		function(value) {
			// ָ
			if (this.valueAxis.getIsLog() && this.getCrossValue() > 0) {
				if (value <= 1e-10) {
					value = this.getCrossValue();
				}
				value = (Math.log(value) - Math.log(this.getCrossValue())) / Math.log(this.tickLength);
			}
			// default
			else {
				value = value - this.getCrossValue();
			}
			if(this.originPoint == null) {
				return new Point2D(0,0);
			}
		
			if (this.getAxis().getPosition()== Constants.prototype.LEFT 
		     			|| this.getAxis().getPosition()==Constants.prototype.RIGHT) {    		
				return new Point2D(this.originPoint.getX(), this.originPoint.getY() - this.unitLength * value);
			} else {
				return new Point2D(this.originPoint.getX() + this.unitLength * value, this.originPoint.getY());
			}
		},
		
		drawAxisGrid	:		function(ctx) {
			// Ȼߣ
			ctx.save();
			if (this.getAxis().getSecondGridStyle() != Constants.prototype.LINE_NONE && this.smallTickLength > 0) {
				
				// ߵɫ
				ctx.strokeStyle = this.getAxis().getSecondGridColor();
				
				if (this.valueAxis.getIsLog()) {
					if(this.smallTickLength > 1.0) {
		    			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.smallTickLength); value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.smallTickLength))) {
		    				// ̶ֵͬ
		    				if ((value - this.getCrossValue()) / this.smallTickLength == 5) {
		    					continue;
		    				}
		    				var lines = this.getGridLine(value);
		            		for (var j = 0; j < lines.length; j ++) {
		            			GraphHelper.drawLine(ctx, lines[j], this.getAxis().getSecondGridStyle());
		            		}
		    			}
		    		}
				} else {
					for (var value = this.minValue + this.smallTickLength; value <= this.maxValue; value += this.smallTickLength) {
						var lines = this.getGridLine(value);
		        		for (var i = 0; i < lines.length; i ++) {
		        			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getSecondGridStyle());
		        		}
		        	}
				}
			}
			
			// .
			if (this.getAxis().getMainGridStyle() != Constants.prototype.LINE_NONE && this.tickLength > 0) {
				// kunsnat: пܴߵ.
				ctx.strokeStyle = this.getAxis().getMainGridColor();
				
				if (this.valueAxis.getIsLog()) {
					if(this.tickLength > 1.0) {
						for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.tickLength); value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.tickLength))) {
							var lines = this.getGridLine(value);
							for (var k = 0; k < lines.length; k ++) {
								GraphHelper.drawLine(ctx, lines[k], this.getAxis().getMainGridStyle());
							}
						}
					}
				} else {
					for (var value = this.minValue + this.tickLength; value <= this.maxValue; value += this.tickLength) {
						var lines = this.getGridLine(value);
		        		for (var i = 0; i < lines.length; i ++) {
		        			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getMainGridStyle());
		        		}
		        	}
				}
			}
	    	ctx.restore();
			
			if (this.valueAxis.getHasAlertValue()) {
				ctx.save();
				
				ctx.lineWidth = 1;
				ctx.strokeStyle = 'red';
		
				if(!(this.valueAxis.getStartAlertValue() instanceof Formula)) {
					var startString = this.valueAxis.getStartAlertValue().toString();
					if(Utils.string2Number(startString) != null) {
						var lineValue = Utils.string2Number(startString).doubleValue();
						if(lineValue <= this.getMaxValue() && lineValue >= this.getMinValue()) {
							var lines = this.getGridLine(lineValue);
							for (var i = 0; i < lines.length; i ++) {
								GraphHelper.drawLine(ctx, lines[i]);
							}
						}
					}
				} else {
					var lines = this.getGridLine((this.maxValue - this.minValue)/4.0);
					for (var i = 0; i < lines.length; i ++) {
						GraphHelper.drawLine(ctx, lines[i]);
					}
				}
				if(!(this.valueAxis.getEndAlertValue() instanceof Formula)) {
					var endString = this.valueAxis.getEndAlertValue().toString();
					if(Utils.string2Number(endString) != null) {
						var lineValue = Utils.string2Number(endString).doubleValue();
						if(lineValue <= this.getMaxValue() && lineValue >= this.getMinValue()) {
							var lines = this.getGridLine(lineValue);
							for (var i = 0; i < lines.length; i ++) {
								GraphHelper.drawLine(ctx, lines[i]);
							}
						}
					}
				} else {
					// Ԥ֮ǰҪֵʾµ. Ȼ. ڽûӦ.
					var lines = this.getGridLine(3 * (this.maxValue - this.minValue)/4.0);
					for (var i = 0; i < lines.length; i ++) {
						GraphHelper.drawLine(ctx, lines[i]);
					}
				}
		    	ctx.restore();
			}
		},
	
		getGridLine		:		function(value) {
		 	var centerP = this.getPoint2DForSelf(value);
	        
	        var line;
	        if(this.getAxis().getPosition() == Constants.prototype.LEFT ){
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY()), 
	        		new Point2D(centerP.getX() + this.getAxisGridLength() , centerP.getY()));
	        } else if(this.getAxis().getPosition() == Constants.prototype.RIGHT){
	        	line = new Line2D(new Point2D(centerP.getX() - this.getAxisGridLength(), centerP.getY()), 
	        		new Point2D(centerP.getX(), centerP.getY()));
	        } else if(this.getAxis().getPosition() == Constants.prototype.TOP){
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY() + this.getAxisGridLength()), 
	        		new Point2D(centerP.getX(), centerP.getY()));
	        } else {
	        	line = new Line2D(new Point2D(centerP.getX(), centerP.getY() - this.getAxisGridLength()), 
	        		new Point2D(centerP.getX(), centerP.getY()));
	        }
	        
	        return new Array(line);
		},
		
		 /**
	     * ᱾  ̶..
	     * =.=
	     */
	    drawAxisLine		:		function(ctx){
	    	ctx.save();
			
			if(this.minValue == this.maxValue) {
				return;
			}
	    	
	    	var line = new Line2D(this.getPoint2DForSelf(this.minValue), this.getPoint2DForSelf(this.maxValue));
	    	
	    	var lineColor = this.getAxis().getLineColor();
			var lineStyle = this.getAxis().getLineStyle();
			if(lineColor != null && lineStyle != Constants.prototype.LINE_NONE) {
				ctx.strokeStyle = lineColor;
				GraphHelper.drawLine(ctx,line, lineStyle);
			}
			
	    	this.drawTicks(ctx);
	    	
	    	ctx.restore();
	    },
	    
	    drawAxisTitle		:		function(ctx) {
	    	var titleGlyph = this.getTitleGlyph();
	    	if (titleGlyph != null) {
	    		// ºʵı߽
	    		var chartBounds = this.calculatorTitleBounds(titleGlyph);
	    		titleGlyph.setBounds(chartBounds);
	    		titleGlyph.draw(ctx);
	    	}
	    },
	    
	    drawTicks		:		function(ctx) {
	    	var mainStroke = this.valueAxis.getMainStroke();
	    	var secStroke = this.valueAxis.getSecStroke();
	    	
	    	if (this.valueAxis.getIsLog()) {
	    		if(this.tickLength > 1.0) {
	    			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.tickLength); value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.tickLength))) {
	    				// Ҫ̶
	    				var line = this.getTickLine(value, this.valueAxis.getTickLength(), this.valueAxis.getTickMarkType());
	    				if (this.valueAxis.getTickLength() == 0 || this.valueAxis.getMainStroke() == 0) {
	    					continue;
	    				}
	    				this.drawTickLine(ctx, line, mainStroke);
	    			}
	    		}
	    		//  : ̶С1, ǸĻ  пܻ.
	    		if(this.smallTickLength > 1.0) {
	    			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.smallTickLength); value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.smallTickLength))) {
	    				// ̶ֵͬ
	    				if ((value - this.getCrossValue()) / this.smallTickLength == 5) {
	    					continue;
	    				}
	    				// Ҫ̶
	    				var line = this.getTickLine(value, this.valueAxis.getSecTickLength(), this.valueAxis.getSecTickMarkType());
	    				if (this.valueAxis.getSecTickLength() == 0 || this.valueAxis.getSecStroke() == 0) {
	    					continue;
	    				}
	    				this.drawTickLine(g, line, secStroke);
	    			}
	    		}
	    	} else if (this.maxValue > this.minValue){
	    		for (var value = this.minValue; value <= this.maxValue; value += this.tickLength) {
	    			// Ҫ̶
	    			var line = this.getTickLine(value, this.valueAxis.getTickLength(), this.valueAxis.getTickMarkType());
	    		    this.drawTickLine(ctx, line, mainStroke);
	        	}
	    		for (var value = this.minValue; value <= this.maxValue; value += this.smallTickLength) {
	    			// ̶ֵͬ
	    			if ((value - this.minValue) / this.smallTickLength == 5 ) {
	    				continue;
	    			}
	    			// Ҫ̶
	    			var line = this.getTickLine(value, this.valueAxis.getSecTickLength(), this.valueAxis.getSecTickMarkType());
	    			this.drawTickLine(ctx, line, secStroke);
	        	}
	    	}
	    	
	    	var divide_unit = 1.0;
	    	
	    	// showUnit
			var showUnit = this.valueAxis.getShowUnit();
	    	if (showUnit != null) {
				//  Ҫ  ǧ   ʮ ׵5
				if (showUnit.equals(new String(Inter.getLocText("Hundred")))){
					divide_unit = 100;
				} else if (showUnit.equals(new String(Inter.getLocText("Thousand")))) {
					divide_unit = 1000;
				} else if (showUnit.equals(new String(Inter.getLocText("Million")))) {
					divide_unit = 1000000;
				} else if (showUnit.equals(new String(Inter.getLocText("One-Billion")))) {
					divide_unit = 1000000000;
				} else if (showUnit.equals(new String( Inter.getLocText("Trillion")))) {
					divide_unit = 10e12;
				} else {
					divide_unit = Double.valueOf(showUnit).doubleValue();
				}
				// ʾλ..
				var unitGlyph = new TextGlyph(Inter.getLocText("Unit") + ":" + showUnit, null);
				var chartBounds = null;
	    		if (this.getAxis().getPosition() == Constants.prototype.TOP) {
	    			chartBounds = new Bounds( 0, -30, 100, 20);
	    		} else if (this.getAxis().getPosition() == Constants.prototype.LEFT ) {
	    			chartBounds = new Bounds( -50, -20, 100, 20); 
	    		} else if (this.getAxis().getPosition() == Constants.prototype.BOTTOM ) {
	    			chartBounds = new Bounds(-50, 20, 100, 20); 
	    		} else if (this.getAxis().getPosition() == Constants.prototype.RIGHT) {
	    			chartBounds = new Bounds( 20, -60, 100, 100); 
	    		}
	    		unitGlyph.setBounds(chartBounds);
	    		unitGlyph.draw(ctx);
			}
	    	
	    	if (this.valueAxis.getIsLog()) {
	            // kunsnat: ֱõλָ. ͨ math  ԭ: ˵λľ. 9λ..
	    		if(this.tickLength > 1) {
	    			for (var value = this.getCrossValue(); value <= this.maxValue; value = value * this.tickLength) {
	    				var tickValue = value / divide_unit;
	    				// תΪString ͨݸʽ
	    				var string = this.value2String(tickValue);
	    				if (string != null) {
	    					this.drawLabel(ctx, value, 0, string);
	    				} else {
	    					this.drawLabel(ctx, value, 0, Utils.doubleToString(tickValue));
	    				}
	    			}
	    		}
	    	} else if (this.maxValue > this.minValue){
	    		//  ڽǩ
	    		var number = 0;
	    		// ݱǩ
	    		var labelNumber = this.getAxis().getLabelNumber();
	    		// ʱȲBigDecimal   0.8 + 0.4
//	    		var bigValue = new BigDecimal("" + this.minValue).subtract(new BigDecimal("" + this.tickLength));
	        	for (var value = this.minValue; value <= this.maxValue; value += this.tickLength) {
//	        		bigValue = bigValue.add(new BigDecimal("" + this.tickLength));
	        		// -1Ĭ ʾ
	        		if (!(labelNumber == -1)) {
	        			if (labelNumber <= number) {
	        				// .
	        				continue;
	        			} 
	        		}
	        		
	        		var unitValue = value / divide_unit;
//	        		var unitValue = bigValue.divide(new BigDecimal(""+divide_unit));
	        		
	        		// valueݸʽ.
        			if(this.getAxis().getIsStagger()) {
        				this.drawBGLabel(ctx, value, 0, this.value2String(unitValue), number);
        			} else {
        				this.drawLabel(ctx, value, 0, this.value2String(unitValue));
        			}
        			
	        		number++;
	        	}
	    	}
	    	if(this.valueAxis.getHasAlertValue()) {
	    		var startString = this.valueAxis.getStartAlertValue().toString();
	    		if(!(this.valueAxis.getStartAlertValue() instanceof Formula)) {
	    			if(Utils.string2Number(startString) != null) {
	    				var start = Utils.string2Number(startString).doubleValue();
	    				// ޶ķΧ.
	    				if(start >= this.getMinValue() && start <= this.getMaxValue()) {
	    					this.drawAlertValueLabel(ctx, start, 0, startString);
	    				}
	    			}
	    		} else {
	    			this.drawAlertValueLabel(ctx, (maxValue - minValue)/4.0, 0, startString);
	    		}
	    		
	    		var endString = this.valueAxis.getEndAlertValue().toString();
	    		if(!(this.valueAxis.getEndAlertValue() instanceof Formula)) {
	    			if(Utils.string2Number(endString) != null) {
	    				var end = Utils.string2Number(endString).doubleValue();
	    				if(end >= this.getMinValue() && end <= this.getMaxValue()) {
	    					this.drawAlertValueLabel(g, end, 0, endString);
	    				}
	    			}
	    		} else {
	    			this.drawAlertValueLabel(ctx, 3*(maxValue - minValue)/4.0, 0, endString);
	    		}
	    	}
	    },
	    
	    drawAlertValueLabel		:		function(ctx, value, offset, str) {
	    	ctx.save();
	    	
	    	var centerP = this.getPoint2DForSelf(value + offset);
	    	var textAttr = new TextAttr();
	    	var font = new FRFont();
	    	font.color = 'rgb(255,0,0)';
	    	textAttr.setFRFont(font);
	    	
	    	var dim = TextGlyph.calculateTextDimension(str, textAttr);
	    	var labelBounds = null;
	    	
	    	var position = this.getAxis().getPosition();
			if (position == Constants.prototype.LEFT) {
				labelBounds = new Bounds(centerP.getX() + this.getAxisGridLength(), 
					centerP.getY() - dim.getHeight() / 2, dim.getWidth(), dim.getHeight());
			} else if (position == Constants.prototype.TOP) {
				labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, 
					centerP.getY() + this.getAxisGridLength() + dim.getHeight(), 
					dim.getWidth(), dim.getHeight());	
			} else if (position == Constants.prototype.RIGHT) {
				labelBounds = new Bounds(centerP.getX() - dim.getWidth() - this.getAxisGridLength(), 
					centerP.getY() - dim.getHeight(), dim.getWidth(), dim.getHeight() );
			} else {
				labelBounds = new Bounds(centerP.getX() - dim.getWidth()/2, 
					centerP.getY() - this.getAxisGridLength() - dim.getHeight() - Axis.LINE_LABEL_GAP, 
					dim.getWidth(), dim.getHeight());
			}
		
			TextGlyph.drawLabel(ctx, str, textAttr, labelBounds);
				
			ctx.restore();
	    }
	});
	
	
	function	AreaCategoryAxisGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(AreaCategoryAxisGlyph, CategoryAxisGlyph, {
		initConstants	:	function(js) {
			AreaCategoryAxisGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		getCategoryCount		:		function() {
			var number = this.categoryLabelList.length;
			
			return number > 1 ? number - 1 	: number;
		},
		
		drawLabel 		:		function(ctx, value, str) {
			// ָԾAxisGlyphdrawLabel..
			CategoryAxisGlyph.superclass.drawLabel.apply(this, [ctx, value, 0, str]);
		},
		
		drawBGLabel		:		function(ctx, value, str, labelNumber) {
			AreaCategoryAxisGlyph.superclass.drawBGLabel.apply(this,[ctx, value, 0, str, labelNumber]);
		}

	});
	
	function	RadarAxisGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(RadarAxisGlyph, AxisGlyph, {
		initConstants		:		function(js) {
			js = js || {};
			
			this.minValue = js.minValue == undefined ? 0 : js.minValue;
			this.maxValue = js.maxValue == undefined ? 0 : js.maxValue;
			this.D = js.D == undefined ? 0 : js.D;
			this.radian = js.radian  == undefined? 0 : js.radian;
			this.categoryCount = js.categoryCount == undefined ? 0 : js.categoryCount;
			this.radarAxis = js.radarAxis == undefined ? null : new RadarAxis(js.radarAxis);
			
			RadarAxisGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		init		:		function(plotBounds) {
			this.setBounds(plotBounds);
	    	// ԭ
	    	this.setOrigin(new Point2D(plotBounds.getX() + plotBounds.getWidth()/2, plotBounds.getY() + plotBounds.getHeight()/2));
	    	// ֱ
	    	this.setD(Math.min(plotBounds.getWidth(), plotBounds.getHeight()));
	    	// Ƕ
	    	this.setRadian(Math.PI * 2 / this.getCategoryCount()  );
	    	
	    	this.setAxisLength(this.getD() / 2);
		},
		
		initMinMaxValue		:		function(autoMin, autoMax) {
			if(this.radarAxis.isCustomMinValue()) {
				this.minValue = this.radarAxis.getMinValue();
			} else {
				this.minValue = autoMin;
			}
			
			if(this.radarAxis.isCustomMaxValue()) {
				this.maxValue = this.radarAxis.getMaxValue();
			} else {
				this.maxValue = autoMax;
			}
		},
		
		getAxis		:		function() {
			return this.radarAxis;
		},
		
		setAxis		:		function(axis) {
			this.radarAxis = axis;
		},
		
		setMinValue		:		function(minValue) {
			this.minValue = minValue
		},
		
		getMinValue		:		function() {
			return this.minValue;
		},
		
		setMaxValue		:		function(maxValue) {
			this.maxValue = maxValue;
		},
		
		getMaxValue		:		function() {
			return this.maxValue;
		},
		
		setCategoryCount		:		function(count) {
			this.categoryCount = count;
		},
		
		getCategoryCount		:		function() {
			return this.categoryCount;
		},
		
		setD		:		function(d) {
			this.D = d;
		},
		
		getD		:		function() {
			return this.D;
		},
		
		setRadian		:		function(radian) {
			this.radian	= radian;
		},
		
		getRadian		:		function() {
			return this.radian;
		},
		
		calculateAxisLengthUnit		:		function() {
			this.unitLength = this.axisLength / (this.getMaxValue() - this.getMinValue());
		
			this.tickLength = Axis.calculateIncrement(this.getMinValue(), this.getMaxValue());
			// ʼο̶ȵλ
			this.smallTickLength = this.tickLength / 5;
		},
		
		getPoint2D		:		function(categoryIndex, value) {
			value = value - this.getCrossValue();
			
			return new Point2D(
					this.originPoint.getX() + Math.cos(this.radian * categoryIndex + Math.PI / 2) * value * this.unitLength,
					this.originPoint.getY() - Math.sin(this.radian * categoryIndex + Math.PI / 2) * value * this.unitLength		
			);
		},
		
		/**
		 * 
		 */
		 drawAxisGrid		:		function(ctx) {
		 	// 
    		ctx.save();
	    	if (this.getAxis().getSecondGridStyle() != Constants.prototype.LINE_NONE && this.smallTickLength > 0) {
	    		
	    		ctx.strokeStyle = this.getAxis().getSecondGridColor();
	    		
	    		for (var value = this.getCrossValue(); value < this.getMaxValue(); value += this.smallTickLength) {
	    			var line = this.getGridLine(value);
	    			for (var i = 0; i < line.length; i ++) {
	    				GraphHelper.drawLine(ctx, line[i], this.getAxis().getSecondGridStyle());
	    			}
	    		}
	    	}
	    	// 
	    	if (this.getAxis().getMainGridStyle() != Constants.prototype.LINE_NONE && this.tickLength > 0) {
	    		
	    		ctx.strokeStyle = this.getAxis().getMainGridColor();
	    		
	    		for (var value = this.getCrossValue(); value < this.getMaxValue(); value += this.tickLength) {
	    			var line = this.getGridLine(value);
	    			for (var i = 0; i < line.length; i ++) {
	    				GraphHelper.drawLine(ctx, line[i], this.getAxis().getMainGridStyle());
	    			}
	    		}
	    	}
    		ctx.restore();
		 },
		 
		 getGridLine		:		function(value) {
		 	var axisLines = [];
		 	for(var i = 0; i < this.getCategoryCount(); i++) {
		 		axisLine[i] = new Line2D(this.getPoint2D(i, value), this.getPoint2D(i+1, value));
		 	}
		 	return axisLines;
		 },
		 
		 drawAxisLine		:		function(ctx) {
		 	ctx.save();
		 	
		 	var lineColor = this.getAxis().getLineColor();
			var lineStyle = this.getAxis().getLineStyle();
			if(lineColor != null && lineStyle != Constants.prototype.LINE_NONE) {
				ctx.strokeStyle = lineColor;
				
		    	// һCategoryӦһ
		    	var lines = this.getAxisLines();
		    	for (var i = 0; i < lines.length; i ++) {
		    		GraphHelper.drawLine(ctx, lines[i], lineStyle);
		    	}
			}
			
			// ̶
			this.drawTicks(ctx);
			
			ctx.restore();
		 },
		 
		 drawTicks		:		function(ctx) {
		 	for (var i = 0; i < this.getCategoryCount(); i ++) {
	    		// ¼ǩ
	    		var number = 0;
	    		// Ӧǩ
	    		var labelNumber = this.getAxis().getLabelNumber();
	    		for(var value = this.getCrossValue(); value <= this.getMaxValue(); value += this.tickLength) {
	    			
	    			// -1Ĭ ʾ
	        		if (!(labelNumber == -1)) {
	        			if (labelNumber <= number) {
	        				// .
	        				continue;
	        			} 
	        		}
	    			
	    			// ̶
	    			GraphHelper.drawLine(ctx, this.getTickLine(i, value, this.radarAxis.getTickLength(), this.radarAxis.getTickMarkType()));
	    			if (i == 0) {
	    				this.drawBGLabel(ctx, i, value, number);
	    			}
	    			number++;
	    		}
	    	}
	    	for (var i = 0; i < this.getCategoryCount(); i ++) {
	    		for(var value = this.getCrossValue(); value <= this.getMaxValue(); value += this.smallTickLength) {
	    			var tmpValue = (value - this.getCrossValue()) / this.smallTickLength;
	    			if ( !(tmpValue == 5)) {
	    				// ο̶
	        			GraphHelper.drawLine(ctx, this.getTickLine(i, value, this.radarAxis.getSecTickLength(), this.radarAxis.getSecTickMarkType()));
	    			}
	    		}
	    	}
		 },
		 
		 getTickLine		:		function(categoryIndex, value, tickLength, tickMarkType) {
		 	var centerP = this.getPoint2D(categoryIndex, value);
    	
	    	var leftP = new Point2D(
	    			centerP.getX() - tickLength / 2.0 * Math.cos(categoryIndex * this.radian), 
	    			centerP.getY() + tickLength / 2.0 * Math.sin(categoryIndex * this.radian));
	    			
			var rightP = new Point2D(centerP.getX() + tickLength / 2.0 * Math.cos(categoryIndex * this.radian), 
					centerP.getY() - tickLength / 2.0 * Math.sin(categoryIndex * this.radian));
	    	
	    	if (tickMarkType == Constants.prototype.TICK_MARK_CROSS) {
	    		return new Line2D(leftP, rightP);
	    	} else if (tickMarkType == Constants.prototype.TICK_MARK_INSIDE){
	    		return new Line2D(leftP, centerP);
	    	} else if (tickMarkType == Constants.prototype.TICK_MARK_OUTSIDE) {
	    		return new Line2D(centerP, rightP);
	    	} else {
	    		return new Line2D(centerP, centerP);
	    	}
		 },
		 
		 drawBGLabel 		:		function(ctx, categoryIndex, value , number) {
		 	// ȡ㰴 0---̶ȳ
    		var centerP = this.getPoint2D(categoryIndex, value);
	    	// label  С..
	    	// ݸʽ
	    	var format = this.getAxis().getFormat();
			var text = null;
			if (format != null) {
				text = FR.contentFormat(value, format);
			} else {
				text = value + "";
			}
	    	var textAttr = this.radarAxis.getTextAttr();
	    	if (textAttr == null) {
	    		textAttr = new TextAttr();
	    	}
	    	
	    	var dim = TextGlyph.calculateTextDimension(text, textAttr);
	    	
	    	var labelBounds = null;
	    	if (this.getAxis().getAxisLabelPosition() == Constants.prototype.LABEL_NONE) {
	    		return;
	    	} else {
	    		if(this.getAxis().getIsStagger()) {
	    			if(number % 2 == 0) {
	    				labelBounds =  new Bounds(
	    						centerP.getX() - Axis.prototype.LINE_LABEL_GAP - dim.getWidth(), 
	    						centerP.getY() - dim.getHeight() / 2, 
	    						dim.getWidth(), dim.getHeight()	);
	    			} else {
	    				labelBounds =  new Bounds(
	    						centerP.getX() - Axis.prototype.LINE_LABEL_GAP - dim.getWidth() * 1.5, 
	    						centerP.getY() - dim.getHeight() / 2, 
	    						dim.getWidth(), dim.getHeight()	);
	    			}
	    		} else {
	    			labelBounds =  new Bounds(
							centerP.getX() - Axis.prototype.LINE_LABEL_GAP - dim.getWidth(), 
							centerP.getY() - dim.getHeight() / 2, 
							dim.getWidth(), dim.getHeight()	);
	    		}
	    	}
	    	TextGlyph.drawLabel(ctx, text, textAttr, labelBounds);
		 },
		 
		 getAxisLines		:		function() {
		 	var axis_lines = [];
    	
	    	for (var i = 0; i < this.getCategoryCount(); i ++) {
	    		axis_lines[i] = new Line2D(
	    				this.getPoint2D(i, this.getCrossValue()), this.getPoint2D(i, this.getMaxValue())
	    		);
	    	}
	    	
	    	return axis_lines;
		 },
		 
		 getShape		:		function() {
		 	var path = new GeneralPath();
	    	var lines = this.getAxisLines();
	    	for (var i = 0; i < lines.length; i ++) {
	    		path.append(lines[i], false);
	    	}
	    	
	    	return path;
		 },
		 
		 getCrossValue	:	function() {
		 	return this.minValue;
		 },
		 
		 drawAxisTitle		:		function(ctx) {
		 	
		 }
		 
	});
	
		function RangeAxisGlyph(js) {
			this.initConstants(js);
		}
		
		FR.extend(RangeAxisGlyph, ValueAxisGlyph, {
			initConstants	:	function(js) {
				js = js || {};
				
				this.leftColor = js.leftColor == undefined ? 'red' : js.leftColor;
				this.rightColor = js.rightColor == undefined ? 'green' : js.rightColor;
				
				RangeAxisGlyph.superclass.initConstants.apply(this, [js]);
			},
			
			setLeftColor	:		function(leftColor) {
				this.leftColor = leftColor;
			},
			
			getLeftColor	:		function() {
				return this.leftColor;
			},
			
			setRightColor	:		function(rightColor) {
				this.rightColor = rightColor;
			},
			
			getRightColor	:		function() {
				return this.rightColor;
			},
			
			init	:		function(plotBounds) {
				// 
		    	var bounds = new Bounds(0, plotBounds.getHeight() / 2, plotBounds.getWidth(), 10);
		    	var zero = new Point2D(0, 0);
				var axisLength = bounds.getWidth();
				var axisGridLength = plotBounds.getHeight();
				
				this.setOrigin(zero);
				this.setBounds(bounds);
				this.setAxisLength(axisLength);
				this.setAxisGridLength(axisGridLength);
			},
			
			// TODO
			drawTicks		:		function(ctx) {
				var secStroke = this.valueAxis.getSecStroke();
		    	var mainStroke = this.valueAxis.getMainStroke();
		    	
		    	if (this.valueAxis.getIsLog()) {
		    		if(this.tickLength > 1.0) {
		    			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.tickLength);
		    						value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.tickLength))) {
		    				// Ҫ̶
		    				var line = this.getTickLine(value, this.valueAxis.getTickLength(), 
		    									this.valueAxis.getTickMarkType());
		    				if (this.valueAxis.getTickLength() == 0 || this.valueAxis.getMainStroke() == 0) {
		    					continue;
		    				}
		    				this.drawTickLine(ctx, line, mainStroke);
		    			}
		    		}
		    		if(this.smallTickLength > 1.0) {
		    			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.smallTickLength); 
		    						value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.smallTickLength))) {
		    				// ̶ֵͬ
		    				if ((value - this.getCrossValue()) / this.smallTickLength == 5) {
		    					continue;
		    				}
		    				// Ҫ̶
		    				var line = this.getTickLine(value, this.valueAxis.getSecTickLength(), 
		    								this.valueAxis.getSecTickMarkType());
		    				if (this.valueAxis.getSecTickLength() == 0 || this.valueAxis.getSecStroke() == 0) {
		    					continue;
		    				}
		    				this.drawTickLine(ctx, line, secStroke);
		    			}
		    		}
		    	} else {
		    		for (var value = this.minValue; value <= this.maxValue; value += this.tickLength) {
		    			// Ҫ̶
		    			var line = this.getTickLine(value, this.valueAxis.getTickLength(), this.valueAxis.getTickMarkType());
		    			this.drawTickLine(ctx, line, mainStroke);
		        	}
		    		for (var value = this.minValue; value <= this.maxValue; value += this.smallTickLength) {
		    			// ̶ֵͬ
		    			if ((value - this.minValue) % this.tickLength == 0 ) {
		    				continue;
		    			}
		    			// Ҫ̶
		    			var line = this.getTickLine(value, this.valueAxis.getSecTickLength(), this.valueAxis.getSecTickMarkType());
		    			this.drawTickLine(ctx, line, secStroke);
		    		}
		    	}
		    	
		    	var divide_unit = 1.0;
		    	
		    	// showUnit
				var showUnit = this.valueAxis.getShowUnit();
		    	if (showUnit != null) {
					//  Ҫ  ǧ   ʮ ׵5
					if (showUnit.equals(new String(Inter.getLocText("Hundred")))){
						divide_unit = 100;
					} else if (showUnit.equals(new String(Inter.getLocText("Thousand")))) {
						divide_unit = 1000;
					} else if (showUnit.equals(new String(Inter.getLocText("Million")))) {
						divide_unit = 1000000;
					} else if (showUnit.equals(new String(Inter.getLocText("One-Billion")))) {
						divide_unit = 1000000000;
					} else if (showUnit.equals(new String( Inter.getLocText("Trillion")))) {
						divide_unit = 10e12;
					} else {
						divide_unit = Double.valueOf(showUnit).doubleValue();
					}
					// ʾλ..
					var unitGlyph = new TextGlyph("λ:" + showUnit, null);
					var chartBounds =  new Bounds(-50, 20, 100, 20); 
		    		unitGlyph.setBounds(chartBounds);
		    		unitGlyph.draw(ctx);
				}
		    	
		    	if (this.valueAxis.getIsLog()) {
		    		if(this.tickLength > 1) {
		    			for (var value = this.getCrossValue(); value <= this.maxValue; value = value * this.tickLength) {
		    				var tickValue = value / divide_unit;
		    				
		    				var format = this.getAxis().getFormat();
		    				var string = null;
		    				if (format != null) {
		    					string = FR.contentFormat(tickValue, format);
		    				}
		    				if (string != null) {
		    					this.drawLabel(ctx, value, 0, string);
		    				} else {
		    					this.drawLabel(ctx, value, 0, tickValue + "");
		    				}
		    			}
		    		}
		    	} else {
		    		// valueݸʽ.. ݱǩ.
		        	for (var value = this.minValue; value <= this.maxValue; value += this.tickLength) {
		        		var unitValue = value / divide_unit;    		
		        		
		        		var format = this.getAxis().getFormat();
		        		var string = null;
		        		if (format != null) {
		        			string = FR.contentFormat(unitValue, format);
		        		}
		        		if (string != null) {
		        			this.drawLabel(ctx, value, 0, string);
		        		} else {
		        			this.drawLabel(ctx, value, 0, unitValue + "");
		        		}
		        	}
		    	}
		    	
		    	if(this.valueAxis.getHasAlertValue()) {
		    		var startString = this.valueAxis.getStartAlertValue().toString();
		    		if(!(this.valueAxis.getStartAlertValue() instanceof Formula)) {
		    			if(Utils.string2Number(startString) != null) {
		    				var start = Utils.string2Number(startString).doubleValue();
		    				// ޶ķΧ.
		    				if(start >= this.getMinValue() && start <= this.getMaxValue()) {
		    					this.drawAlertValueLabel(ctx, start, 0, startString);
		    				}
		    			}
		    		} else {
		    			this.drawAlertValueLabel(ctx, (this.maxValue - this.minValue)/4.0, 0, startString);
		    		}
		    		var endString = this.valueAxis.getEndAlertValue().toString();
		    		if(!(this.valueAxis.getEndAlertValue() instanceof Formula)) {
		    			if(Utils.string2Number(endString) != null) {
		    				var end = Utils.string2Number(endString).doubleValue();
		    				if(end >= this.getMinValue() && end <= this.getMaxValue()) {
		    					this.drawAlertValueLabel(ctx, end, 0, endString);
		    				}
		    			}
		    		} else {
		    			this.drawAlertValueLabel(ctx, 3*(this.maxValue - this.minValue)/4.0, 0, endString);
		    		}
		    	}
			},
			
			drawAxisGrid		:		function(ctx) {
				// Ȼߣ
	    		ctx.save();
		    	if (this.getAxis().getSecondGridStyle() != Constants.prototype.LINE_NONE && this.smallTickLength > 0) {
		    		
		    		ctx.strokeStyle = this.getAxis().getSecondGridColor();
		    		
		    		if (this.valueAxis.getIsLog()) {
		    			if(this.smallTickLength > 1.0) {
		        			for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.smallTickLength); 
		        						value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.smallTickLength))) {
		        				// ̶ֵͬ
		        				if ((value - this.getCrossValue()) / this.smallTickLength == 5) {
		        					continue;
		        				}
		        				var lines = this.getGridLine(value);
		                		for (var j = 0; j < lines.length; j ++) {
		                			GraphHelper.drawLine(ctx, lines[j], this.getAxis().getSecondGridStyle());
		                		}
		        			}
		        		}
		    		} else {
		    			for (var value = this.minValue + this.smallTickLength; 
		    						value <= this.maxValue; value += this.smallTickLength) {
		    				var lines = this.getGridLine(value);
		            		for (var i = 0; i < lines.length; i ++) {
		            			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getSecondGridStyle());
		            		}
		            	}
		    		}
		    	}
		    	
		    	// .
		    	if (this.getAxis().getMainGridStyle() != Constants.prototype.LINE_NONE && this.tickLength > 0) {
		    		ctx.strokeStyle = this.getAxis().getMainGridColor();
		    		
		    		if (this.valueAxis.getIsLog()) {
		    			if(this.tickLength > 1.0) {
		    				for (var value = this.getCrossValue(), i = Math.log(value) / Math.log(this.tickLength); 
		    							value <= this.maxValue; value = Math.exp((++ i) * Math.log(this.tickLength))) {
		    					var lines = this.getGridLine(value);
		    					for (var k = 0; k < lines.length; k ++) {
		    						GraphHelper.drawLine(ctx, lines[k], this.getAxis().getMainGridStyle());
		    					}
		    				}
		    			}
		    		} else {
		    			for (var value = this.minValue + this.tickLength; value <= this.maxValue; value += this.tickLength) {
		    				var lines = this.getGridLine(value);
		            		for (var i = 0; i < lines.length; i ++) {
		            			GraphHelper.drawLine(ctx, lines[i], this.getAxis().getMainGridStyle());
		            		}
		            	}
		    		}
		    	}
	    		ctx.restore();
		    	
		    	if (this.valueAxis.getHasAlertValue()) {
		    		ctx.save();
		    		
		    		ctx.lineWidth = 1;
					ctx.strokeStyle= "red";
		    		
		    		var startString = this.valueAxis.getStartAlertValue().toString();
		    		if(!(this.valueAxis.getStartAlertValue() instanceof Formula)) {
		    			if(Utils.string2Number(startString) != null) {
		    				var lineValue = Utils.string2Number(startString).doubleValue();
		    				if(lineValue <= this.getMaxValue() && lineValue >= this.getMinValue()) {
		    					var lines = this.getGridLine(lineValue);
		    					for (var i = 0; i < lines.length; i ++) {
		    						GraphHelper.drawLine(ctx, lines[i]);
		    					}
		    				}
		    			}
		    		} else {
		    			var lines = this.getGridLine((this.maxValue - this.minValue)/4.0);
		    			for (var i = 0; i < lines.length; i ++) {
		    				GraphHelper.drawLine(ctx, lines[i]);
		    			}
		    		}
		    		if(!(this.valueAxis.getEndAlertValue() instanceof Formula)) {
		    			var endString = this.valueAxis.getEndAlertValue().toString();
		    			//  жǷתΪֵ.
		    			if(endString != null) {
		    				var lineValue = Utils.string2Number(endString).doubleValue();
		    				if(lineValue <= this.getMaxValue() && lineValue >= this.getMinValue()) {
		    					var lines = this.getGridLine(lineValue);
		    					for (var i = 0; i < lines.length; i ++) {
		    						GraphHelper.drawLine(ctx, lines[i]);
		    					}
		    				}
		    			}
		    		} else {
		    			var lines = this.getGridLine(3 * (this.maxValue - this.minValue)/4.0);
		    			for (var i = 0; i < lines.length; i ++) {
		    				GraphHelper.drawLine(ctx, lines[i]);
		    			}
		    		}
		    		ctx.restore();
		    	}
		    	this.drawAxisGround(ctx);
			},
			
			drawAxisGround		:		function(ctx) {
				var linegrad = ctx.createLinearGradient(0,-25,this.axisLength,50);
				linegrad.addColorStop(0, this.getLeftColor());
				linegrad.addColorStop(1, this.getRightColor());
				
				ctx.fillStyle = linegrad;
				
				ctx.fillRect(0, -25, this.axisLength, 50);
			},
			
			getGridLine		:		function(value) {
				var centerP = this.getPoint2DForSelf(value);
				// ȫͼ ֻһ.
				var line = new Line2D(new Point2D(centerP.getX(), centerP.getY() - this.getAxisGridLength()/2), 
						new Point2D(centerP.getX(), centerP.getY() + this.getAxisGridLength()/2));
				return new Array(line);
			},
			
			/**
			 * ıǩ
			 **/
			drawLabel		:		function(ctx, value, offset, str) {
				var centerP = this.getPoint2DForSelf(value + offset);
		    	var textAttr = this.getAxis().getTextAttr();
		    	if (textAttr == null) {
		    		textAttr = new TextAttr();
		    	}
		    	var dim = TextGlyph.calculateTextDimension(str, textAttr);
		    	// ߴʾǩλ
		    	var bounds = null;
		    	var labelPosition = this.valueAxis.getAxisLabelPosition();
		    	if (labelPosition == Constants.prototype.LABEL_NONE) {
		    		// ִ ֱӷ  boundsΪ.
		    		return;
		    	} else if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
		    		bounds = new Bounds(centerP.getX() - dim.getWidth()/2 + 5 , centerP.getY() + 45, dim.getWidth(), dim.getHeight());
		    	}else if (labelPosition == Constants.prototype.LABEL_TOP || labelPosition == Constants.prototype.LABEL_AROUND) {
		    		bounds = new Bounds(centerP.getX() - dim.getWidth()/2 + 5 , centerP.getY() - 45 - dim.getHeight(), dim.getWidth(), dim.getHeight());
		    	}
				TextGlyph.drawLabel(ctx, str, textAttr, bounds);
			},
			
			/**
			 * ߵvalueLabel
			 */
			 drawAlertValueLabel		:		function(ctx, value, offset, str) {
			 	var centerP = this.getPoint2DForSelf(value + offset);
				var textAttr = new TextAttr();
				
				// TODO ɫ
				var font = new FRFont();
				font.color = 'rgb(255,0,0)';
				textAttr.setFRFont(font);
		    	
		    	var dim = TextGlyph.calculateTextDimension(str, textAttr);
		    	// ߴʾǩλ
		    	var bounds = null;
		    	var labelPosition = this.valueAxis.getAxisLabelPosition();
		    	if (labelPosition == Constants.prototype.LABEL_NONE) {
		    		// ִ ֱӷ  boundsΪ.
		    		return;
		    	} else if (labelPosition == Constants.prototype.LABEL_BOTTOM) {
		    		bounds = new Rectangle2D(centerP.getX() - dim.getWidth()/2 + 5 , centerP.getY() - 45 - dim.getHeight(), dim.getWidth(), dim.getHeight());
		    	}else if (labelPosition == Constants.prototype.LABEL_TOP || labelPosition == Constants.prototype.LABEL_AROUND) {
		    		bounds = new Rectangle2D(centerP.getX() - dim.getWidth()/2 + 5 , centerP.getY() + 45, dim.getWidth(), dim.getHeight());
		    	}
		    	TextGlyph.drawLabel(ctx, str, textAttr, bounds);
			 }
			
		});
		
		function	ValueAxis3DGlyph(js) {
			// cubic; valueAxis
			this.initConstants(js);
		}
		
		FR.extend(ValueAxis3DGlyph, ValueAxisGlyph, {
			initConstants	:	function(js) {
				js = js || {};
				
				this.cubic = js.cubic == undefined ?  null : new Cubic(js.cubic);
				ValueAxis3DGlyph.superclass.initConstants.apply(this, [js]);
			},
			
			draw		:		function(ctx) {
				var p = this.getProjection().projectee(this.getBounds().getX(), this.getBounds().getY(), 0);
		        ctx.translate(p.getX(), p.getY());//ƽ
		        
		    	this.drawAxisGrid(ctx);
		    	
		    	this.drawAxisLine(ctx);
		    	
		    	this.drawAxisTitle(ctx);
		    	
		        ctx.translate(-p.getX(), -p.getY());//ƽ
			},
			
			getPoint2DForSelf	:	function(value) {
				var p = this.getPoint2D(value);
				
				return this.getProjection().projectee(p.getX(), p.getY(), 0);
			},
			
			getGridLine		:		function(value) {
				var p = this.getPoint2D(value);
				
				var p_1 = this.getProjection().projectee(p.getX(), p.getY(), 0);
				var p_2 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
				
				var line_side = new Line2D(p_1, p_2);
		        
		        var p_3, p_4;
		        if(this.getAxis().getPosition() == Constants.prototype.LEFT ){
		        	p_3 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
		        	p_4 = this.getProjection().projectee(p.getX() + this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
		        } else if(this.getAxis().getPosition() == Constants.prototype.RIGHT){
		        	p_3 = this.getProjection().projectee(p.getX() - this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
		        	p_4 = this.getProjection().projectee(p.getX() - this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
		        } else if(this.getAxis().getPosition() == Constants.prototype.TOP){
		        	p_3 = this.getProjection().projectee(p.getX(), p.getY() + this.getAxisGridLength(), - this.cubic.getDeep());
		        	p_4 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
		        } else {
		        	p_3 = this.getProjection().projectee(p.getX(), p.getY() - this.getAxisGridLength(), - this.cubic.getDeep());
		        	p_4 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
		        }
				
		        var line_back = new Line2D(p_3, p_4);
				return new Array(line_side, line_back);
			},
			
			setCubic	:	function(cubic) {
				this.cubic = cubic;
			},
			
			getCubic 	:	function() {
				return this.cubic;
			},
			
			getProjection	:	function() {
				return this.cubic.getProjection();
			},
			
			setProjection	:	function(projection) {
				this.cubic.setProjection(projection);
			}
		});
		
	function	CategoryAxis3DGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(CategoryAxis3DGlyph, CategoryAxisGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.cubic = js.cubic == undefined ? null : new Cubic(js.cubic);
			
			CategoryAxis3DGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		draw		:		function(ctx) {
			var p = this.getProjection().projectee(this.getBounds().getX(), this.getBounds().getY(), 0);
	        ctx.translate(p.getX(), p.getY());//ƽ
	        
	    	this.drawAxisGrid(ctx);
	    	
	    	this.drawAxisLine(ctx);
	    	
	    	this.drawAxisTitle(ctx);
	    	
	        ctx.translate(-p.getX(), -p.getY());//ƽ
	        
	        // kunsnat: cubic ֱ3DAxisGlyphл.
	        if(this.cubic != null) {
	        	this.cubic.draw(ctx);
	        }
		},
		
		getPoint2DForSelf		:		function(value) {
			var p = this.getPoint2D(value);
			
			return this.getProjection().projectee(p.getX(), p.getY(), 0);
		},
		
		getGridLine		:		function(value) {
			var p = this.getPoint2D(value);
			
			var p_1 = this.getProjection().projectee(p.getX(), p.getY(), 0);
			var p_2 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
			
			var line_side = [];
			
			var p_3, p_4;
	        if(this.getAxis().getPosition() == Constants.prototype.LEFT ){
	        	p_3 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
	        	p_4 = this.getProjection().projectee(p.getX() + this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
	        } else if(this.getAxis().getPosition() == Constants.prototype.RIGHT){
	        	p_3 = this.getProjection().projectee(p.getX() - this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
	        	p_4 = this.getProjection().projectee(p.getX() - this.getAxisGridLength(), p.getY(), - this.cubic.getDeep());
	        } else if(this.getAxis().getPosition() == Constants.prototype.TOP){
	        	p_3 = this.getProjection().projectee(p.getX(), p.getY() + this.getAxisGridLength(), - this.cubic.getDeep());
	        	p_4 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
	        } else {
	        	p_3 = this.getProjection().projectee(p.getX(), p.getY() - this.getAxisGridLength(), - this.cubic.getDeep());
	        	p_4 = this.getProjection().projectee(p.getX(), p.getY(), - this.cubic.getDeep());
	        }
			
	        var line_back = new Line2D(p_3, p_4);
	        
			return new Array(line_side, line_back);
		},
		
		setCubic		:		function(cubic) {
			this.cubic = cubic;
		},
		
		getCubic 		:		function() {
			return this.cubic;
		},
		
		getProjection		:		function() {
			return this.cubic.getProjection();
		},
		
		setProjection		:		function(projection) {
			this.cubic.setProjection(projection);
		}
	});
	
		function	AreaCategory3DAxisGlyph(js) {
			this.initConstants(js);
		}
		
		FR.extend(AreaCategory3DAxisGlyph, CategoryAxis3DGlyph, {
			initConstants	:	function(js) {
				AreaCategory3DAxisGlyph.superclass.initConstants.apply(this, [js]);
			},
			
			getCategoryCount		:		function() {
				var labelNumber = this.categoryLabelList.length;
				return labelNumber > 1 ? labelNumber - 1 : labelNumber;
			},
			
			// ֱյĽ
			drawLabel		:		function(ctx, value, str) {
				CategoryAxisGlyph.superclass.drawLabel.apply(this, [ctx,value, 0, str]);
			},
			
			drawBGLabel		:		function(ctx, value, str, labelNumber) {
				CategoryAxisGlyph.superclass.drawBGLabel.apply(this, [ctx, value, 0, str, labelNumber]);
			}
				
		});	

function LineMarkerIcon(js) {
	this.initConstants(js);
}

LineMarkerIcon.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.color = js.color == undefined ? null : js.color;
		this.lineStyle = js.lineStyle == undefined ? Constants.prototype.LINE_NONE : js.lineStyle;
		this.alpha = js.alpha == undefined ? 1.0 : js.alpha;
		
		if(js.markerType == undefined) {
			this.marker = null;
		} else {
			var type = js.markerType;
			if(type == "CircleFilledMarker") {
				this.marker = new CircleFilledMarker(js.marker);
			} else if(type == "CircleMarker") {
				this.marker = new CircleMarker(js.marker);
			} else if(type == "CrossMarker") {
				this.marker = new CrossMarker(js.marker);
			} else if(type == "DiamondFilledMarker") {
				this.marker = new DiamondFilledMarker(js.marker);
			} else if(type == "DiamondMarker") {
				this.marker = new DiamondMarker(js.marker);
			} else if(type == "DowJonesMarker") {
				this.marker = new DowJonesMarker(js.marker);
			} else if(type == "MinusSignMarker") {
				this.marker = new MinusSignMarker(js.marker);
			} else if(type == "NullMarker") {
				this.marker = new NullMarker(js.marker);
			} else if(type == "PlusSignMarker") {
				this.marker = new PlusSignMarker(js.marker);
			} else if(type == "SquareFilledMarker") {
				this.marker = new SquareFilledMarker(js.marker);
			} else if(type == "SquareMarker") {
				this.marker = new SquareMarker(js.marker);
			} else if(type == "StarMarker") {
				this.marker = new StarMarker(js.marker);
			} else if(type == "TriangleFilledMarker") {
				this.marker = new TriangleFilledMarker(js.marker);
			} else if(type == "TriangleMarker") {
				this.marker = new TriangleMarker(js.marker);
			} else if(type == "XMarker") {
				this.marker = new XMarker(js.marker);
			} else if(type == "AntiClockLineMarker") {
				this.marker = new AntiClockLineMarker(js.marker);
			} else if(type == "ClockLineMarker") {
				this.marker = new ClockLineMarker(js.marker);
			} else if(type == "PointMarker") {
				this.marker = new PointMarker(js.marker);
			} else if(type == "AllEqualMarker") {
				this.marker = new AllEqualMarker(js.marker);
			}
		}
		
		if(js.background == undefined || js.backgroundType == undefined ) {
			this.background = null;
		} else {
			var backgroundType = js.backgroundType;
			if(backgroundType == "ColorBackground") {
				this.background = new ColorBackground(js.background);
			}
		}
		
	},
	
	setAlpha	:	function(alpha) {
		this.alpha = alpha;
	},
	
	getAlpha	:	function() {
		return this.alpha;
	},
	
	setColor	:	function(color) {
		this.color = color;
	},
	
	getColor	:	function() {
		return this.color;
	},
	
	setMarker	:	function(marker) {
		this.marker = marker;
	},
	
	getMarker	:	function() {
		return this.marker;
	},
	
	setBackground	:	function(background) {
		this.background = background;
	},
	
	getBackground	:	function() {
		return this.background;
	},
	
	setLineStyle	:	function(lineStyle) {
		this.lineStyle = lineStyle;
	},
	
	getLineStyle	:	function() {
		return this.lineStyle;
	},
	
	getIconWidth	:	function() {
		return LegendItem.prototype.LEGEND_ICON_WIDTH;
	},
	
	getIconHeight	:	function() {
		return LegendItem.prototype.LEGEND_ICON_WIDTH;
	},
	
	paint	:	function(ctx) {
		ctx.save();
		
		if(this.color != null) {
			ctx.fillStyle = this.color;
			// ͬʱҪǵߵɫ
			ctx.strokeStyle = this.color;
		}
	
		ctx.globalAlpha = this.alpha;
	
		var drawBackground = true;
	
		// kunsnat: ֱӸ LEGEND_ICON_WIDTH 11  5.5
		if(this.lineStyle != Constants.prototype.LINE_NONE) {
			GraphHelper.drawLine(ctx, new Line2D(new Point2D(0, 5.5),new Point2D(11,5.5)), this.lineStyle);
			drawBackground = false;
		}
	
		if(this.marker != null) {
			this.marker.paint(ctx, 5.5, 5.5);
			ctx.restore();
			return ;
		}
	
		if(drawBackground) {
			if(this.background != null) {
				this.background.paint(ctx, new Bounds(0,0,11,11));
			} else {
				ctx.fillRect(0,0,11,11);
			}
		}
	
		ctx.restore();
	}
}

function LegendItem(js) {
	this.initConstants(js);
}

LegendItem.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.label = js.label == undefined ? null : js.label;
		this.lineMarkerIcon = js.lineMarkerIcon == undefined ? null : new LineMarkerIcon(js.lineMarkerIcon);
		
		this.bounds = null;
	},
	
	LEGEND_ICON_WIDTH	:	11,
	GAP		:	2,
	
	setLineMarkerIncon	:	function(lineMarkerIcon) {
		this.lineMarkerIcon = lineMarkerIcon;
	},
	
	getLineMarkerIcon 	:	function() {
		return this.lineMarkerIcon;
	},
	
	setLabel	:	function(label) {
		this.label = label;
	},
	
	getLabel	:	function() {
		return this.label;
	},
	
	setBounds	:	function(bounds) {
		this.bounds = bounds;
	},
	
	getBounds	:	function() {
		return this.bounds;
	},
	
	draw	:	function(ctx, font4Label) {
		var alpha = 1.0;
			
		if (this.getLineMarkerIcon() != null) {
			alpha = this.getLineMarkerIcon().getAlpha();
				
			ctx.translate(this.bounds.getX(), this.bounds.getY());
			this.getLineMarkerIcon().paint(ctx);
			ctx.translate(-this.bounds.getX(), -this.bounds.getY());
		}	
	
        if (this.getLabel() != null) {
        	ctx.save();
        	
        	ctx.font = font4Label.size + "px " + font4Label.fontName;
          	ctx.fillStyle = font4Label.color;
           	ctx.globalAlpha = 1.0;
           	
           	ctx.fillText(this.getLabel(), this.bounds.getX() + this.LEGEND_ICON_WIDTH + this.GAP, this.bounds.getY() + this.bounds.getHeight());

			ctx.restore();          
        }
	},
	
	prefferedSize	:	function(font4Label) {
		var dimension = GraphHelper.stringDimension(this.getLabel(), font4Label, 0);
		dimension.width = dimension.width + this.LEGEND_ICON_WIDTH + this.GAP;
		return dimension;
	}
}

function LegendGlyph(js) {
	this.initConstants(js);
}

FR.extend(LegendGlyph, RectangleGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		
		this.font = js.font == undefined ? null : new FRFont(js.font);
		this.position = js.position == undefined ? Constants.prototype.RIGHT : js.position;
		
		this.items = [];
		if(js.items != undefined) {
			var legendItems = js.items;
			for(var i = 0; i < legendItems.length; i++) {
				this.items[i] = new LegendItem(legendItems[i]);
			}
		}
		
		LegendGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	MARGIN	:	2,
		
	setItems		:		function(items) {
		this.items = items;
	},
	
	getItems		:		function() {
		return this.items;
	},
	
	setFont			:		function(font) {
		this.font = font;
	},
	
	getFont			:		function() {
		return this.font;
	},
	
	setPosition		:		function(position) {
		this.position = position;
	},
	
	getPosition		:		function() {
		return this.position;
	},
	
	draw		:		function(ctx) {
		LegendGlyph.superclass.draw.apply(this, [ctx]);
	
		ctx.translate(this.bounds.getX(),this.bounds.getY());
	
		if(this.getItems() != null) {
			for(var i = 0; i < this.getItems().length; i++ ) {
				this.getItems()[i].draw(ctx, this.font);
			}
		}
	
		ctx.translate(-this.bounds.getX(), -this.bounds.getY());
	},
	
	prefferedSizeByItems		:		function() {
		if(this.items == null || this.items.length == 0) {
			return new Dimension2D();
		}
	
		var borderLineSize = GraphHelper.getLineStyleSize(this.getBorderStyle());
	        
        var width, height;
        if (this.position == Constants.prototype.TOP || this.position == Constants.prototype.BOTTOM) {        	
        	var sumWidth = 0.0;
        	var maxHeight = 0.0;
        	for (var i = 0; i < this.items.length; i ++) {
        		var dim = this.items[i].prefferedSize(this.font);
        		sumWidth += dim.getWidth();
        		maxHeight = Math.max(maxHeight, dim.getHeight());
        	}
        	
        	width = borderLineSize * 2 + LegendGlyph.prototype.MARGIN * 2 * this.items.length +  sumWidth;
        	height = LegendGlyph.prototype.MARGIN * 2 + Math.max(maxHeight, LegendItem.prototype.LEGEND_ICON_WIDTH);
        } else {
        	var maxWidth = 0.0;
        	var sumHeight = 0.0;
        	for (var i = 0; i < this.items.length; i ++) {
        		var dim = this.getItems()[i].prefferedSize(this.font);
        		sumHeight += dim.getHeight();
        		maxWidth = Math.max(maxWidth, dim.getWidth());
        	}
        	
        	height = borderLineSize * 2 + LegendGlyph.prototype.MARGIN * 2 * this.getItems().length + sumHeight;
        	width = maxWidth + LegendGlyph.prototype.MARGIN * 2 + borderLineSize * 2;
        }
        
        return new Dimension2D(width, height);
	},
	
	refreshItemBounds		:		function() {
		if(!(this.getItems() != null && this.getItems().length > 0 )) {
    		return;
    	}
    	
    	var fontHeight = 12;
    	if(this.font != null) {
	        fontHeight = this.font.size;
    	}

        var borderLineSize = GraphHelper.getLineStyleSize(this.getBorderStyle());

        var width = this.bounds.getWidth() - borderLineSize * 2;
        var height = this.bounds.getHeight() - borderLineSize * 2;
        var item_height = Math.max(fontHeight, LegendItem.prototype.LEGEND_ICON_WIDTH);
        var sumWidth = 0.0;
        for (var i = 0; i < this.getItems().length; i ++) {
        	sumWidth += this.getItems()[i].prefferedSize(this.font).getWidth();
        }
    	
    	if (sumWidth < width) {
    		var h_gap = (width - sumWidth) / this.getItems().length;
    		var v_gap = Math.max(0, height - item_height);
    		
    		var pre_width = 0.0;
    		for (var i = 0; i < this.getItems().length; i ++) {
    			var x = h_gap / 2 + pre_width + h_gap * i + borderLineSize;
    			var y = v_gap / 2 + borderLineSize;
    			
        		this.getItems()[i].setBounds(new Bounds(x, y, LegendItem.prototype.LEGEND_ICON_WIDTH, LegendItem.prototype.LEGEND_ICON_WIDTH));
        		
        		pre_width += this.getItems()[i].prefferedSize(this.font).getWidth();
    		}
    	} else {
    		var maxWidth = 0.0;
        	for (var i = 0; i < this.getItems().length; i ++) {
        		var itemWidth = this.getItems()[i].prefferedSize(this.font).getWidth();
        		maxWidth = Math.max(itemWidth, maxWidth);
        	}
        	
        	if (maxWidth < 0.1) {
        		return;
        	}
        	
        	var col_count = Math.round(Math.max(1, (width / maxWidth)));
        	var row_count = Math.round(this.getItems().length / col_count);
        	var margin = height / row_count - Math.max(fontHeight, LegendItem.prototype.LEGEND_ICON_WIDTH);
        	margin = Math.max(margin, 0);
        	var per_width = width / col_count;
        	for (var i = 0; i < this.getItems().length; i ++) {
        		var col = i % col_count;
        		var row = i / col_count;
        		var x = per_width * col + (per_width - maxWidth) / 2.0 + borderLineSize;
        		var y = margin / 2 + row * item_height + row * margin + borderLineSize;
        		
        		this.getItems()[i].setBounds(new Bounds(x,y, LegendItem.prototype.LEGEND_ICON_WIDTH, LegendItem.prototype.LEGEND_ICON_WIDTH));
        	}
    	}
	}
});


function PlotGlyph(js) {
 	this.initConstants(js);
}

FR.extend(PlotGlyph, RectangleGlyph, {
	
	initConstants	:	function(js) {
		js = js || {};
		
		this.dataSeries = [];
		if(js.seriesList != undefined && js.seriesList.length > 0) {
			var array = js.seriesList;
			for(var i = 0; i < array.length; i++) {
				this.dataSeries[i] = new DataSeries(array[i]);
			}
		}
		
		this.seriesCollection = js.seriesCollection == undefined ? new SeriesCollection() : new SeriesCollection(js.seriesCollection);
		
		PlotGlyph.superclass.initConstants.apply(this, [js]);
	},
		
	getDataSeries		:		function() {
		return this.dataSeries;
	},
	
	setDataSeries		:		function(value) {
		this.dataSeries = value;
	},
	
	getSeries		:		function(index)
	{
		return this.dataSeries[index];
	},
	
	getSeriesSize		:		function() 
	{
		return this.dataSeries.length;
	},
	
	draw		:		function(ctx, time, xylist, actionModel) {
		ctx.translate(this.getBounds().getX(),this.getBounds().getY());
		
		// ֻߵPlotGlyphxylist, ¼. chartGlyphж0, 
		
		xylist.push(this.getBounds().getX());
		xylist.push(this.getBounds().getY());
	
		for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
			var stepNumber = 22;
			this.getSeries(i).getAnimateGlyph(stepNumber);
		}
		if(this.isStacked) {
			// ֧, εĶѻĶѻ. 
			this.createCateAnimateGlyph();
			
			this.animateGlyphDraw(ctx, time, this.getCateAnimateStepNumber(), xylist);
		} else {
			// getAnimateStepNumber ֱӵõѾanimateGlyph.length, stepNumber, Ȼ󲿷ǺstepNumber
			// ʱж.ǷΪֵ.
			if(this.getSeries(0)) {
				this.animateGlyphDraw(ctx, time, this.getSeries(0).getAnimateStepNumber(), xylist);
			}
		}
		
		ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
	},
	
	animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
		var plotGlyph = this;
		var count = 0;
		
		var id = setInterval(function() {
			for(var i = 0; i < xylist.length; i = i + 2) {
				ctx.translate(xylist[i], xylist[i+1]);
			}
			
			if(plotGlyph.isStacked) {
				plotGlyph.drawCateAnimateGlyph(ctx, count);
			} else {
				for(var i = 0; i < plotGlyph.getSeriesSize(); i++) {
					plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
				}
			}
			
			count++;
			
			if(count > stepNumber - 1) {
				clearInterval(id);
				for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
					plotGlyph.getSeries(i).drawLabel(ctx);
				}
				
				plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
			}
			
			for(var i = 0; i < xylist.length; i = i + 2) {
				ctx.translate(-xylist[i], -xylist[i+1]);
			}
		}, time/stepNumber);
	},
	
	// Ļ, ͼͼ ά ֤͸Ч ˸
	animateReverseGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
		// Ҫ.
		var plotGlyph = this;
		var count = 0;
		
		var id = setInterval(function() {
			for(var i = 0; i < xylist.length; i = i + 2) {
				ctx.translate(xylist[i], xylist[i+1]);
			}
			
			if(plotGlyph.isStacked) {
    			plotGlyph.drawCateAnimateGlyph(ctx, count)
			} else {
				for(var i = plotGlyph.getSeriesSize() - 1; i >= 0; i--) {
					plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
				}
			}
			
			count++;
			
			if(count > stepNumber - 1) {
				clearInterval(id);
				for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
					plotGlyph.getSeries(i).drawLabel(ctx);
				}
				
				plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
			}
			
			for(var i = 0; i < xylist.length; i = i + 2) {
				ctx.translate(-xylist[i], -xylist[i+1]);
			}
		}, time/stepNumber);
	},
	
	drawInfo		:		function(ctx) {
		this.info.paint(ctx, this.getOutline4Fill());
	},
	
	// kunsnat: Ϊ̬֮ѱͼѹ. ͳһ
	drawLegendGlyphAndTitleGlyph	:	function(ctx, xylist) {
		for(var i = 0; i < xylist.length; i = i + 2) {
			ctx.translate(-xylist[i], -xylist[i+1]);
		}
		
		if(this.legendGlyph != null) {
			this.legendGlyph.draw(ctx);
		}
	
		if(this.titleGlyph != null) {
			this.titleGlyph.draw(ctx);
		}
		
		for(var i = 0; i < xylist.length; i = i + 2) {
			ctx.translate(xylist[i], xylist[i+1]);
		}
	},
	
	dealDataPointLabelBounds	:	function(dataPoint, seriesIndex) {
		var glyph = dataPoint.getDataLabel();
		if(glyph instanceof TextGlyph) {
			var attrPosition = this.getSeriesCollection().getSeriesCondition(new SeriesAttrPosition(), seriesIndex);
			glyph.preferredLabelBounds(dataPoint, attrPosition.getPosition());
		}
	},
	
	setSeriesCollection 		: 		function(seriesCollection) {
		this.seriesCollection = seriesCollection;
	},
	
	getSeriesCollection			:		function() {
		return this.seriesCollection;
	}
});

function CategoryPlotGlyph(js) {
	this.initConstants(js);
}

FR.extend(CategoryPlotGlyph, PlotGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		
		// жvalueAxisGlyph valueAxis3DGlyph
		if(js.valueGlyphType == undefined || js.valueAxisGlyph == null) {
			this.valueAxisGlyph = null;
		} else {
			if(js.valueGlyphType == "ValueAxisGlyph") {
				this.valueAxisGlyph = new ValueAxisGlyph(js.valueAxisGlyph);
			} else if(js.valueGlyphType == "ValueAxis3DGlyph") {
				this.valueAxisGlyph = new ValueAxis3DGlyph(js.valueAxisGlyph);
			}
		}
		
		if(js.categoryGlyphType == undefined || js.categoryAxisGlyph == undefined) {
			this.categoryAxisGlyph = null;
		} else {
			var categoryType = js.categoryGlyphType;
			if(categoryType == "CategoryAxisGlyph") {
				this.categoryAxisGlyph = new CategoryAxisGlyph(js.categoryAxisGlyph);
			} else if(categoryType == "AreaCategoryAxisGlyph") {
				this.categoryAxisGlyph = new AreaCategoryAxisGlyph(js.categoryAxisGlyph);
			} else if(categoryType == "CategoryAxis3DGlyph") {
				this.categoryAxisGlyph = new CategoryAxis3DGlyph(js.categoryAxisGlyph);
			} else if(categoryType == "AreaCategory3DAxisGlyph") {
				this.categoryAxisGlyph = new AreaCategory3DAxisGlyph(js.categoryAxisGlyph);
			}
		}
		
		this.isStacked = js.isStacked == undefined ? false : js.isStacked;
		
		CategoryPlotGlyph.superclass.initConstants.apply(this, [js]);	
	},
	
	layoutAxisGlyph		:		function() {
		// ȼaxisLabelWidth, Ȼȥȷ plotBounds. Ȼȥcalculate
    	this.categoryAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
    	this.valueAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
		
		this.categoryAxisGlyph.calculateAxisGlyph(this.getBounds());
		this.valueAxisGlyph.calculateAxisGlyph(this.getBounds());
		
		var background = this.getInfo().getBackground();
//		if(background instanceof IntervalColorBackground) {
//			background.setIntervalLength(this.valueAxisGlyph.getUnit()*this.valueAxisGlyph.getUnitLen());
//		}
	},
	
	 /**
     * kunsnat: άͼе3DAxisGlyphв 
     */
     layout3DAxisGlyph 		:		function() {
     	var plotWidth = this.getBounds().getWidth();
     	var plotHeight = this.getBounds().getHeight();
     	
     	var cubic = new Cubic();
     	
     	cubic.setProjection(this.getProjection());
     	cubic.setInfo(this.getInfo());
     	
     	var deep = this.getDeep();
     	if(deep == -1) {
     		deep = plotWidth;
     	}
     	// ע: ߵcubic.zֵ0, Ĭϱһ.
     	cubic.setCubic(0,0,0,plotWidth,plotHeight,deep);
     	cubic.setCovers(new Array(Cubic.prototype.BACK, Cubic.prototype.LEFT, Cubic.prototype.BOTTOM));
     	
     	this.categoryAxisGlyph.setCubic(cubic);
     	this.valueAxisGlyph.setCubic(cubic);
     },
	
	draw		:		function(ctx, time, xylist, actionModel) {
		ctx.translate(this.getBounds().getX(),this.getBounds().getY());
	
		if(this.valueAxisGlyph != null) {
			this.valueAxisGlyph.draw(ctx);
		}
		if(this.categoryAxisGlyph != null) {
			this.categoryAxisGlyph.draw(ctx);
		}
		ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
	
		CategoryPlotGlyph.superclass.draw.apply(this,[ctx, time, xylist, actionModel]);
	},
	
	
	getDataPointPercentValue		:		function(seriesIndex, categoryIndex)
	{
	
		var valueAxis = this.valueAxisGlyph.getAxis();
		var dataPointValue = this.getSeries(seriesIndex).getDataPoint(categoryIndex).getValue();
		
		if(!valueAxis.getIsPercentage()) {
			return dataPointValue;
		}
	
		var cateSum = 0;
		for(var series = 0; series < this.getSeriesSize(); series++) {
			var dataSeries = this.getSeries(series);
			cateSum = cateSum + dataSeries.getDataPoint(categoryIndex).getValue();
		}
		
		if(cateSum == 0)return 0;
		
		return dataPointValue/cateSum;
	},
	
	getValueAxisGlyph		:		function() {
		return this.valueAxisGlyph;
	},
	
	setValueAxisGlyph		:		function(valueAxisGlyph) {
		this.valueAxisGlyph = valueAxisGlyph;
	},
	
	getCategoryAxisGlyph		:		function() {
		return this.categoryAxisGlyph;
	},
	
	setCategoryAxisGlyph		:		function(categoryAxisGlyph) {
		this.categoryAxisGlyph = categoryAxisGlyph;
	},
	
	setStacked		:		function(isStacked) {
		this.isStacked = isStacked;
	},
	
	getIsStacked		:		function() {
		return this.isStacked;
	}
});

function BarPlotGlyph(js) {
	this.initConstants(js);
}

FR.extend(BarPlotGlyph, CategoryPlotGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		
		this.isHorizontal = js.isHorizontal == undefined ? false : js.isHorizontal;
		this.seriesOverlapPercent = js.seriesOverlapPercent == undefined ? 0 : js.seriesOverlapPercent;
		this.categoryIntervalPercent = js.categoryIntervalPercent == undefined ? 2 : js.categoryIntervalPercent;
		
		BarPlotGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	setSeriesOverlapPercent		:		function(seriesOverlapPercent) {
		 this.seriesOverlapPercent = seriesOverlapPercent;
	},
	
	getSeriesOverlapPercent		:		function(){
		 return this.seriesOverlapPercent;
	},
	
	setCategoryIntervalPercent		:		function(categoryIntervalPercent){
		this.categoryIntervalPercent = categoryIntervalPercent;
	},
	
	getCategoryIntervalPercent		:		function(){
		return this.categoryIntervalPercent;
	},
	
	setHorizontal		:		function(isHorizontal){
		this.isHorizontal = isHorizontal;
		
		// ע BarPlot
		if(isHorizontal) {
			this.getValueAxisGlyph().getAxis().setPosition(Constants.prototype.BOTTOM);
			this.getCategoryAxisGlyph().getAxis().setPosition(Constants.prototype.LEFT);
		} 
	},
	
	getIsHorizontal		:		function(){
		return this.isHorizontal;
	},
	
	getBarShape		:		function(seriesIndex, categoryIndex) {
		var bar_percent = this.getBarPercent(this.getSeriesSize());
		var bar_begin_percent = bar_percent * (1 - this.getSeriesOverlapPercent()) * seriesIndex + categoryIndex + 
	                                0.5 * this.getCategoryIntervalPercent() * bar_percent;
	 	var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
	
		var x, y, width, heigh;
	
		if(this.isHorizontal) {
			y = this.getCategoryAxisGlyph().getPoint2D(bar_begin_percent + bar_percent).getY();
			height = this.getCategoryAxisGlyph().getUnitLen() * bar_percent;
	    		
    		if (this.getIsStacked()) {
    			var pre_sum = 0;	// ǰϵеĳ
    			
    			for (var i = seriesIndex - 1; i >= 0; i --) {
    				pre_sum += this.getDataPointPercentValue(i, categoryIndex);
    			}
    			
    			x = this.getValueAxisGlyph().getPoint2D(pre_sum).getX();
    			width = this.getValueAxisGlyph().getPoint2D(pre_sum + value).getX() - x;
    		} else {    			
    			x = this.getValueAxisGlyph().getPoint2D(0).getX();
    			width = this.getValueAxisGlyph().getPoint2D(value).getX();
    		}
    	} else {
    		x = this.getCategoryAxisGlyph().getPoint2D(bar_begin_percent).getX();
       		width = this.getCategoryAxisGlyph().getUnitLen() * bar_percent;
       		
       		if (this.getIsStacked()) {
       			var pre_sum = 0;
       			for (var i = seriesIndex - 1; i >= 0; i --) {
       				pre_sum += this.getDataPointPercentValue(i, categoryIndex);
       			}
       			
       			y = this.getValueAxisGlyph().getBounds().getY() 
       			    + this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
       			
       			height = this.getValueAxisGlyph().getPoint2D(pre_sum).getY() 
       			    - this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
       		} else {
       			y = this.getValueAxisGlyph().getBounds().getY() 
       			    + this.getValueAxisGlyph().getPoint2D(value).getY();
       			
       			height = this.getValueAxisGlyph().getBounds().getHeight() 
       			         - this.getValueAxisGlyph().getPoint2D(value).getY();
       		}
    	}
    	
    	var bounds = new Bounds(x, y, width, height);
    	bounds.isHorizontal4Bounds = this.isHorizontal;
    	
    	return bounds;
	},
	
	getBarPercent		:		function(seriesCount) {
		return 1.0 / (seriesCount - ((seriesCount - 1 ) * this.getSeriesOverlapPercent()) +  this.getCategoryIntervalPercent());
	},
	
	/**
	 * ȡûͼͼϵĿϢ.ھʾ.
	 * @param seriesIndex ϵ
	 * @param categoryIndex 
	 * @param categoryAxisGlyph
	 * @param valueAxisGlyph
	 * @param customPlotGlyph
	 * @param barNumber ӵĿ
	 * @param barIndex ʵʵĵڼ
	 * @return
	 */
	getBarShape4CustomPlot 	:	function(seriesIndex, categoryIndex, categoryAxisGlyph, valueAxisGlyph, customPlotGlyph, barNumber, barIndex) {
		// ȷ
		var bar_percent = this.getBarPercent(barNumber);
		var bar_begin_percent = bar_percent * (1 - this.getSeriesOverlapPercent() ) 
		       * barIndex + categoryIndex + 0.5 * this.getCategoryIntervalPercent() * bar_percent;
		var value = customPlotGlyph.getDataPointPercentValue(seriesIndex, categoryIndex);
		
		var x, y, width, height;
		
		x = categoryAxisGlyph.getPoint2D(bar_begin_percent).getX();
		width = categoryAxisGlyph.getUnitLen() * bar_percent;
		
		if (this.getIsStacked()) {
			var pre_sum = 0;
			for (var i = barIndex - 1; i >= 0; i --) {
				pre_sum += customPlotGlyph.getDataPointPercentValue(i, categoryIndex);
			}
			
			y = valueAxisGlyph.getBounds().getY() + valueAxisGlyph.getPoint2D(pre_sum + value).getY();
			
			height = valueAxisGlyph.getPoint2D(pre_sum).getY() - valueAxisGlyph.getPoint2D(pre_sum + value).getY();
		} else {
			y = valueAxisGlyph.getBounds().getY() + valueAxisGlyph.getPoint2D(value).getY();
			height = valueAxisGlyph.getBounds().getHeight() - valueAxisGlyph.getPoint2D(value).getY();
		}
    	
    	return new Bounds(x, y, width, height);
	},
	
	// animateGlyph, εĶѻ, ǶԷл
	createCateAnimateGlyph	:	function() {
		this.cateAnimateGlyph = [];
		for(var cate = 0; cate < this.getSeries(0).getDataPointCount(); cate++) {
			this.cateAnimateGlyph[cate] = [];
			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				this.cateAnimateGlyph[cate] = this.cateAnimateGlyph[cate].concat(this.getSeries(i).getDataPoint(cate).animateGlyph)
			}
		}
	},
	
	getCateAnimateStepNumber	:	function() {
		return this.cateAnimateGlyph[0].length;
	},
	
	drawCateAnimateGlyph	:	function(ctx, count) {
		for(var i = 0; i < this.getSeries(0).getDataPointCount(); i++) {
			this.cateAnimateGlyph[i][count].draw(ctx);
		}
	}
});

function Bar2DPlotGlyph(js) {
	this.initConstants(js);
}

FR.extend(Bar2DPlotGlyph, BarPlotGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		
		this.isSimulation3D = js.isSimulation3D == undefined ? false : js.isSimulation3D;
		
		Bar2DPlotGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	layoutDataSeriesGlyph		:		function(){
		for(var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex++) {
			var dataSeries = this.getSeries(seriesIndex);
			
			for(var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex++) {
				var dataPoint = dataSeries.getDataPoint(categoryIndex);
				
				var shapeGlyph = new ShapeGlyph();
				dataPoint.setGlyph(shapeGlyph);
				
				if(this.isSimulation3D) {
					var info = new General3DInfo();
					info.isHorizontal = this.isHorizontal;
					shapeGlyph.setInfo(info);
				}
	
				shapeGlyph.setShape(this.getBarShape(seriesIndex, categoryIndex));
				shapeGlyph.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				
				this.dealDataPointLabelBounds(dataPoint, seriesIndex);
			}
		}
	},
	
	// kunsnat: ,ΪҪͼλ
	dealDataPointLabelBounds	:	function(dataPoint, seriesIndex) {
		var glyph = dataPoint.getDataLabel();
		if(glyph instanceof TextGlyph) {
			var attrPosition = this.getSeriesCollection().getSeriesCondition(new SeriesAttrPosition(), seriesIndex);					
			glyph.preferredLabelBounds(dataPoint, attrPosition.getPosition());
			
			if(this.getIsHorizontal()) {
				this.resetDataLabelBounds(glyph, attrPosition.getPosition(), dataPoint.getShape().getBounds2D());
			}
		}
	},
	
	resetDataLabelBounds 	:		function(textGlyph, position, rect) {
		var dim = textGlyph.preferredDimension();
		
		if(position == Constants.prototype.AXISINSIDE) {
			textGlyph.setBounds(new Bounds(
					rect.getX(), rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, 
					dim.getWidth(), dim.getHeight()
			));
		} else if(position == Constants.prototype.INSIDE) {
			textGlyph.setBounds(new Bounds(
					rect.getX() + rect.getWidth() - dim.getWidth(), 
					rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, 
					dim.getWidth(), dim.getHeight()
			));
		} else if(position == Constants.prototype.OUTSIDE) {
			textGlyph.setBounds(new Bounds(
					rect.getX() + rect.getWidth(), 
					rect.getY() + (rect.getHeight() - dim.getHeight()) / 2.0, 
					dim.getWidth(), dim.getHeight()
			));
		} 
	},
	
	draw		:		function(ctx, time, xylist) {
		this.drawInfo(ctx);
		
		Bar2DPlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
	}
});

	function	LinePlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(LinePlotGlyph, CategoryPlotGlyph, {
		initConstants	:		function(js) {
			js = js || {};
			
			this.isShowLine = js.isShowLine == undefined ? true : js.isShowLine;
			this.isShowMarker = js.isShowMarker == undefined ? true : js.isShowMarker;
			
			LinePlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutDataSeriesGlyph	:	function() {
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var linePaths = new GeneralPath();
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					// ֱֵ һ.
					if(dataPoint.valueIsNull) {
						continue;
					}
					
					var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
					
					var point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX();				
					var point_y;
					
					if (this.getIsStacked()) {
						var pre_sum = 0;	
						for (var i = seriesIndex - 1; i >= 0; i --) {
		    				pre_sum += this.getDataPointPercentValue(i, categoryIndex);
		    			}
		    			
		    			point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
					} else {
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(value).getY();
					}
					
					// kunsnat: ֵмֵ, getAnimate generalpathʱ, 
					linePaths.centerValue = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getBounds().getHeight() / 2;
					
					if (categoryIndex == 0) {
						linePaths.moveTo(point_x, point_y);
					} else {
						linePaths.lineTo(point_x, point_y);
					}
					
					if(this.getIsShowMarker()) {
						var markerGlyph = new MarkerGlyph();
						markerGlyph.dealCondition4Line(this.getSeriesCollection(), seriesIndex);
						markerGlyph.setShape(new Bounds(point_x - 5, point_y - 5, 10, 10));
	
						dataPoint.setGlyph(markerGlyph);
					} else {
						dataPoint.setShape(new Bounds(point_x - 5, point_y - 5, 10, 10));
					}
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
				
				if (this.getIsShowLine()) {
					var foldLine = new FoldLine(linePaths); 
					dataSeries.setGlyph(foldLine);
					
					foldLine.getLineStyleInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				}
	    	}
		},
		
		draw	:		function(ctx, time, xylist) {
			ctx.translate(this.getBounds().getX(),this.getBounds().getY());
			
			this.drawInfo(ctx);
			
			if(this.valueAxisGlyph != null) {
				this.valueAxisGlyph.draw(ctx);
			}
			if(this.categoryAxisGlyph != null) {
				this.categoryAxisGlyph.draw(ctx);
			}

			xylist.push(this.getBounds().getX());
			xylist.push(this.getBounds().getY());

			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				var stepNumber = 12;
				this.getSeries(i).getAnimateGlyph(stepNumber);
			}
			
			this.animateGlyphDraw(ctx, time, this.getSeries(0).getAnimateStepNumber(), xylist);
			
			ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
		},
		
		animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
			var plotGlyph = this;
			var count = 0;
			
			var id = setInterval(function() {
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(xylist[i], xylist[i+1]);
				}
				
				// kunsnat: FFָհ, IETMȫɫ
//				ctx.clearRect(0,0,plotGlyph.getBounds().getWidth(), plotGlyph.getBounds().getHeight());
				
				for(var i = 0; i < plotGlyph.getSeriesSize(); i++) {
					plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
				}
				
				count++;
				
				if(count > stepNumber - 1) {
					clearInterval(id);
					for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
						plotGlyph.getSeries(i).drawLabel(ctx);
						
						var dataPoints = plotGlyph.getSeries(i).getPoints();
					    for (var j=0; j < dataPoints.length; j++ ) {
							dataPoints[j].draw(ctx);
					    }
					}
					
					plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
				}
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(-xylist[i], -xylist[i+1]);
				}
			}, time/stepNumber);
		},
		
		setShowLine		:		function(isShowLine) {
			this.isShowLine	= isShowLine;
		},
		
		getIsShowLine	:		function() {
			return this.isShowLine;
		},
		
		setShowMarker	:		function(isShowMarker) {
			this.isShowMarker = isShowMarker;
		},
		
		getIsShowMarker	:		function() {
			return this.isShowMarker;
		}
	});
	
	function	PiePlotGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(PiePlotGlyph, PlotGlyph, {
		initConstants		:		function(js) {
			js = js || {};
			
			this.startAngle = js.startAngle == undefined ? 0 : js.startAngle;
			this.separatePercent = js.separatePercent == undefined ? 10 : js.separatePercent;
			
			PiePlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			// do nothing;
		},
		
		layoutDataSeriesGlyph		:		function() {
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var D = this.getPieDimension(dataSeries);
		        var radius = D / ( 2 + 2 * this.getSeparatePercent() / 100.0);
				
		        var seriesStartAngle = this.getStartAngle();
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					dataPoint.setPercentValue(this.getPercent(categoryIndex));
					dataPoint.setGlyph(this.getDataPointShape(categoryIndex, seriesStartAngle, radius));
					
					this.dealDataPointLabelBounds(dataPoint, categoryIndex, seriesIndex, seriesStartAngle, radius);
					
					seriesStartAngle = seriesStartAngle + this.getPercent(categoryIndex) * 360;
				}
			}
		},
		
		// labelbounds ǣ
		dealDataPointLabelBounds		:	function(dataPoint, categoryIndex, seriesIndex, seriesStartAngle, radius) {
			var dataLabel = dataPoint.getDataLabel();
			if(dataLabel instanceof TextGlyph) {
				// ȷLabelbounds,Ȼȷǣ
				this.getLeadLine(dataPoint, dataLabel, categoryIndex, seriesStartAngle + 0.5 * this.getPercent(categoryIndex) * 360, radius);
			}
		},
		
		getPieDimension		:		function(dataSeries) {
			var plotBounds = this.getBounds();
			var resultD = Math.min(plotBounds.getWidth(), plotBounds.getHeight());
			resultD = this.deal4BestRad(dataSeries, resultD);
			
			return resultD;
		},
		
		deal4BestRad		:		function(dataSeries, resultD) {
			for(var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
				var attrContents = this.getSeriesCollection().getSeriesCondition(new SeriesAttrContents(), categoryIndex);
				if(attrContents.getIsShowGuidLine()) {
					resultD = (resultD - 28) * 0.8;
					return resultD;
				}
			}
			return resultD;
		},
		
		getDataPointShape 		:		function(categoryIndex, start, radius) {
			var plotBounds = this.getBounds();
	    	var plotCenterPoint = new Point2D(plotBounds.getWidth() / 2, plotBounds.getHeight() / 2);
	    	
	    	var distance = this.getSeparatePercent() / 100.0 * radius;	
	    	var halfAngle = start + 0.5 * this.getPercent(categoryIndex) * 360;
	    	
	    	// getYĴ + 
			var resultShape = new ShapeGlyph();
			
			var startAngle = (360 - start - this.getPercent(categoryIndex) * 360) % 360;
			var endAngle = (360 - start) % 360;
			// kunsnat: startΪ0ʱ, endAngleҲΪ0, ᵼ¶໭һȦ. (270 -- 0) ˳ʱ, ԸΪ(270--360)ͽ
			if(start == 0) {
				endAngle = 360;
			} 
			resultShape.shape = new Arc2D(
			 		//  360 - halAngle ǶȲͬjava
					plotCenterPoint.getX() + distance * Math.cos((360 - halfAngle) * Math.PI / 180),
					plotCenterPoint.getY() + distance * Math.sin((360 - halfAngle) * Math.PI / 180), 
					// kunsnat: javaеĽǶ㷨һ, javaxʱǶ
					// jsx, ˳ʱǶ. Ҫ 360ȡ
					radius, startAngle, endAngle	
			);
			
			resultShape.getInfo().dealCondition(this.getSeriesCollection(), categoryIndex);
	
			return resultShape;
		},
		
		getLeadLine		:		function(dataPoint, textGlyph, categoryIndex, halfAngle, r) {
			var plotBounds = this.getBounds();
			
			var tg_width = textGlyph.preferredDimension().getWidth();
			var tg_height = textGlyph.preferredDimension().getHeight();
			
			var attrPosition = this.getSeriesCollection().getSeriesCondition(new SeriesAttrPosition(), categoryIndex);
		  	var attrContents = this.getSeriesCollection().getSeriesCondition(new SeriesAttrContents(), categoryIndex);
			
			var pieLabel = textGlyph.getText();
			if(pieLabel != null) {
				var seriesBounds = dataPoint.getShape().getBounds2D();
				var sx = seriesBounds.getX(), sy = seriesBounds.getY(), sw = seriesBounds.getWidth(), sh = seriesBounds.getHeight();
				var centerLabelx = sx + (sw - textGlyph.preferredDimension().getWidth())/2, 
					centerLabely = sy + (sh - textGlyph.preferredDimension().getHeight())/2;
				
				// ñͼ ԲĴλ. ɢ뾶1.5ҵ ǣ߳
				var centerSx = plotBounds.getWidth()/2.0, 
					centerSy = plotBounds.getHeight()/2.0;
				
				if(attrPosition.getPosition() == Constants.prototype.OUTSIDE) {
					// Ƿ̶.  ǣߴǱͼ뾶һ
					var rad = r + r * this.getSeparatePercent() /100;
					
					// ȡģ Χ360.
					var tmpAngle = halfAngle % 360;
					// 뾶x yͶӰֵ  Ҫõ1.3İ뾶 
					var leadx = this.getLeadLineX(tmpAngle, rad * 1.5);
					var leady = this.getLeadLineY(tmpAngle, rad * 1.5);
					// ǩλ
					var tgx1 = centerSx + leadx;
					var tgy1 = centerSy + leady;
					// ǩλ Բʱ xλ һǩĿ
					if(leadx < 0) {
						tgx1 = tgx1 - tg_width;
					}
					if(tmpAngle >= 45 && tmpAngle < 130) {
						tgy1 = tgy1 + tg_height/2.0;
					}
					if(tmpAngle >= 230 && tmpAngle < 300) {
						tgy1 = tgy1 - tg_height;
					}
					// kunsnat: ǩλújavaеĲͬ +12;
					textGlyph.setBounds(new Bounds(tgx1, tgy1 + 12, tg_width, tg_height));
					
					if(attrContents.getIsShowGuidLine()) {
						var line = null;
						var x2 = textGlyph.getBounds().getX(), y2 = textGlyph.getBounds().getY() - 12;
						
						// kunsnat: ͨǶȷΧ  ǣָıǩλ
						if(tmpAngle >= 0 && tmpAngle < 45 || tmpAngle >= 315 && tmpAngle < 360) {
							y2 = y2 + tg_height/2.0;
						} else if(tmpAngle >= 45 && tmpAngle < 135) {
							y2 = y2 + tg_height;
							x2 = x2 + tg_width/2.0;
						} else if(tmpAngle >= 135 && tmpAngle < 225) {
							x2 = x2 + tg_width;
							y2 = y2 + tg_height/2.0;
						} else if(tmpAngle >= 225 && tmpAngle < 315) {
							x2 = x2 + tg_width/2.0;
						} 
						// Բλ  + 뾶xyͶӰֵ.  ǩĺλ.
						line = new Line2D(
									new Point2D(centerSx + this.getLeadLineX(tmpAngle, rad), centerSy + this.getLeadLineY(tmpAngle, rad)),
									new Point2D(x2, y2)
								);
						dataPoint.setLeadLine(line);
					} 
				} else {
					// λþеʱͲǣ.
					textGlyph.setBounds(new Bounds(centerLabelx, centerLabely  + tg_height, tg_width, tg_height));
				}
			}
		},
		
		getLeadLineX		:		function(extent, rad) {
			return rad * Math.cos(extent * Math.PI / 180);
		},
		
		getLeadLineY		:		function(extent, rad) {
			return -(rad * Math.sin(extent * Math.PI / 180));
		},
		
		getTotalValue		:		function() {
			var totalValue = 0;
			var tmpValue;
			
			var dataSeries = this.getSeries(0);
			for(var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex++) {
				tmpValue = dataSeries.getDataPoint(categoryIndex).getValue();
				// Եֵ.
				totalValue = totalValue + Math.abs(tmpValue);
			}
			
			return totalValue;
		},
		
		getPercent		:		function(categoryIndex) {
			var value = this.getSeries(0).getDataPoint(categoryIndex).getValue();
			
			return Math.abs(value)/ this.getTotalValue();
		},
		
		setStartAngle		:		function(startAngle) {
			this.startAngle = startAngle;
		},
		
		getStartAngle		:		function() {
			return this.startAngle;
		},
		
		setSeparatePercent		:		function(separatePercent) {
			this.separatePercent = separatePercent;
		},
		
		getSeparatePercent 		:		function() {
			return this.separatePercent;
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			PiePlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
		}
	});
	
	function	Arc2D(x, y, radius, start, end) { 
		this.x = x;
		this.y = y;
		this.radius = radius;
		this.start = start;
		this.end = end;
	}
	
	Arc2D.prototype = {
		x	:	0,
		y	:	0,
		radius	:	0,
		start	:	0,
		end		:	0,
		
		getX	:	function() {
			return this.x;
		},
		
		setX	:	function(x) {
			this.x = x;
		},
		
		getY	:	function() {
			return this.y;
		},
		
		setY	:	function(y) {
			this.y = y;
		},
		
		getRadius	:	function() {
			return this.radius;
		},
		
		setRadius	:	function(r) {
			this.radius	= r;
		},
		
		getStart	:	function() {
			return this.start;
		},
		
		setStart	:	function(start) {
			this.start = start;
		},
		
		getEnd	:	function() {
			return this.end;
		},
		
		setEnd	:	function(end) {
			this.end = end;
		},
		
		paint	:	function(ctx, time, xylist) {
			if(time) {
				this.animateArc2DDraw(ctx, time, xylist)
			} else {
	
				ctx.beginPath();
				ctx.arc(this.x, this.y, this.radius, (this.start - 1)* Math.PI / 180, (this.end + 1) * Math.PI / 180, false);
				ctx.fill();
				
				var startDegrees = this.start * Math.PI / 180;
				var endDegrees = this.end * Math.PI / 180;
				
				var startX = this.x + Math.cos(startDegrees) * this.radius;
				var startY = this.y + Math.sin(startDegrees) * this.radius;
				
				var endX = this.x + Math.cos(endDegrees) * this.radius;
				var endY = this.y + Math.sin(endDegrees) * this.radius;
				
				ctx.beginPath();
				ctx.moveTo(this.x, this.y);
				ctx.lineTo(startX, startY);
				ctx.lineTo(endX, endY);
				ctx.fill();
				
				// ε, ΪFillʱһ
//				ctx.stokeStyle = ctx.fillStyle;
//				// kunsnat: ߺɫ޲ǰеȱʧ .
//				ctx.lineWidth = 1;
//				
//				ctx.beginPath();
//				ctx.moveTo(startX, startY);
//				ctx.lineTo(endX, endY);
//				ctx.stroke();
			}
		},
		
		getAnimateShape	:	function(step) {
			var arcArray = [];
			for(var i = 0; i < step; i++) {
				arcArray[i] = new Arc2D(this.x,this.y,this.radius,this.start,this.start+(this.end-this.start)*(i + 1)/step);
			}
			
			return arcArray;
		},
		
		// Pie3Dõ.. Ե  
		draw	:	function(ctx) {
			ctx.save();
			
			ctx.fillStyle = "red";
			this.paint(ctx);
			
			ctx.restore();
		},
		
		stroke	:	function(ctx) {
			ctx.beginPath();
			ctx.moveTo(this.x, this.y);
			ctx.arc(this.x, this.y, this.radius, this.start * Math.PI/180, this.end * Math.PI/180, false);
			ctx.lineTo(this.x, this.y);
			
			ctx.stroke();
		},
		
		// ֵֻ߲stroke, Strokeǻεstroke
		stroke4Meter	:	function(ctx) {
			var angle = 360 - this.start % 360;
			ctx.beginPath();
			ctx.moveTo(this.x + this.radius * Math.cos(angle * Math.PI /180), 
						this.y - this.radius * Math.sin(angle * Math.PI / 180));
			ctx.arc(this.x, this.y, this.radius, this.start * Math.PI/180, this.end * Math.PI/180, false);
			ctx.stroke();
		},
		
		getStartPoint	:	function() {
			var angle = this.getStart() * Math.PI/ 180;
			var x = this.getX() + (Math.cos(angle) * 0.5 + 0.5) * this.getRadius();
			var y = this.getY() + (Math.sin(angle) * 0.5 + 0.5) * this.getRadius();
			return new Point2D(x, y);
		},
		
		getEndPoint	:	function() {
			var angle = this.getEnd() * Math.PI / 180;
			var x = this.getX() + (Math.cos(angle) * 0.5 + 0.5) * this.getRadius();
			var y = this.getY() + (Math.sin(angle) * 0.5 + 0.5) * this.getRadius();
			return new Point2D(x, y);
		},
		
		getBounds2D	:	function() {
			//  kunsnat: õ㷨. ģjava. (ôнPieж)
			var x1, y1, x2, y2;
			 
			x1 = y1 = x2 = y2 = 0.0;
			var angle = 360.0;
			for (var i = 0; i < 6; i++) {
			    if (i < 4) {
					angle -= 90.0;
					if (!this.containsAngle(angle)) {
					    continue;
					}
			    } else if (i == 4) {
					angle = this.getEnd();
			    } else {
					angle = this.getStart();
			    }
			    var rads = angle * Math.PI / 180.0;
			    var xe = Math.cos(rads);
			    var ye = Math.sin(rads);
			    x1 = Math.min(x1, xe);
			    y1 = Math.min(y1, ye);
			    x2 = Math.max(x2, xe);
			    y2 = Math.max(y2, ye);
			}
			var w = this.getRadius() * 2;
			var h = this.getRadius() * 2;
			x2 = (x2 - x1) * 0.5 * w;
			y2 = (y2 - y1) * 0.5 * h;
			x1 = this.getX() + (x1 * 0.5) * w;
			y1 = this.getY() + (y1 * 0.5) * h;
			return new Bounds(x1, y1, x2, y2);
		},
		
//		getLineGradient	:	function(ctx, isHorizontal) {
//			if(this.lineGradient) {
//				return this.lineGradient;
//			}
//			var bounds = this.getBounds2D();
//			if(isHorizontal) {
//				this.lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height);
//			} else {
//				this.lineGradient = ctx.createLinearGradient(bounds.x, bounds.y, bounds.x + bounds.width, bounds.y);
//			}
//			return this.lineGradient;
//		},
		
		containsAngle	:	function(angle) {
			// ȼ򵥴, Ϊͼ angleһֻ0360֮
			return angle >= this.start && angle <= this.end;
		}
	}
	
	function	AreaPlotGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(AreaPlotGlyph, CategoryPlotGlyph, {
		initConstants	:	function(js) {
			AreaPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutDataSeriesGlyph		:		function() {
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var areaPaths = new GeneralPath();
				var sg = new ShapeGlyph();
				sg.shape = areaPaths;
				dataSeries.setGlyph(sg);
				sg.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				
				// ׼
				var pre_value = [];
				
				var point_x = this.getCategoryAxisGlyph().getPoint2D(0.0).getX();
				var point_y = this.getValueAxisGlyph().getPoint2D(this.getValueAxisGlyph().getCrossValue()).getY();
				areaPaths.moveTo(point_x, point_y);
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
					
					point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX();
					// Сֵ.
					var pre_sum = this.getValueAxisGlyph().getCrossValue();
					if (this.getIsStacked()) {
		    			for (var i = seriesIndex - 1; i >= 0; i --) {
		    				pre_sum += this.getDataPointPercentValue(i, categoryIndex);
		    			}
		    			
		    			point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
					} else {
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(value).getY();
					}
					
					// 䶯 α..
					dataPoint.setShape(new Arc2D(point_x - 3, point_y + 12, 6, 0,360));
					
					pre_value[categoryIndex] = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum).getY();
					areaPaths.lineTo(point_x, point_y);
					
					// : ȡPlotGlyph
					var glyph = dataPoint.getDataLabel();
					if(glyph instanceof TextGlyph) {
						var attrPosition = this.getSeriesCollection().getSeriesCondition(new SeriesAttrPosition(), seriesIndex);					
						glyph.preferredLabelBounds(dataPoint, attrPosition.getPosition());
					}
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
				
				for (var i = pre_value.length - 1; i >= 0; i --) {
					areaPaths.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX(), pre_value[i]);
				}
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			AreaPlotGlyph.superclass.draw.apply(this, [ctx, time, xylist, "AreaPlotGlyph"]);
		},
		
		// ͼ, animateGlyph, еĽл(Ǻ3Dͼõ)
		createCateAnimateGlyph	:	function() {
			this.cateAnimateGlyph = [];
			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				this.cateAnimateGlyph = this.cateAnimateGlyph.concat(this.getSeries(i).animateGlyph)
			}
		},
		
		getCateAnimateStepNumber	:	function() {
			return this.cateAnimateGlyph.length;
		},
		
		drawCateAnimateGlyph	:	function(ctx, count) {
			this.cateAnimateGlyph[count].draw(ctx);
		}
	});

	function	Ellipse2D(x, y, width, height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	Ellipse2D.prototype = {
		x	:	0,
		y	:	0,
		width	:	0,
		height	:	0,
		
		getX	:	function() {
			return this.x;
		},
		
		setX	:	function(x) {
			this.x = x;
		},
		
		getY	:	function() {
			return this.y;
		},
		
		setY	:	function(y) {
			this.y = y;
		},
		
		getWidth	:	function() {
			return this.width;
		},
		
		setWidth	:	function(width) {
			this.width = width;
		},
		
		getHeight	:	function() {
			return this.height;
		},
		
		setHeight	:	function(height) {
			this.height = height;
		},
		
		// TODO
		draw	:	function(ctx) {
			this.paint(ctx);
		},
		
		paint	:	function(ctx) {
			var x = this.x;
			var y = this.y;
			var a = this.width;
			var b = this.height;
			// ԲĻ
			var px, py;   
            var d1, d2;   
            px = 0;   
            py = b;   
            d1 = b * b + a * a * (-b + 0.25);   
            this.point(x + px, y + py);   
            this.point(x - px, y - py);   
            this.point(x - px, y + py);   
            this.point(x + px, y - py);   
            while (b * b * (px + 1) < a * a * (py - 0.5)) {   
                if (d1 <= 0) {   
                    d1 += b * b * (2 * px + 3);   
                    px++;   
                } else {   
                    d1 += b * b * (2 * px + 3) + a * a * (-2 * py + 2);   
                    px++;   
                    py--;   
                }   
                this.point(x + px, y + py);   
                this.point(x - px, y - py);   
                this.point(x - px, y + py);   
                this.point(x + px, y - py);   
            }   
            d2 = b * b * (px + 0.5) * (px + 0.5) + a * a * (py - 1) * (py - 1) - a * a * b * b;   
            while (py > 0) {   
                if (d2 <= 0) {   
                    d2 += b * b * (2 * px + 2) + a * a * (-2 * py + 3);   
                    px++;   
                    py--;   
                } else {   
                    d2 += a * a * (-2 * py + 3);   
                    py--;   
                }   
                this.point(x + px, y + py);   
                this.point(x - px, y - py);   
                this.point(x - px, y + py);   
                this.point(x + px, y - py);   
            }   
			
		},
		
		point	:	function(x, y) {   
            var pos = this.pos();   
            var size = this.size();   
            x = pos.x + x;   
            y = pos.y + y;   
               
            // ڱ߽ʾ,򲻽õ뻺   
            if (!((x >= pos.x && x <= pos.x + size.width)   
                && (y >= pos.y && y <= pos.y + size.height)))   
                return;   
        },
        
        pos	:	function() {   
            var rect = document.getElementById('canvas').getClientRects()[0];   
            return {   
                x: rect.left,   
                y: rect.top   
            };   
        }, 
        
       size	:	function(w, h) {
       	var canvas = document.getElementById('canvas');
			if (w && h) {
				if (cache.length != 0) return;
				canvas.style.width = w + "px";
				canvas.style.height = h + "px";
			} else {
				return {
					width: parseInt(canvas.style.width),
					height: parseInt(canvas.style.width)
				};
			}
		}
		
	}
	
	/**
	 * άͼͶӰ任
	 * 任ʱ XңY£ZĻг
	 * 1.ͶӰ
	 * 2.͸ͶӰ
	 * 3.ֱϵ(Excel)
	 *
	 */
	function Projection(js) {
		this.initConstants(js);
	}
	
	Projection.prototype = {
		
		// ͶӰ
		ORTHO	:	0,
		// ͸ͶӰ
		PERSPECTIVE	:	1,
		// ֱͶӰ
		RIGHT_ANGLE	:	2,

		initConstants	:	function(js) {
			js = js || {};
			
			this.mode = js.mode == undefined ? 2 : js.mode;
			this.elevation = js.elevation == undefined ? 15 : js.elevation;
			this.rotation = js.rotation == undefined ? 20 : js.rotation;
			this.focus = js.focus == undefined ? 800 : js.focus;
			
			this.need_cal = js.need_cal == undefined ? true : js.need_cal;
			this.sin_theta_alpha = js.sin_theta_alpha == undefined ? 0 : js.sin_theta_alpha;
			this.cos_theta_alpha = js.cos_theta_alpha == undefined ? 0 : js.cos_theta_alpha;
			this.sin_theta_beta = js.sin_theta_beta == undefined ? 0 : js.sin_theta_beta;
			this.cos_theta_beta = js.cos_theta_beta == undefined ? 0 : js.cos_theta_beta;
		},
		
		getFocus	:	function() {
			return this.focus;
		},
		
		setFocus	:	function(focus) {
			this.focus = focus;
		},
		
		getRotation	:	function() {
			return this.rotation;
		},
		
		setRotation	:	function(rotation) {
			this.rotation = rotation;
			
			if(!this.need_cal) {
				this.need_cal = true;
			}
		},
		
		getElevation	:	function() {
			return this.elevation;
		},
		
		setElevation	:	function(elevation) {
			this.elevation = elevation;
			
			if(!this.need_cal) {
				this.need_cal = true;
			}
		},
		
		getMode	:	function() {
			return this.mode;
		},
		
		setMode	:	function(mode) {
			this.mode = mode;
		},
		
		/**
		 * ͶӰά굽άƽ
		 */
		projectee	:	function(x, y, z) {
			this.calculateSINCOS();
			
			if (this.mode == Projection.prototype.ORTHO) {
				return this.ortho_projectee(x, y, z);
			} else if (this.mode == Projection.prototype.PERSPECTIVE) {
				return this.perspective_projectee(x, y, z);
			} else if (this.mode == Projection.prototype.RIGHT_ANGLE) {
				return this.right_angle_projectee(x, y, z);
			} else {
				return new Point2D(x, y);
			}
		},
		
		/**
		 * ͶӰһԲ
		 */
		projecteeArc	:	function(y, R, start, extent) {
			this.calculateSINCOS();
		
			var factor = this.focus / (
					this.sin_theta_alpha * y + this.focus
					);
			
			// TODO Arc  radius = ? 2 * R * factor, 2 * R * factor * sin_theta_alpha
			var arc2D = new Arc2D(0, y * this.cos_theta_alpha * factor, R * factor, 
					start + this.rotation, start + this.rotation + extent);
			return arc2D;
		},
		
		/**
		 * SINCOSֵ.
		 */
		calculateSINCOS	:	function() {
			if (! this.need_cal) {
				return;
			}
			
			this.sin_theta_alpha = Math.sin(this.elevation * Math.PI / 180);
			this.cos_theta_alpha = Math.cos(this.elevation * Math.PI / 180);
			
			this.sin_theta_beta= Math.sin(-this.rotation * Math.PI/180);
			this.cos_theta_beta = Math.cos(-this.rotation * Math.PI/180);
			
			this.need_cal = false;
		},
		
		/**
		 * ͸ͶӰ
		 */
		perspective_projectee	:	function(x, y, z) {
			var dx = x * this.cos_theta_beta + z * this.sin_theta_beta;
			var dy = -x * this.sin_theta_alpha * this.sin_theta_beta 
				+ y * this.cos_theta_alpha + z * this.sin_theta_alpha * this.cos_theta_beta;
			
			var factor = this.focus / (
					this.cos_theta_alpha * this.sin_theta_beta * x 
						+ this.sin_theta_alpha * y - this.cos_theta_alpha * this.cos_theta_beta * z + this.focus
					);
			return new Point2D(dx * factor, dy * factor);
		},
		
		/**
		 * ƽͶӰ
		 */
		ortho_projectee	:	function(x, y, z) {
			var dx = x * this.cos_theta_beta + z * this.sin_theta_beta;
			var dy = -x * this.sin_theta_alpha * this.sin_theta_beta + y * this.cos_theta_alpha 
							+ z * this.sin_theta_alpha * this.cos_theta_beta;
			
			return new Point2D(dx, dy);
		},
		
		/**
		 * ֱϵ
		 */
		right_angle_projectee	:	function(x, y, z) {
			var dx = x + z * this.sin_theta_beta * 0.5;
			var dy = y + z * this.sin_theta_alpha * 0.5;
			
			return new Point2D(dx, dy);
		}
	}
	
	function ColorInfo() {
		this.initConstants();
	}
	
	ColorInfo.prototype = {
		initConstants 	:	function() {
			this.seriesAttrAlpha = new SeriesAttrAlpha();
			this.seriesAttrBorder = new SeriesAttrBorder();
			this.seriesAttrColor = new SeriesAttrColor();
		},
		
		setSeriesColor	:	function(seriesColor) {
			this.getSeriesAttrColor().setSeriesColor(seriesColor);
		},
		
		getSeriesColor	:	function() {
			return this.getSeriesAttrColor().getSeriesColor();
		},
		
		setSeriesAttrColor	:	function(seriesAttrColor) {
			this.seriesAttrColor = seriesAttrColor;
		},
		
		getSeriesAttrColor	:	function() {
			return this.seriesAttrColor;
		},
		
		setBorderLineStyle	:	function(borderLineStyle) {
			this.getSeriesAttrBorder().setBorderStyle(borderLineStyle);
		},
		
		getBorderLineStyle	:	function() {
			return this.getSeriesAttrBorder().getBorderStyle();
		},
		
		setBorderLineColor	:	function(borderLineColor) {
			this.getSeriesAttrBorder().setBorderColor(borderLineColor);
		},
		
		getBorderLineColor	:	function() {
			return this.getSeriesAttrBorder().getBorderColor();
		},
		
		setSeriesAttrBorder	:	function(seriesAttrBorder) {
			this.seriesAtrrBorder = seriesAttrBorder;
		},
		
		getSeriesAttrBorder	:	function() {
			return this.seriesAttrBorder;
		},
		
		setDefaultAlpha	:	function(defaultAlpha) {
			this.getSeriesAttrAlpha().setAlpha(defaultAlpha);
		},
		
		getDefaultAlpha	:	function() {
			return this.getSeriesAttrAlpha().getAlpha();
		},
		
		setSeriesAttrAlpha	:	function(seriesAttrAlpha) {
			this.seriesAttrAlpha = seriesAttrAlpha;
		},
		
		getSeriesAttrAlpha	:	function() {
			return this.seriesAttrAlpha;
		},
		
		paint	:	function(ctx, shape) {
			if(shape == null) {
				return ;
			}
			
			ctx.save();
			
			ctx.globalAlpha = this.getDefaultAlpha();
			
			if(this.getSeriesColor() != null) {
				ctx.fillStyle = this.getSeriesColor();
				shape.paint(ctx);
			}
			
			if(this.getBorderLineStyle() != Constants.LINE_NONE && this.getBorderLineColor() != null) {
				ctx.strokeStyle = this.getBorderLineColor();
				// ߿.  
//				GraphHelper.drawLine(ctx, shape, this.getBorderLineStyle());
			}
			
			ctx.restore();
		},
		
		dealCondition	:	function(collection, index) {
			var attrColor = collection.getSeriesCondition(new SeriesAttrColor(), index);
			this.setSeriesColor(attrColor.getSeriesColor());
			
			var attrBorder = collection.getSeriesCondition(new SeriesAttrBorder(), index);
			this.setBorderLineColor(attrBorder.getBorderColor());
			this.setBorderLineStyle(attrBorder.getBorderStyle());
			
			var attrAlpha = collection.getSeriesCondition(new SeriesAttrAlpha(), index);
			this.setDefaultAlpha(attrAlpha.getAlpha());
		}
		
	}
	

	function Cylinder(start_y, depth, R) {
		this.initConstants();
		
		this.start_y = start_y;
		this.depth = depth;
		this.R = R;
	}
	
	Cylinder.prototype = {
		initConstants	:	function() {
			this.projection = new Projection();
			this.colorInfo = new ColorInfo();
		},
		
		start_y	:	0,
		x	:	0,
		y	:	0,
		start	:	0,
		extent	:	360,
		
		depth	:	60,
		R	:	60,
		
		draw	:	function(ctx) {
			var color = this.colorInfo.getSeriesColor().darker();
			ctx.strokeStyle = color;
			this.bottom(ctx);
			ctx.stroke();
			
			for (var i = this.getDepth() - 1; i > 0; i --) {
				color = this.colorPlus(color);
				ctx.strokeStyle = color;
				
				this.getArc2D(i, ctx);
				ctx.stroke();
			}
			
			ctx.strokeStyle = this.colorInfo.getSeriesColor().brighter();
			this.top(ctx);
			ctx.stroke();
		},
		
		colorPlus	:	function(color) {
			return 'rgb(color.getRed() + 1, color.getGreen() + 1,color.getBlue() + 1)';
		},
		
		bottom	:	function(ctx) {
			return this.getArc2D(this.getDepth(), ctx);
		},
		
		back	:	function() {
			var arc_top = this.top();
//	        arc_top.setArcType(Arc2D.OPEN);
	        var arc_bottom = this.bottom();
//	        arc_bottom.setArcType(Arc2D.OPEN);
	        
	        var start = arc_top.getStart();
	        var end = arc_top.getEnd();
	        var extent = end - start;
	        
	        // ʱûõ.
	        if (this.isInner()) {	// ԲԲ
				var generalPath = new GeneralPath();
//				generalPath.append(arc_top.getPathIterator(null), true);
				generalPath.lineTo(arc_bottom.getEndPoint().getX(), arc_bottom.getEndPoint().getY());
//				arc_bottom.setStart(end);
//				arc_bottom.setEnd(end - extent);
//				generalPath.append(arc_bottom.getPathIterator(null), true);
				return generalPath;
			}
	        
			var upper_Arc2D = this.projection.projecteeArc(this.getStart_y(), this.getR(), 0, 360);
			var r = upper_Arc2D.getRadius();
			var x = upper_Arc2D.getX();
			var y = upper_Arc2D.getY();
			x = x + this.x - r;
			y = y + this.y - r;
			var top = new Ellipse2D(x, y, 2*r, 2*r);
			
			var top_left = new Point2D(top.getX(), top.getY());
			var top_right = new Point2D(top.getX() + top.getWidth(), top.getY());
			
			var bottom_Arc2D = this.projection.projecteeArc(this.getStart_y() + this.getDepth(), this.getR(), 0, 360);
			var bbr = bottom_Arc2D.getRadius();
	        var bottom = new Ellipse2D(bottom_Arc2D.getX() - r + this.x, bottom_Arc2D.getY() - r + this.y, 
	        			bbr * 2, bbr * 2);
	        
	        var bottom_left = new Point2D(bottom.getX(), bottom.getY() + 2*r);
	        var bottom_right = new Point2D(bottom.getX() + bbr * 2, bottom.getY() + bbr * 2);
	                
	        var between = new GeneralPath();
	        between.moveTo(top.getX(), top.getY() + r);
	        between.lineTo(top.getX() + 2*r, top.getY() + r);
	        between.lineTo(bottom.getX() + 2*r, bottom.getY() + r);
	        between.lineTo(bottom.getX(), bottom.getY() + r);
	
			// TODO Area..
//	        var pie = new Area(top);
//	        pie.add(new Area(between));
//	        pie.add(new Area(bottom));
//	        
//	        var back = new Area(pie);
//	        back.subtract(new Area(bottom));
	        
	        var back_side = null;
	        
	        /*
	         *  ұ߽theta, ߽180 - theta, front֮180 - 2 * theta
	         *  theta Ϊֵ-90 ~ 90
	         */
	        var theta = Math.asin(-this.get_sin_theta()) * 180 / Math.PI;

	        // for CLOCKWISE charts, the extent will be negative...
	        if (extent < 0.0) {
	            if (this.isAngleAtFront(start)) {  // start at front
	                if (!this.isAngleAtBack(end)) {
	                    if (this.extent > -(180.0 + 2 * theta)) {  // the segment is entirely at the 
	                    } else {  // the segment starts at the front, and wraps all 
	                            // the way around
	                            // the back and finishes at the front again
	                        back_side = back;
	                    }
	                } else {  // starts at the front, finishes at the back (going 
	                        // around the left side)
	                	back_side = this.getSideArea(arc_top, arc_bottom, 180 - theta, end, top_left, top_right, bottom_left, bottom_right);
	                }
	            } else {  // the segment starts at the back (still extending CLOCKWISE)
	                if (!this.isAngleAtFront(end)) {
	                    if (extent > -(180.0 - 2* theta)) {  // whole segment stays at the back
	                    	back_side = this.getSideArea(arc_top, arc_bottom, start, end, top_left, top_right, bottom_left, bottom_right);
	                    } else {  // starts at the back, wraps around front, and 
	                            // finishes at back again
	                    	var side1 = this.getSideArea(arc_top, arc_bottom, theta, start, top_left, top_right, bottom_left, bottom_right);
	                        
	                        var side2 = this.getSideArea(arc_top, arc_bottom, end, 180 - theta, top_left, top_right, bottom_left, bottom_right);
	                        
	                        back_side = new Area(side1);
	                        back_side.add(side2);
	                    }
	                } else {  // starts at back, finishes at front (CLOCKWISE)
	                	back_side = this.getSideArea(arc_top, arc_bottom, start, theta, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	        } else if (extent > 0.0) {  // the pie sections are arranged ANTICLOCKWISE
	            if (this.isAngleAtFront(start)) {  // segment starts at the front
	                if (!this.isAngleAtBack(end)) {  // and finishes at the front
	                    if (extent < (180.0 + 2 * theta)) {  // segment only occupies the front
	                    }
	                    else {  // segments wraps right around the back...
	                    	back_side = back;
	                    }
	                } else {  // segments starts at front and finishes at back...
	                	back_side = this.getSideArea(arc_top, arc_bottom, theta, end, top_left, top_right, bottom_left, bottom_right);
	                }
	            } else {  // segment starts at back
	                if (!this.isAngleAtFront(end)) {
	                    if (extent < (180.0 - 2 * theta)) {  // and finishes at back
	                    	back_side = this.getSideArea(arc_top, arc_bottom, end, start, top_left, top_right, bottom_left, bottom_right);
	                    } else {  // starts at back and wraps right around to the back again
	                        var side1 = this.getSideArea(arc_top, arc_bottom, 180 - theta, start, top_left, top_right, bottom_left, bottom_right);
	
	                        // back again
	                        var side2 = this.getSideArea(arc_top, arc_bottom, theta, end, top_left, top_right, bottom_left, bottom_right);
	                        
	                        back_side = new Area(side1);
	                        back_side.add(side2);
	                    }
	                } else {  // starts at the back and finishes at the front (wrapping the left side)
	                	back_side = this.getSideArea(arc_top, arc_bottom, 180, start, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	        }
	        
//	        if (back_side == null) {
//	        	back_side = new Area();
//	        } else {
//	        	back_side.intersect(back);
//	        }
	        
	        return back_side;
		},
		
		front	:	function() {
			if (this.isInner()) {
				return new Area();
			}
			
			var tb = this.projection.projecteeArc(this.getStart_y(), this.getR(), 0, 360);
			var top = new Ellipse2D(tb.getX() - tb.getRadius() + this.x, 
						tb.getY() - tb.getRadius() + this.y, tb.getRadius(), tb.getRadius());
	
			var top_left = new Point2D(top.getX(), top.getY());
			var top_right = new Point2D(top.getX() + top.getWidth(), top.getY());
	
			var bb = this.projection.projecteeArc(this.getStart_y() + this.getDepth(), this.getR(), 0, 360);
			
	        var bottom = new Ellipse2D(bb.getX() - bb.getRadius() + this.x, 
	        			bb.getY() - bb.getRadius() + this.y, bb.getRadius(), bb.getRadius());
	
	        var bottom_left = new Point2D(bottom.getX(), bottom.getY() + bottom.getHeight());
	        var bottom_right = new Point2D(bottom.getX() + bottom.getWidth(), bottom.getY() + bottom.getHeight());
	        
	        var between = new GeneralPath();
	        between.moveTo(top.getX(), top.getY());
	        between.lineTo(top.getX() + top.getWidth(), top.getY());
	        between.lineTo(bottom.getX() + bottom.getWidth(), bottom.getY());
	        between.lineTo(bottom.getX(), bottom.getY());
//	        between.closePath();
	                
//	        var pie = new Area(top);
//	        pie.add(new Area(between));
//	        pie.add(new Area(bottom));
//	
//	        var front = new Area(pie);
//	        front.subtract(new Area(top));
	        
	        var arc_top = this.top();
//	        arc_top.setArcType(Arc2D.OPEN);
	        var arc_bottom = this.bottom();
//	        arc_bottom.setArcType(Arc2D.OPEN);
	        
	        var start = arc_top.getStart();
	        var end = arc_top.getEnd();
	        var extent = end - start;
	        
	        var front_side = null;
	        
	        /*
	         *  ұ߽theta, ߽180 - theta, front֮180 - 2 * theta
	         *  theta Ϊֵ-90 ~ 90
	         */
	        var theta = Math.asin(-this.get_sin_theta()) * 180/Math.PI;
	        
	        // for CLOCKWISE charts, the extent will be negative...        
	        if (extent < 0.0) {
	            if (this.isAngleAtFront(start)) {  // start at front
	                if (!this.isAngleAtBack(end)) {
	                    if (extent > -(180.0 + 2 * theta)) {  // the segment is entirely at the front of the chart                    	
	                    	front_side = this.getSideArea(arc_top, arc_bottom, end, start, top_left, top_right, bottom_left, bottom_right);
	                    }
	                    else {  // the segment starts at the front, and wraps all 
	                            // the way around
	                            // the back and finishes at the front again                    	
	                        var side1 = this.getSideArea(arc_top, arc_bottom, 180 - theta, start, top_left, top_right, bottom_left, bottom_right);
	                    	
	                        var side2 = this.getSideArea(arc_top, arc_bottom, end, theta, top_left, top_right, bottom_left, bottom_right);
	                        
	                        front_side = new Area(side1);
	                        front_side.add(side2);
	                    }
	                }
	                else {  // starts at the front, finishes at the back (going around the left side)
	                	front_side = this.getSideArea(arc_top, arc_bottom, 180 - theta, start, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	            else {  // the segment starts at the back (still extending 
	                    // CLOCKWISE)
	                if (!this.isAngleAtFront(end)) {
	                    if (extent > - (180.0 - 2 * theta)) {  // whole segment stays at the back
	                    }
	                    else {  // starts at the back, wraps around front, and 
	                            // finishes at back again
	                        front_side = front;
	                    }
	                }
	                else {  // starts at back, finishes at front (CLOCKWISE)
	                	front_side = this.getSideArea(arc_top, arc_bottom, end, theta, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	        }
	        else if (extent > 0.0) {  // the pie sections are arranged ANTICLOCKWISE
	            if (this.isAngleAtFront(start)) {  // segment starts at the front
	                if (!this.isAngleAtBack(end)) {  // and finishes at the front
	                    if (extent < (180.0 + 2 * theta)) {  // segment only occupies the front                    	
	                    	front_side = this.getSideArea(arc_top, arc_bottom, end, start, top_left, top_right, bottom_left, bottom_right);
	                    }
	                    else {  // segments wraps right around the back...
	                        var side1 = this.getSideArea(arc_top, arc_bottom, 180 - theta, end, top_left, top_right, bottom_left, bottom_right);
	                        var side2 = this.getSideArea(arc_top, arc_bottom, start, theta, top_left, top_right, bottom_left, bottom_right);
	
	                        front_side = new Area(side1);
	                        front_side.add(side2);
	                    }
	                }
	                else {  // segments starts at front and finishes at back...
	                	front_side = this.getSideArea(arc_top, arc_bottom, start, theta, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	            else {  // segment starts at back
	
	                if (!this.isAngleAtFront(end)) {
	                    if (extent < (180.0 - 2 * theta)) {  // and finishes at back
	                    }
	                    else {  // starts at back and wraps right around to the 
	                            // back again
	                    	front_side = front;
	                    }
	                }
	                else {  // starts at the back and finishes at the front 
	                        // (wrapping the left side)
	                	front_side = this.getSideArea(arc_top, arc_bottom, 180 - theta, end, top_left, top_right, bottom_left, bottom_right);
	                }
	            }
	
	        }
	        
//	        if (front_side == null) {
//	        	front_side = new Area();
//	        } else {
//	        	front_side.intersect(front);
//	        }
	        
	        return front_side;
		},
		
		top	:	function() {
			return this.getArc2D(0);
		},
		
		getStartSide	:	function() {
			var top = this.top();
			var bottom = this.bottom();
			
			var startSide = new GeneralPath();
			startSide.moveTo(bottom.getX(), bottom.getY());
			startSide.lineTo(bottom.getStartPoint().getX(), bottom.getStartPoint().getY());
			startSide.lineTo(top.getStartPoint().getX(), top.getStartPoint().getY());
			startSide.lineTo(top.getX(), top.getY());
//			startSide.closePath();
			
			return startSide;
		},
		
		getEndSide	:	function() {
			var top = this.top();
			var bottom = this.bottom();
			
			var endSide = new GeneralPath();
			endSide.moveTo(bottom.getX(), bottom.getY());
			
			endSide.lineTo(bottom.getEndPoint().getX(), bottom.getEndPoint().getY());
			endSide.lineTo(top.getEndPoint().getX(), top.getEndPoint().getY());
			endSide.lineTo(top.getX(), top.getY());
//			endSide.closePath();
			
			return endSide;
		},
		
		getArc2D	:	function(depth) {
			var upper_Arc2D = this.projection.projecteeArc(this.getStart_y() + depth, this.getR(), this.start, this.extent);
			
			upper_Arc2D.setX(upper_Arc2D.getX() + this.x);
			upper_Arc2D.setY(upper_Arc2D.getY() + this.y);
//			rect.x += this.x;
//			rect.y += this.y;
//			upper_Arc2D.setArc(rect, upper_Arc2D.getAngleStart(), upper_Arc2D.getAngleExtent(), upper_Arc2D.getArcType());
			
			return upper_Arc2D;
		},
		
		getShape	:	function() {
			var generalPath = new GeneralPath();
		
			generalPath.append(this.getArc2D(0), false);
			generalPath.append(this.getArc2D(this.getDepth()), false);
			
			return generalPath;
		},
		
		setProjection	:	function(projection) {
			this.projection = projection;
		},
		
		getProjection	:	function() {
			return this.projection;
		},
		
		setColorInfo	:	function(colorInfo) {
			this.colorInfo = colorInfo;
		},
		
		getColorInfo	:	function() {
			return this.colorInfo;
		},
		
		setStart_y 	:	function(start_y) {
			this.start_y = start_y;
		},
		
		getStart_y 	:	function() {
			return this.start_y;
		},
		
		setX 	:	function(x) {
			this.x = x;
		},
		
		getX 	:	function() {
			return this.x;
		},
		
		setY	:	function(y) {
			this.y = y;
		},
		
		getY	:	function() {
			return this.y;
		},
		
		setStart	:	function(start) {
			this.start = start;
		},
		
		getStart	:	function() {
			return this.start;
		},
		
		setExtent	:	function(extent) {
			this.extent = extent;
		},
		
		getExtent	:	function() {
			return this.extent;
		},
		
		setDepth	:	function(depth) {
			this.depth = depth;
		},
		
		getDepth	:	function() {
			return this.depth;
		},
		
		setR	:	function(r) {
			this.R = r;
		},
		
		getR	:	function() {
			return this.R;
		},
		
		getArcPoint	:	function(arc, angle) {
			var x = arc.getX() + (Math.cos(- angle * Math.PI / 180) * 0.5 + 0.5) * arc.getRadius();
			var y = arc.getY() + (Math.sin(- angle * Math.PI / 180) * 0.5 + 0.5) * arc.getRadius();
			return new Point2D(x, y);
		},
		
		getSideArea	:	function(arc_top, arc_bottom, from, to, top_left, top_right, bottom_left, bottom_right) {
			var a = ChartUtils.intersectsPoint(
	    			this.getArcPoint(arc_top, from), this.getArcPoint(arc_bottom, from), top_left, top_right);
	    	var b = ChartUtils.intersectsPoint(
	    			this.getArcPoint(arc_top, from), this.getArcPoint(arc_bottom, from), bottom_left, bottom_right);
	    	var c= ChartUtils.intersectsPoint(
	    			this.getArcPoint(arc_top, to), this.getArcPoint(arc_bottom, to), top_left, top_right);
	    	var d = ChartUtils.intersectsPoint(
	    			this.getArcPoint(arc_top, to), this.getArcPoint(arc_bottom, to), bottom_left, bottom_right);
	    	if (a == null || b == null || c == null || d == null) {
	    		return new Area();
	    	}
	    	
	    	var generalPath = new GeneralPath();
	    	generalPath.moveTo(a.getX(), a.getY());
	    	generalPath.lineTo(b.getX(), b.getY());
	    	generalPath.lineTo(d.getX(), d.getY());
	    	generalPath.lineTo(c.getX(), c.getY());
//	    	generalPath.closePath();
	    	
//	    	return new Area(generalPath);
			return generalPath;
		},
		
		isInner	:	function() {
			var elevation = this.projection.getElevation();
			var focus = this.projection.getFocus();
			var a = focus / ( 2 * this.getR());
			var b = Math.sqrt(1 + a * a) - a;
			
			return Math.cos(elevation * Math.PI / 180) <= b;
		},
		
		isAngleAtFront	:	function(angle) {
			 return (Math.sin(angle * Math.PI / 180) < - this.get_sin_theta());
		},
		
		isAngleAtBack	:	function(angle) {
			return !this.isAngleAtFront(angle);
		},
		
		get_sin_theta	:	function() {
			var elevation = this.projection.getElevation() * Math.PI / 180;
			var focus = this.projection.getFocus();
			
			return this.getR() * (Math.pow(Math.sin(elevation), 2)) / (Math.cos(elevation) * focus);
		}
		
	}
	
	Cylinder.CylinderSide = function(cylinder, isStart) {
		this.cylinder = cylinder;
		this.isStart = isStart;
		
	}
	
	Cylinder.CylinderSide.prototype = {
		cylinder	:	null,
		isStart	:	false,
		
		compareTo	:	function(cylinderSide) {
			var angle_this;
			var angle_that;
			if (this.isStart) {
				angle_this = this.cylinder.getStart();
			} else {
				angle_this = this.cylinder.getStart() + this.cylinder.getExtent();
			}
			
			if (cylinderSide.isStart) {
				angle_that = cylinderSide.cylinder.getStart();
			} else {
				angle_that = cylinderSide.cylinder.getStart() + cylinderSide.cylinder.getExtent();
			}
			
			var value_this = Math.abs(angle_this - 90) % 360;
			var value_that =  Math.abs(angle_that - 90) % 360;
			
			value_this = value_this > 180 ? 360 - value_this : value_this;
			value_that = value_that > 180 ? 360 - value_that : value_that;
			
			if (Math.abs(value_this - value_that) < 0.05) {
				if (this.cylinder.getExtent() != 0) {
					if (this.isStart) {
						angle_this = this.cylinder.getStart() 
						+ this.cylinder.getExtent() / Math.abs(this.cylinder.getExtent());
					} else {
						angle_this = this.cylinder.getStart() + this.cylinder.getExtent() 
						- this.cylinder.getExtent() / Math.abs(this.cylinder.getExtent());
					}
				}
				
				if (cylinderSide.cylinder.getExtent() != 0) {
					if (cylinderSide.isStart) {
						angle_that = cylinderSide.cylinder.getStart() 
						+ cylinderSide.cylinder.getExtent() / Math.abs(cylinderSide.cylinder.getExtent());
					} else {
						angle_that = cylinderSide.cylinder.getStart() + cylinderSide.cylinder.getExtent()
						- cylinderSide.cylinder.getExtent() / Math.abs(cylinderSide.cylinder.getExtent());
					}
				}
				
				value_this = Math.abs(angle_this - 90) % 360;
				value_that =  Math.abs(angle_that - 90) % 360;
				value_this = value_this > 180 ? 360 - value_this : value_this;
				value_that = value_that > 180 ? 360 - value_that : value_that;
			}
			
			if (value_this < value_that) {
				return - 1;
			} else if(value_this > value_that) {
				return 1;
			} else {
				return 0;
			}
		}
	}
	
	
	function	Pie3D() {
		this.initConstants();
	}
	
	Pie3D.prototype = {
		initConstants	:	function() {
			this.projection = new Projection();
			this.cylinderList = new Array();
		},
		
		draw	:	function(ctx) {
			
			// Ȼ
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				var cylinder = this.getCylinder(i);
				var colorInfo = cylinder.getColorInfo();
				var color = colorInfo.getSeriesColor();
				if(color != null) {
//					colorInfo.setSeriesColor(color.darker());
				} 
				colorInfo.paint(ctx, cylinder.bottom());
				
				colorInfo.setSeriesColor(color);
			}
			
			// ٻ
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				var cylinder = this.getCylinder(i);
				var colorInfo = cylinder.getColorInfo();
				var color = colorInfo.getSeriesColor();
				if(color != null) {
//					colorInfo.setSeriesColor(color.darker());
				} 
				colorInfo.paint(ctx, cylinder.back());
				
				colorInfo.setSeriesColor(color);
			}
			
			/*
			 * ٻڲı, Ҫ򣬰Ƕ
			 * Startʱ angle = start || angle = start + extend / Math.abs(extend);
			 * Endʱangle = end || angle = end - extend / Math.abs(extend);
			 * 
			 * value = Math.abs(angle - 90) % 360, value 180ȣΪvalue = 360 - value
			 * cylinder_list.size() * 2angleҪ
			 */
			var cylinderSides = new Array(this.getCylinderCount() * 2);
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				cylinderSides[2 * i] = new Cylinder.CylinderSide(this.getCylinder(i), true);
				cylinderSides[2 * i + 1] = new Cylinder.CylinderSide(this.getCylinder(i), false);
			}
			
			// 
			this.sortCylinderSide(cylinderSides);
			
			// ʼı
			for (var i = 0; i < cylinderSides.length; i ++) {
				var cylinder = cylinderSides[i].cylinder;
				
				var colorInfo = cylinder.getColorInfo();
				var color = colorInfo.getSeriesColor();
				if(color != null) {
//					colorInfo.setSeriesColor(color.darker());
				} 
				if (cylinderSides[i].isStart) {
					colorInfo.paint(ctx, cylinder.getStartSide());
				} else {
					colorInfo.paint(ctx, cylinder.getEndSide());
				}
				
				colorInfo.setSeriesColor(color);
			}
			
			// ٻ
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				var cylinder = this.getCylinder(i);
				var colorInfo = cylinder.getColorInfo();
				colorInfo.paint(ctx, cylinder.front());
			}
			
			// 
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				var cylinder = this.getCylinder(i);
				
				var colorInfo = cylinder.getColorInfo();
				var color = colorInfo.getSeriesColor();
				if(color != null) {
//					colorInfo.setSeriesColor(color.brighter());
				} 
				colorInfo.paint(ctx, cylinder.top());
	
				colorInfo.setSeriesColor(color);
			}
		},
		
		getShape	:	function() {
			var generalPath = new GeneralPath();
		
			for (var i = 0 ; i < this.getCylinderCount(); i ++) {
				generalPath.append(this.getCylinder(i).getShape(), false);
			}
			
			return generalPath;
		},
		
		addCylinder	:	function(cylinder) {
			this.cylinderList.push(cylinder);
		},
		
		getCylinder	:	function(index) {
			return this.cylinderList[index];
		},
		
		getCylinderCount	:	function() {
			return this.cylinderList.length;
		},
		
		getProjection	:	function() {
			return this.projection;
		},
		
		setProjection	:	function(projection) {
			this.projection = projection;
		},
		
		/**
		 * 
		 */
		sortCylinderSide	:	function(cylinderSides) {
			var cloned = new Array(cylinderSides.length);
			for(var i = 0; i < cylinderSides.length; i++)  {
				cloned[i] = cylinderSides[i];
			}
			this.mergeSort(cloned, cylinderSides, 0, cylinderSides.length);
		},
		
		/**
		 * compareȽϺ, 
		 */
		mergeSort	:	function(cloned, cylinderSides, low, high) {
			for (var i=low; i<high; i++)
                for (var j=i; j>low && (cylinderSides[j-1]).compareTo(cylinderSides[j])>0; j--)
                    this.swap(cylinderSides, j, j-1);
            return;
		},
		
		/**
		 * λ.
		 */
		swap	:	function(x, a, b) {
			var t = x[a];
			x[a] = x[b];
			x[b] = t;
		}
	}

	function	Pie3DPlotGlyph(js) {
		this.initConstants(js);
	}	
	
	FR.extend(Pie3DPlotGlyph, PiePlotGlyph, {
		initConstants		:		function(js) {
			js = js || {};
			
			this.projection = js.projection == undefined ? new Projection() : new Projection(js);
			this.depth = js.depth == undefined ? 20 : js.depth;
			
			Pie3DPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			// do nothing
		},
		
		layoutDataSeriesGlyph 		:		function() {
			var plotBounds = this.getBounds();
	    	
	    	var width = plotBounds.getWidth();
	    	var height = plotBounds.getHeight();
	    	// Բ
	    	var C = new Point2D(width / 2, height / 2);
	    	// ֱ ΪǩԤռ.
	        var D = Math.min(width, height);
	        
	        for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				// ͨÿһDataLabelInfo ʵʺʵıͼֱǣߵĳ.
				D = this.deal4BestRad(dataSeries, D);
				
				var start = this.getStartAngle();	// 90ȿʼ    ˳ʱת
				// ӦĽǶȷΧ
		        var extent = 0;                
		        var r = D / ( 2 + 2 * this.getSeparatePercent() / 100.0 );
				var distance = this.getSeparatePercent() / 100.0 * r;	//	ζ㵽Բĵľ
				
				var pie3d = new Pie3D();
				dataSeries.setGlyph(pie3d);
				
				pie3d.setProjection(this.getProjection());
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					extent = this.getPercent(categoryIndex) * 360;
					// kunsnat: ÿʼǶ Ҫ ͼʵбĽǶ   ͶӰЧ.
					// Ȼƫܿܵ´λ.. 
					// бӽǵµ: yתrotation 
					var halfAngle = start + 0.5 * extent + this.getProjection().getRotation();//һĽǶ
					
					// xתĵ 
					halfAngle = halfAngle + this.dealWithElvation(halfAngle);
					
					var cylinder = new Cylinder(0, this.getDepth(), r);
					cylinder.setX(C.getX() + distance * Math.cos(halfAngle * Math.PI / 180));
					cylinder.setY(C.getY() + distance * Math.sin(halfAngle * Math.PI / 180));
					cylinder.setStart(start);
					cylinder.setExtent(extent);
					cylinder.setProjection(this.getProjection());
					cylinder.getColorInfo().dealCondition(this.getSeriesCollection(), categoryIndex);
					
					pie3d.addCylinder(cylinder);
					
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					dataPoint.setShape(cylinder.top());
					dataPoint.setPercentValue(this.getPercent(categoryIndex));
					
					dealDataPointLabelBounds(dataPoint, cylinder, categoryIndex, halfAngle);

					start = start + extent;
				}
			}
		},
		
		// TODO ǩλ ǣ
		dealDataPointLabelBounds	:	function(dataPoint, cylinder, categoryIndex, halfAngle) {
			// ǩݺǣ
			var tg = dataPoint.getDataLabel();
			if (tg instanceof TextGlyph) {
				var attrPosition = this.getSeriesCollection().getSeriesCondition(new SeriesAttrPosition(), categoryIndex);					
				tg.dealCondition(getSeriesCollection(), categoryIndex);
				
				var tg_width = tg.preferredDimension().getWidth();
				var tg_height = tg.preferredDimension().getHeight();
				
				var pieLabel = tg.getText();
				if(pieLabel != null) {
					// ϵб߿
					var seriesBounds = dataPoint.getShape().getBounds2D();
					var sx = seriesBounds.getX(), sy = seriesBounds.getY(), sw =  seriesBounds.getWidth(), sh = seriesBounds.getHeight();
					var centerLabelx = sx + (sw - tg.preferredDimension().getWidth())/2, centerLabely = sy + (sh - tg.preferredDimension().getHeight())/2;
					
					// ñͼ ԲĴλ. ɢ뾶1.5ҵ ǣ߳
					var centerSx = this.getBounds().getWidth()/2.0;
					var centerSy = this.getBounds().getHeight()/2.0;
					
					if(attrPosition.getPosition() == Constants.prototype.OUTSIDE) {
						// Ƿ̶.  ǣߴǱͼ뾶һ
						var rad = cylinder.getR() * (1 +this.getSeparatePercent()/100);
						// ȡģ Χ360.
						var tmpAngle = halfAngle % 360;
						
						// 뾶x yͶӰֵ  Ҫõ1.3İ뾶 
						var leadx = this.getLeadLineX(tmpAngle, rad * 1.5);
						var leady = this.getLeadLineY(tmpAngle, rad * 1.5);
						
						// ǩλ
						var tgx1 = centerSx + leadx;
						var tgy1 = centerSy + leady;
						// ǩλ Բʱ xλ һǩĿ
						if(leadx < 0) {
							tgx1 = tgx1 - tg_width;
						}
						if(tmpAngle >= 45 && tmpAngle < 130) {
							tgy1 = tgy1 + tg_height/2.0;
						}
						if(tmpAngle >= 230 && tmpAngle < 300) {
							tgy1 = tgy1 - tg_height;
						}
						
						tg.setBounds(new Bounds(tgx1, tgy1, tg_width, tg_height));
						
						if(false) {
//						if(pieDataLabelInfo.getIsShowGuidLine()) {
							var x2 = tg.getBounds().getX(), y2 = tg.getBounds().getY();
							
							// kunsnat: ͨǶȷΧ  ǣָıǩλ
							if(tmpAngle >= 0 && tmpAngle < 45 || tmpAngle >= 315 && tmpAngle < 360) {
								y2 = y2 + tg_height/2.0;
							} else if(tmpAngle >= 45 && tmpAngle < 135) {
								y2 = y2 + tg_height;
								x2 = x2 + tg_width/2.0;
							} else if(tmpAngle >= 135 && tmpAngle < 225) {
								x2 = x2 + tg_width;
								y2 = y2 + tg_height/2.0;
							} else if(tmpAngle >= 225 && tmpAngle < 315) {
								x2 = x2 + tg_width/2.0;
							} 
							// Բ PS: kunsnat:ߵĽǶ ò..
							var point = Cylinder.getArcPoint(cylinder.top(), halfAngle);
							
							dataPoint.setLeadLine(new Line2D(point.getX(), point.getY(), x2, y2));
						}
					} else {
						// λþеʱͲǣ.
						tg.setBounds(new Bounds(centerLabelx, centerLabely, tg_width, tg_height));
					}
				}
			}
		},
		
		dealWithElvation		:		function(halfAngle) {
			halfAngle = halfAngle % 360;
	    	if(halfAngle > 0 && halfAngle < 90) {
	        	var A = Math.sin(this.getProjection().getElevation() * Math.PI / 180);
	        	var B = Math.tan(halfAngle * Math.PI / 180);
	        	var x = Math.atan(A/B);
	        	var angle = x * 180 / Math.PI;
	    		return -(90 - halfAngle - angle);
	    	} else if(halfAngle > 90 && halfAngle < 180){
	    		var smallAngle = halfAngle - 90;
	    		var A = Math.sin(this.getProjection().getElevation() * Math.PI / 180);
	        	var B = Math.tan((halfAngle - 90) * Math.PI / 180);
	        	var x = Math.atan(A/B);
	        	var angle = x * 180 / Math.PI;
	    		return 90 - smallAngle - angle;
	    	} else if(halfAngle > 180 && halfAngle < 270) {
	    		// ڵ޵ĽǶ
	    		var smallAngle = 270 - halfAngle;
	    		var A = Math.sin(this.getProjection().getElevation() * Math.PI / 180);
	        	var B = Math.tan((smallAngle) * Math.PI / 180);
	        	var x = Math.atan(A/B);
	        	var angle = x * 180 / Math.PI;
	    		return -(90 - smallAngle - angle);
	    	} else if(halfAngle > 270 && halfAngle < 360) {
	    		var smallAngle = 360 - halfAngle;
	    		var A = Math.sin(this.getProjection().getElevation() * Math.PI / 180);
	        	var B = Math.tan((360 - halfAngle) * Math.PI / 180);
	        	var x = Math.atan(A/B);
	        	var angle = x * 180 / Math.PI;
	    		return 90 - smallAngle - angle;
	    	}
	    	// 0 90 180 270 360ЩǶȵʱΪ0.
	    	return 0;
		},
		
		setProjection		:		function(projection) {
			this.projection = projection;
		},
		
		getProjection		:		function() {
			return this.projection;
		},
		
		setDepth		:		function(depth) {
			this.depth = depth;
		},
		
		getDepth 		:		function() {
			return this.depth;
		}
	});
	
	function	RadarPlotGlyph(js) {
		this.initConstants(js);
	}
	
	FR.extend(RadarPlotGlyph, PlotGlyph, {
		initConstants	:		function(js) {
			js = js || {};
			
			this.isFilled = js.isFilled == undefined ?  true : js.isFilled;
			this.showLine = js.showLine == undefined ? true : js.showLine;
			this.showMarker = js.showMarker == undefined ? false : js.showMarker;
			
			this.radarAxisGlyph = js.radarAxisGlyph == undefined ?  null : new RadarAxisGlyph(js.radarAxisGlyph);
			
			RadarPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			this.radarAxisGlyph.init(new Bounds(0,0,this.getBounds().getWidth(), this.getBounds().getHeight()));
			this.radarAxisGlyph.calculateAxisLengthUnit();
		},
		
		layoutDataSeriesGlyph		:		function() {
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var linePath = new GeneralPath();
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					var value = dataPoint.getValue();
					var point = this.getRadarAxisGlyph().getPoint2D(categoryIndex, value);
					if (categoryIndex == 0) {
						linePath.moveTo(point.getX(), point.getY());
					} else {
						linePath.lineTo(point.getX(), point.getY());
					}
					
					if (this.getIsShowMarker()) {
						var markerGlyph = new MarkerGlyph();
						markerGlyph.dealCondition4Line(this.getSeriesCollection(), seriesIndex);
						markerGlyph.setShape(new Bounds(point.getX() - 5, point.getY() - 5, 10, 10));
						
						dataPoint.setGlyph(markerGlyph);
					} else {
						dataPoint.setShape(new Bounds(point.getX() - 5, point.getY() - 5, 10, 10));
					}
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
				
				// պ
				linePath.closePath();
				
				if (this.getIsShowLine()) {
					//   LinePlot ɢͼһ ֻ, ûб߿
					var foldLine = new FoldLine(linePath);
	    			foldLine.getLineStyleInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
	    			dataSeries.setGlyph(foldLine);
				}
				
				if (this.getIsFilled()) {
					var shapeGlyph = new ShapeGlyph();
					shapeGlyph.shape = linePath;
					shapeGlyph.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					
					dataSeries.setGlyph(shapeGlyph);
				}
			}
		},
		
		// ߵactionModel --> AreaPath. Χɢ
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			ctx.translate(this.getBounds().getX(), this.getBounds().getY());
			
			if(this.radarAxisGlyph != null) {
				this.radarAxisGlyph.draw(ctx);
			}
			
			xylist.push(this.getBounds().getX());
			xylist.push(this.getBounds().getY());
			
			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				var stepNumber = 12;
				this.getSeries(i).getAnimateGlyph(stepNumber);
			}
			
			this.animateGlyphDraw(ctx, time, this.getSeries(0).getAnimateStepNumber(), xylist);
			
			ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
		},
		
		animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
			var plotGlyph = this;
			var count = 0;
			
			var id = setInterval(function() {
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(xylist[i], xylist[i+1]);
				}
				
				for(var i = 0; i < plotGlyph.getSeriesSize(); i++) {
					plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
				}
				
				count++;
				
				if(count > stepNumber - 1) {
					clearInterval(id);
					for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
						plotGlyph.getSeries(i).drawLabel(ctx);
						
						var dataPoints = plotGlyph.getSeries(i).getPoints();
					    for (var j=0; j < dataPoints.length; j++ ) {
							dataPoints[j].draw(ctx);
					    }
					}
					
					plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
				}
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(-xylist[i], -xylist[i+1]);
				}
			}, time/stepNumber);
		},
		
		setRadarAxisGlyph		:		function(radarAxisGlyph) {
			this.radarAxisGlyph = radarAxisGlyph;
		},
		
		getRadarAxisGlyph		:		function() {
			return this.radarAxisGlyph;
		},
		
		setFilled		:		function(isFilled) {
			this.isFilled	= isFilled;
		},
		
		getIsFilled		:		function() {
			return this.isFilled;
		},
		
		setShowLine		:		function(showLine) {
			this.showLine = showLine;
		},
		
		getIsShowLine	:		function() {
			return this.showLine;
		},
		
		setShowMarker	:		function(showMarker) {
			this.showMarker = showMarker;
		},
		
		getIsShowMarker	:		function() {
			return this.showMarker;
		}
	});
	
	function	LineGlyph(js) {
		this.initConstants(js);
	}
	
	LineGlyph.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			// Ϊline ǲᴫ, RangePlotGlyph.dolayoutʱ.
			this.line = null;
			
			this.lineStyle = js.lineStyle == undefined ? Constants.prototype.LINE_THIN : js.lineStyle;
			this.lineColor = js.lineColor == undefined ? 'black' : js.lineColor;
			this.alpha = js.alpha == undefined ? 1.0 : js.alpha;
		},

		getLine	:	function() {
			return this.line;
		},
		
		setLine	:	function(line) {
			this.line = line;
		},
		
		setLineStyle 	:	function(lineStyle) {
			this.lineStyle = lineStyle;
		},
		
		getLineStyle 	:	function() {
			return this.lineStyle;
		},
		
		setLineColor	:	function(color) {
			this.lineColor = color;
		},
		
		getLineColor	:	function() {
			return this.lineColor;
		},
		
		setAlpha	:	function(alpha){
			this.alpha = alpha;
		},
		
		getAlpha	:	function() {
			return this.alpha;
		},
		
		draw	:	function(ctx) {
			ctx.save();
		
			ctx.globalAlpha = this.getAlpha(); 
			ctx.fillStyle = this.getLineColor();
			ctx.lineWidth = this.getLineStyle();
			
			var start = this.line.getStartPoint();
			var end = this.line.getEndPoint();
			
			ctx.moveTo(start.getX(), start.getY());
			ctx.lineTo(end.getX(), end.getY());
			ctx.stroke();
//	        GraphHelper.drawLine(ctx, line.getX1(), line.getY1(),
//	                line.getX2(), line.getY2(), this.getLineStyle());
	        
	        ctx.restore();
		},
		
		getShape	:	function() {
			return this.line;
		}
	}
	
	function 	StockPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(StockPlotGlyph, PlotGlyph, {
		HIGH_LOW_CLOSE	:	0,
		OPEN_HIGH_LOW_CLOSE	:	1,
		VOLUME_HIGH_LOW_CLOSE	:	2,
		VOLUME_OPEN_HIGH_LOW_CLOSE	:	3,
		
		initConstants		:		function(js) {
			js = js || {};
			
			this.subType = js.subType == undefined ? 0 : js.subType;
			this.errTextGlyph = js.errTextGlyph == undefined ? null : new TextGlyph(js.errTextGlyph);
			
			this.categoryAxisGlyph = js.categoryAxisGlyph == undefined ? null : new CategoryAxisGlyph(js.categoryAxisGlyph);
			this.volumeAxisGlyph = js.volumeAxisGlyph == undefined ? null : new ValueAxisGlyph(js.volumeAxisGlyph);
			this.priceAxisGlyph = js.priceAxisGlyph == undefined ? null : new ValueAxisGlyph(js.priceAxisGlyph);

			this.highLowGlyph = [];
			this.openCloseShapeGlyph = [];
			
			this.upBarBorderLineStyle = js.upBarBorderLineStyle == undefined ? 1 : js.upBarBorderLineStyle;
			this.upBarBorderLineColor = js.upBarBorderLineColor == undefined ? 'black' : js.upBarBorderLineColor;
			this.upBarBackground = js.upBarBackground == undefined ? ColorBackground.getInstance('green') : new ColorBackground(js.upBarBackground);
			
			this.downBarBorderLineStyle = js.downBarBorderLineStyle == undefined ? 1 : js.downBarBorderLineStyle;
			this.downBarBorderLineStyle = js.downBarBorderLineStyle == undefined ? 'black' : js.downBarBorderLineStyle;
			this.downBarBackground = js.downBarBackground == undefined ? ColorBackground.getInstance('red') : new ColorBackground(js.downBarBackground);
			
			this.highLowLineStyle = js.highLowLineStyle == undefined ? 1 : js.highLowLineStyle;
			this.highLowLineColor = js.highLowLineColor == undefined ? 'black' : js.highLowLineColor;
			
			StockPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			this.categoryAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
			this.priceAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
			
			if(this.getSubType() == this.VOLUME_HIGH_LOW_CLOSE 
					|| this.getSubType() == this.VOLUME_OPEN_HIGH_LOW_CLOSE) {
				this.volumeAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
			}
		
			
			this.categoryAxisGlyph.calculateAxisGlyph(this.getBounds());
			this.priceAxisGlyph.calculateAxisGlyph(this.getBounds());
			
			if(this.getSubType() == this.VOLUME_HIGH_LOW_CLOSE 
					|| this.getSubType() == this.VOLUME_OPEN_HIGH_LOW_CLOSE) {
				this.volumeAxisGlyph.calculateAxisGlyph(this.getBounds());
			}
			
			var bg = this.getInfo().getBackground();
//			if(bg instanceof IntervalColorBackground)
		},
		
		layoutDataSeriesGlyph 		:		function() {
			var plotBounds = this.getBounds();
			
			var seriesCount = this.getSeriesSize();
	
			if(this.getErrTextGlyph() != null) {
				var errTextGlyph = this.getErrTextGlyph();
				errTextGlyph.setBounds(new Bounds(0, 0, plotBounds.getWidth(), plotBounds.getHeight()));
				return;
			}
			
			// ҪӸߵ͵
			var lines = [];
			
			for (var seriesIndex = 0; seriesIndex < seriesCount; seriesIndex++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				for (var categoryIndex = 0, categoryCount = dataSeries.getDataPointCount(); 
							categoryIndex < categoryCount; categoryIndex++) {
					
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					var value = dataPoint.getValue();
					
					var shapeGlyph = new ShapeGlyph();
					shapeGlyph.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					dataPoint.setGlyph(shapeGlyph);
					
					if (this.getSubType() == this.HIGH_LOW_CLOSE) {
						var point = new Point2D(
								this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
								this.getPriceAxisGlyph().getPoint2D(value).getY()
								);
						
						if (seriesIndex == 0) {
							lines[categoryIndex] = new Line2D(point, point);
						} else if(seriesIndex == 1) {
							lines[categoryIndex] = new Line2D(lines[categoryIndex].getStartPoint(), point);
						}
						
						shapeGlyph.setShape(new Bounds(point.getX() - 5, point.getY() - 2, 10, 4));
					} else if (this.getSubType() == this.OPEN_HIGH_LOW_CLOSE) {
						var point = new Point2D(
								this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
								this.getPriceAxisGlyph().getPoint2D(value).getY()
								);
						
						if (seriesIndex == 1) {	// HIGH
							lines[categoryIndex] = new Line2D(point, point);
						} else if(seriesIndex == 2) {	// LOW
							lines[categoryIndex] = new Line2D(lines[categoryIndex].getStartPoint(), point);
						}
						
						if (seriesIndex == 0) {	// OPEN
							
						} else if (seriesIndex == 3) {	//CLOSE
							
						}
						
						shapeGlyph.setShape(new Bounds(point.getX() - 5, point.getY() - 2, 10, 4 ));
					} else if (this.getSubType() == this.VOLUME_HIGH_LOW_CLOSE) {
						
						if (seriesIndex == 0) {	// VOLUMN
							var point = new Point2D(
								this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
								this.getVolumeAxisGlyph().getPoint2D(value).getY()
								);
							
							shapeGlyph.setShape(
									new Bounds(
											point.getX() - 5, point.getY(), 10, 
											this.getVolumeAxisGlyph().getPoint2D(0).getY() - point.getY()
									)		
							);
						} else {
							var point = new Point2D(
									this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
									this.getPriceAxisGlyph().getPoint2D(value).getY()
							);
							
							if (seriesIndex == 1) {
								lines[categoryIndex] = new Line2D(point, point);
							} else if(seriesIndex == 2) {
								lines[categoryIndex] = new Line2D(lines[categoryIndex].getStartPoint(), point);
							}
							
							shapeGlyph.setShape(new Bounds(point.getX() - 5, point.getY() - 2, 10, 4));
						}
					} else if (this.getSubType() == this.VOLUME_OPEN_HIGH_LOW_CLOSE) {
						if (seriesIndex == 0) {
							var point = new Point2D(
									this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
									this.getVolumeAxisGlyph().getPoint2D(value).getY()
							);
							
							shapeGlyph.setShape(
									new Bounds(
											point.getX() - 5, point.getY(), 10, 
											this.getVolumeAxisGlyph().getPoint2D(0).getY() - point.getY()
									)		
							);
						} else {
							var point = new Point2D(
									this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX(), 
									this.getPriceAxisGlyph().getPoint2D(value).getY()
							);
							
							if (seriesIndex == 2) {	// HIGH
								lines[categoryIndex] = new Line2D(point, point);
							} else if(seriesIndex == 3) {	// LOW
								lines[categoryIndex] = new Line2D(lines[categoryIndex].getStartPoint(), point);
							}
							shapeGlyph.setShape(new Bounds(point.getX() - 5, point.getY() - 2, 10, 4));
						}
					}
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
			}
			
			/*
			 * alex:ȼShapeټLine,ΪLineҪShape
			 */
			if (this.getSubType() == this.OPEN_HIGH_LOW_CLOSE 
					|| this.getSubType() == this.VOLUME_OPEN_HIGH_LOW_CLOSE) {
				for(var j = 0; j < this.getSeries(0).getDataPointCount(); j ++) {
					var openDataSeries = this.getSeries(this.getSubType() == this.OPEN_HIGH_LOW_CLOSE? 0 : 1);
					var closeDataSeries = this.getSeries(this.getSubType() == this.OPEN_HIGH_LOW_CLOSE? 3 : 4);
					
					var openValue = openDataSeries.getDataPoint(j).getValue();
					var closeValue = closeDataSeries.getDataPoint(j).getValue();
					
					this.openCloseShapeGlyph = [];
							
					if (openValue < closeValue) {	// 
						var openCloseRec = new Bounds(
								this.getCategoryAxisGlyph().getPoint2D(j + 0.5).getX() - 5, 
								this.getPriceAxisGlyph().getPoint2D(closeValue).getY(), 
								10, this.getPriceAxisGlyph().getPoint2D(openValue).getY() 
										- this.getPriceAxisGlyph().getPoint2D(closeValue).getY());
						
//						this.openCloseShapeGlyph[j].setBackground(new ColorBackground("green"));
						
						var shapeGlyph = new ShapeGlyph();
						this.openCloseShapeGlyph[j] = shapeGlyph;
						
						shapeGlyph.setBackground(this.upBarBackground);
						shapeGlyph.setBorderColor(this.upBarBorderLineColor);
						shapeGlyph.setBorderStyle(this.upBarBorderLineStyle);
						shapeGlyph.setShape(openCloseRec);
						
					} else {	// 
						var openCloseRec = new Bounds(
								this.getCategoryAxisGlyph().getPoint2D(j + 0.5).getX() - 5, 
								this.getPriceAxisGlyph().getPoint2D(openValue).getY(), 
								10, this.getPriceAxisGlyph().getPoint2D(closeValue).getY() 
									- this.getPriceAxisGlyph().getPoint2D(openValue).getY());
						
//						this.openCloseShapeGlyph[j].setBackground(new ColorBackground("red"));
						
						var shapeGlyph = new ShapeGlyph();
						this.openCloseShapeGlyph[j] = shapeGlyph;
						
						shapeGlyph.setBackground(this.downBarBackground);
						shapeGlyph.setBorderColor(this.downBarBorderLineColor);
						shapeGlyph.setBorderStyle(this.downBarBorderLineStyle);
						shapeGlyph.setShape(openCloseRec);
					}
				}
			}
			
			// ߵ..
			for (var i = 0; i < lines.length; i ++) {
				this.highLowGlyph[i] = new LineGlyph();
				this.highLowGlyph[i].setLine(lines[i]);
				
				this.highLowGlyph[i].setLineColor(this.highLowLineColor);
				this.highLowGlyph[i].setLineStyle(this.highLowLineStyle);
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			ctx.translate(this.getBounds().getX(), this.getBounds().getY());
			
//			xylist.push(this.getBounds().getX());
//			xylist.push(this.getBounds().getY());
			
			if(this.categoryAxisGlyph != null) {
				this.categoryAxisGlyph.draw(ctx);
			}
			if(this.priceAxisGlyph != null) {
				this.priceAxisGlyph.draw(ctx);
			}
			if(this.volumeAxisGlyph != null) {
				this.volumeAxisGlyph.draw(ctx);
			}
			if(this.errTextGlyph != null) {
				this.errTextGlyph.draw(ctx);
			}
			if(this.highLowGlyph != null && this.highLowGlyph.length > 0) {
				for(var i = 0; i < this.highLowGlyph.length; i++) {
					this.highLowGlyph[i].draw(ctx);
				}
			}
			if(this.openCloseShapeGlyph != null && this.openCloseShapeGlyph.length > 0) {
				for(var i = 0; i < this.openCloseShapeGlyph.length; i++) {
					this.openCloseShapeGlyph[i].draw(ctx);
				}
			}
			
			ctx.translate(-this.getBounds().getX(), -this.getBounds().getY());
			
			StockPlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
		},
		
		setCategoryAxisGlyph 		:		function(categoryAxisGlyph) {
			this.categoryAxisGlyph = categoryAxisGlyph;
		},
		
		getCategoryAxisGlyph 		:		function() {
			return this.categoryAxisGlyph;
		},
		
		setVolumeAxisGlyph 		:		function(volumeAxisGlyph) {
			this.volumeAxisGlyph = volumeAxisGlyph;
		},
		
		getVolumeAxisGlyph		:		function() {
			return this.volumeAxisGlyph;
		},
		
		setPriceAxisGlyph 		:		function(priceAxisGlyph) {
			this.priceAxisGlyph = priceAxisGlyph;
		},
		
		getPriceAxisGlyph		:		function() {
			return this.priceAxisGlyph;
		},
		
		setSubType		:		function(subType) {
			this.subType = subType;
		},
		
		getSubType 		:		function() {
			return this.subType;
		},
		
		setErrTextGlyph 		:		function(errTextGlyph) {
			this.errTextGlyph = errTextGlyph;
		},
		
		getErrTextGlyph			:		function() {
			return this.errTextGlyph;
		},
		
		setHighLowGlyph			:		function(highLowGlyph) {
			this.highLowGlyph = highLowGlyph;
		},
		
		getHighLowGlyph 		:		function() {
			return this.highLowGlyph;
		},
		
		setOpenCloseShapeGlyph 		:		function(openCloseShapeGlyph) {
			this.openCloseShapeGlyph = openCloseShapeGlyph;
		},
		
		getOpenCloseShapeGlyph 		:		function() {
			return this.openCloseShapeGlyph;
		}
	});
	
	function XYScatterPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(XYScatterPlotGlyph, PlotGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.xAxisGlyph = js.xAxisGlyph == undefined ? null : new ValueAxisGlyph(js.xAxisGlyph);
			this.yAxisGlyph = js.yAxisGlyph == undefined ? null : new ValueAxisGlyph(js.yAxisGlyph);
			
			this.showLine = js.showLine == undefined ? true : js.showLine;
			this.showMarker = js.showMarker == undefined ? true : js.showMarker;
				
			this.cateLabelList = new Array();
			if(js.cateLabelList != undefined) {
				var list = js.cateLabelList;
				for(var i = 0; i < list.length; i++) {
					this.cateLabelList.push(list[i]);
				}
			}
			
			XYScatterPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			this.xAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
			this.yAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
		
			
			this.xAxisGlyph.calculateAxisGlyph(this.getBounds());
			this.yAxisGlyph.calculateAxisGlyph(this.getBounds());
			
			var background = this.getInfo().getBackground();
		},
		
		layoutDataSeriesGlyph 		:		function() {
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var lineGeneralPath = new GeneralPath();
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var startX;
					
					/*
					 * alex:ֻһϵ,categoryIndexstartX
					 * жϵ,ԵһϵжӦֵstartX (ڵĻ ǵһϵ..)
					 */
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					if (this.getSeriesSize() == 1) {
						startX = this.xAxisGlyph.getPoint2D(categoryIndex).getX();
					} else {
						startX = this.xAxisGlyph.getPoint2D(this.cateLabelList[categoryIndex]).getX();
					}
					
					var value = dataPoint.getValue();
					
					var startY = this.yAxisGlyph.getBounds().getY() + this.yAxisGlyph.getPoint2D(value).getY();
					
					if (categoryIndex == 0) {
						lineGeneralPath.moveTo(startX, startY);
					} else {
						lineGeneralPath.lineTo(startX, startY);
					}
					
					if(this.showMarker) {
	    				var markerGlyph = new MarkerGlyph();
	    				markerGlyph.dealCondition4Line(this.getSeriesCollection(), seriesIndex);
	    				
						markerGlyph.setShape(new Bounds(startX - 5, startY - 5, 10, 10));
	    				dataPoint.setGlyph(markerGlyph);
	    			} else {
						dataPoint.setShape(new Bounds(startX - 5, startY - 5, 10, 10));
					}
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
				
				if (this.showLine) {
	    			var foldLine = new FoldLine();
	    			dataSeries.setGlyph(foldLine);
	    			
	    			foldLine.setGeneralPath(lineGeneralPath);
	    			foldLine.getLineStyleInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
    			} else {//,ֹ̬ʾBUG
    				var foldLine = new FoldLine();
	    			dataSeries.glyph = foldLine;
    			}
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			ctx.translate(this.getBounds().getX(), this.getBounds().getY());
			
			xylist.push(this.getBounds().getX());
			xylist.push(this.getBounds().getY());
			
			if(this.xAxisGlyph != null) {
				this.xAxisGlyph.draw(ctx);
			}
			if(this.yAxisGlyph != null) {
				this.yAxisGlyph.draw(ctx);
			}
			
			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				// 
				var stepNumber = 12;
				this.dataSeries[i].getAnimateGlyph(stepNumber);
			}
			
			if(this.dataSeries[0]) {
				this.animateGlyphDraw(ctx, time, this.getSeries(0).getAnimateStepNumber(), xylist);
			}
			
			ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
		},
		
		animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
			var plotGlyph = this;
			var count = 0;
			
			var id = setInterval(function() {
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(xylist[i], xylist[i+1]);
				}
				
				for(var i = 0; i < plotGlyph.getSeriesSize(); i++) {
					plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
				}
				
				count++;
				
				if(count > stepNumber - 1) {
					clearInterval(id);
					for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
						plotGlyph.getSeries(i).drawLabel(ctx);
						
						var dataPoints = plotGlyph.getSeries(i).getPoints();
					    for (var j=0; j < dataPoints.length; j++ ) {
							dataPoints[j].draw(ctx);
					    }
					}
					
					plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
				}
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(-xylist[i], -xylist[i+1]);
				}
			}, time/stepNumber);
		},
		
		setXAxisGlyph 		:		function(xAxisGlyph) {
			this.xAxisGlyph = xAxisGlyph;
		},
		
		getXAxisGlyph		:		function() {
			return this.xAxisGlyph;
		},
		
		setYAxisGlyph		:		function(yAxisGlyph) {
			this.yAxisGlyph = yAxisGlyph;
		},
		
		getYAxisGlyph		:		function() {
			return this.yAxisGlyph;
		}
	});	

	function RangePlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(RangePlotGlyph, PlotGlyph, {
		initConstants		:		function(js) {
			js = js || {};
			
			this.rangeAxisGlyph = js.rangeAxisGlyph == undefined ? new RangeAxisGlyph() : new RangeAxisGlyph(js.rangeAxisGlyph);
			
			this.middleLineGlyph = js.middleLineGlyph == undefined ? null : new LineGlyph(js.middleLineGlyph);
			this.seriesWidth = js.seriesWidth == undefined ? 8 : js.seriesWidth;
			
			RangePlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			this.rangeAxisGlyph.init(this.getBounds());
			this.rangeAxisGlyph.calculateAxisLengthUnit();
		},
		
		layoutDataSeriesGlyph		:		function() {
			var plotBounds = this.getBounds();
		
			var width = plotBounds.getWidth();
	    	var height = plotBounds.getHeight();
	    	
	    	// м
	    	var middle_line2D = new Line2D(new Point2D(0, height/2), new Point2D(width, height / 2));
	    	
	    	this.middleLineGlyph.setLine(middle_line2D);
	    	
	    	var range_h = height / 6.0;
	    	
	    	// ֵdataPoint.
	    	for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				var dataPoint = dataSeries.getDataPoint(0);
				var value = this.getRangeAxisGlyph().getPoint2D(dataPoint.getValue());
				// value_rectĿ. width
				var value_rect = new Bounds(
						value.getX() - this.seriesWidth/2, 
						height / 2.0 - range_h/ 2.0 - 4, 
						this.seriesWidth, range_h + 4
				);
				var value_shape = new ShapeGlyph();
				value_shape.shape = value_rect;
				
				value_shape.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				
				dataPoint.setGlyph(value_shape);
				
				this.dealDataPointLabelBounds(dataPoint, seriesIndex);
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
		
			ctx.translate(this.getBounds().getX(), this.getBounds().getY());
			
			if(this.middleLineGlyph != null) {
				this.middleLineGlyph.draw(ctx);
			}
			if(this.rangeAxisGlyph != null) {
				this.rangeAxisGlyph.draw(ctx);
			}
	
			ctx.translate(-this.getBounds().getX(), -this.getBounds().getY());
			
			RangePlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
		},
		
		setRangeAxisGlyph		:		function(rangeAxisGlyph) {
			this.rangeAxisGlyph = rangeAxisGlyph;
		},
		
		getRangeAxisGlyph 		:		function() {
			return this.rangeAxisGlyph;
		},
		
		setMiddleLineGlyph		:		function(middleLineGlyph) {
			this.middleLineGlyph = middleLineGlyph;
		},
		
		getMiddleLineGlyph		:		function() {
			return this.middleLineGlyph;
		}
	});
	
	function 	Meter(title, value, meterStyle) {
		this.setTitle(title);
		this.setValue(value);
		this.meterStyle = meterStyle;
	}
	
	Meter.prototype = {
		value 	:	0,
		titleGlyph 		:		null,
		meterStyle 		:		null,
		
		bounds 			:		null,
		
		// transient
		meterArea		:		null,
		meterMiddleX	:		0,
		meterMiddleY	:		0,
		
		setBounds		:		function(bounds) {
			this.bounds = bounds;
		},
		
		getBounds		:		function() {
			return this.bounds;
		},
		
		draw		:		function(ctx, time, xylist) {
			
			if(time) {
				this.animateDrawMeter(ctx, time, xylist);
			} else {
				var gapHorizontal = (2 * MeterStyle.prototype.DEFAULT_BORDER_SIZE);
		        var gapVertical = (2 * MeterStyle.prototype.DEFAULT_BORDER_SIZE);
		        var meterX = 4 + gapHorizontal / 2;
		        var meterY = 4 + gapVertical / 2;
		        var meterW = this.bounds.getWidth() - 8 - gapHorizontal;
		        var meterH = this.bounds.getHeight() - 8 - gapVertical
		                + ((this.getMeterStyle().getMeterAngle() <= 180) 
		                	&& ! (this.getMeterStyle().getDialShape().equals(MeterStyle.prototype.CIRCLE))
		                ? this.bounds.getHeight() / 1.25 : 0);
		
		        var min = Math.min(meterW, meterH) / 2;
		        meterX = (meterX + meterX + meterW) / 2 - min;
		        meterY = (meterY + meterY + meterH) / 2 - min;
		        meterW = 2 * min;
		        meterH = 2 * min;
		
		        this.meterArea = new Bounds(meterX, meterY, meterW, meterH);
		        this.meterMiddleX = this.meterArea.getX() + this.meterArea.getWidth()/2;
		        this.meterMiddleY = this.meterArea.getY() + this.meterArea.getHeight()/2;
				
		        ctx.translate(this.bounds.getX(), this.bounds.getY());
		        
		        var minValue = this.meterStyle.getStartValue();
				var maxValue = this.meterStyle.getEndValue();
		
				// ɫ/ͼƬ  Ǳ̱ɫ	  
				var backgroundColor = this.meterStyle.getDialBackgroundColor();
				// Ǳɫ
				var radius1 = (this.meterArea.getWidth() / 2) + MeterStyle.prototype.DEFAULT_BORDER_SIZE;
				
				// Ǳ⻡
				var arc = new Arc2D(this.meterMiddleX, this.meterMiddleY, 0.9 * radius1, 0, 360);
				
				if (backgroundColor != null) {
					this.fillArc(ctx, arc, minValue, maxValue, backgroundColor);
				}
	
				arc.paint(ctx);
				
				// ⲿ
				this.paintOutSide(ctx, minValue, maxValue);
	
				for (var i = 0, iCount = this.meterStyle.getIntervalCount(); i < iCount; i++) {
					this.drawArcForInterval(ctx, arc, this.meterStyle.getInterval(i)); // ɫ
				}
				// ̶
				this.drawTickAndLabels(ctx, this.meterArea, minValue, maxValue);
				// ֵ
		        this.drawValueLabel(ctx, this.meterArea);
		        
		        // ͷ
		        this.drawArrow(ctx);  
		        
		        // 
		        this.getTitle().draw(ctx);
		        
		        ctx.translate(-this.bounds.getX(), -this.bounds.getY());
			}
		},
		
		// kunsnat: ıֵָ
		animateDrawMeter	:	function(ctx, time, xylist) {
			var meter = this;
			var step = 20;
			
			var startValue = meter.getMeterStyle().getStartValue();
			var tickValue = meter.getValue();
			
			var actionValue = startValue;
			
			function animateDraw() {
				setTimeout(function() {
					actionValue += (tickValue - startValue)/step;
					
					for(var i = 0; i < xylist.length; i = i + 2) {
						ctx.translate(xylist[i], xylist[i+1]);
					}
					
					var format = meter.meterStyle.getUnitFormat();
			        if(format != null) {
						meter.setValue(FR.contentFormat(actionValue, format));
			        } else {
						// 汣һλС
			        	var number = new Number(actionValue);
			        	meter.setValue(number.toFixed(1));
			        }
					
					meter.draw(ctx);
					
					for(var i = 0; i < xylist.length; i = i + 2) {
						ctx.translate(-xylist[i], -xylist[i+1]);
					}
					
					if(actionValue < tickValue) {
						animateDraw.apply(meter);
					}
					
				}, time/step);
			}
			
			animateDraw();
		},
		
	    // ָ
		drawArrow		:		function(ctx) {
			if ((this.getValue() >= this.meterStyle.getStartValue() && this.getValue() <= this.meterStyle.getEndValue())) {
				ctx.save();
				
				ctx.lineWidth = 2.0;
	
				var radius = 0.8 * ((this.meterArea.getWidth() / 2) + MeterStyle.prototype.DEFAULT_BORDER_SIZE + 15);
				var valueAngle = this.valueToAngle(this.getValue());
				
				// kunsnat: ָͷλ. Ƕȴ, javaͬ, ˳ʱ x᷽.
				var valueP1 = this.meterMiddleX + (radius * Math.cos(Math.PI * (360 - valueAngle) / 180));
				var valueP2 = this.meterMiddleY - (radius * Math.sin(Math.PI * (360 - valueAngle) / 180));
				
				var arrow = new GeneralPath();
				if ((valueAngle > 135 && valueAngle < 225)
						|| (valueAngle < 45 && valueAngle > -45)) {
	
					var valueP3 = (this.meterMiddleY - MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 4);
					var valueP4 = (this.meterMiddleY + MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 4);
					arrow.moveTo(this.meterMiddleX, valueP3);
					arrow.lineTo(this.meterMiddleX, valueP4);
	
				} else {
					arrow.moveTo(
									(this.meterMiddleX - MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 4),
									this.meterMiddleY);
					arrow.lineTo(
									(this.meterMiddleX + MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 4),
									this.meterMiddleY);
				}
				arrow.lineTo(valueP1, valueP2);
				
				// ƽ
				ctx.translate(0, 2);
				
				var shadow1 = ctx.createRadialGradient(this.meterMiddleX, (this.meterMiddleY - 2 * MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 3), 0,
						this.meterMiddleX, (this.meterMiddleY + 2 * MeterStyle.prototype.DEFAULT_CIRCLE_SIZE / 3), radius);
						
				shadow1.addColorStop(0, 'gray');
				shadow1.addColorStop(0.8, 'gray');
				shadow1.addColorStop(1, 'gray');
						
				ctx.fillStyle = shadow1;
				arrow.paint(ctx);
				ctx.translate(0, -2);
				
				ctx.fillStyle = this.meterStyle.getNeedleColor();
				arrow.paint(ctx);

				// circle мԲ
				var circle = new Arc2D(this.meterMiddleX, this.meterMiddleY, 5, 0, 360);
				ctx.fillStyle = 'gray';
				circle.paint(ctx);
				
				ctx.restore();
			}
		},
		
		getShape		:		function() {
			return this.getBounds();
		},
		
		valueToAngle		:		function(value) {
			value = value - this.getMeterStyle().getStartValue();
			// kunsnat: ߴbaseAngle  javaвһ
			var baseAngle = 360 - (this.getMeterStyle().getMeterAngle()/2 + 90);
			return baseAngle + (value / (this.getMeterStyle().getEndValue() - this.getMeterStyle().getStartValue())) 
					* this.getMeterStyle().getMeterAngle();
		},
		
		drawValueLabel		:		function(ctx, area) {
			var valueStr = "No value";
	        // ָʽ()
	        var format = this.meterStyle.getUnitFormat();
	        if(format != null) {
	        	valueStr = FR.contentFormat(this.getValue(), format) + " " + this.meterStyle.getUnits();
	        } else {
	        	valueStr = this.getValue() + " " + this.meterStyle.getUnits();
	        }
	        // x yλ ھƫ
	        var x = area.getX() + area.getWidth() * 0.5;
	        var y = area.getY() + area.getHeight() * 0.45;
	        
	        // ʽ
	        var textAttr = new TextAttr();
			var valueLabel = new TextGlyph();
			valueLabel.text = valueStr;
			valueLabel.textAttr = textAttr;

	        var dim = this.getTextBounds(valueStr, ctx);
			
			var textBounds = new Bounds(x - dim.getWidth()/2.0, y - dim.getHeight(), dim.getWidth(), dim.getHeight());
			// TODO ̶ȵıǩҲҪ.. Ȼ ΢С䶯.
			TextGlyph.drawLabel(ctx, valueStr, textAttr, textBounds);
		},
		
		getTextBounds		:		function(text, ctx) {
			if(text == null) {
				return;
			}
			return new Bounds(0, 0, ctx.measureText(text).width, 12);
		},
		
		drawArc		:		function(ctx, acr, minValue, maxValue, paint, stroke) {
			var startAngle = this.valueToAngle(minValue);
			var endAngle = this.valueToAngle(maxValue);
			var extent = endAngle - startAngle;

			ctx.save();
				
			ctx.strokeStyle = paint;
			ctx.lineWidth = stroke;			
	
			if (paint != null && stroke != null) {
				var arc = new Arc2D(acr.getX(),acr.getY(),acr.getRadius(), startAngle, startAngle + extent);
				arc.stroke4Meter(ctx);
			}
			
			ctx.restore();
		},
		
		// kunsnat: area --> javaͬ. ֱarc, ֻȡͬĽǶ.type
		fillArc		:		function(ctx, arc, minValue, maxValue, paint) {
			if(paint == null) {
				// ״
			}
			
			var startAngle = this.valueToAngle(minValue);
			var endAngle = this.valueToAngle(maxValue);
			
			ctx.save();
			
			ctx.fillStyle = paint;
			
			var tmpArc = new Arc2D(arc.getX(), arc.getY(), arc.getRadius(), startAngle, endAngle);
			tmpArc.paint(ctx);
								
			ctx.restore();
		},
		
		drawArcForInterval		:		function(ctx, arc, interval) {
			var minValue = interval.getBeginValue();
			var maxValue = interval.getEndValue();
	
			var outlinePaint = interval.getOutlineColor();
			// TODO strokeĴϸ ֱõĻ ͼ.
			// νȡ. ֻڲ.. 
			var outlineStroke = interval.getOutlineSize();
			var backgroundPaint = interval.getBackgroundColor();
	
			if (backgroundPaint != null) {
				// meterArea
				this.fillArc(ctx, arc, minValue, maxValue, backgroundPaint);
			}
			if (outlinePaint != null) {
				if (outlineStroke != null) {
					this.drawArc(ctx, arc, minValue, maxValue, outlinePaint, outlineStroke);
				}
			}
		},
		
		drawTickAndLabels		:		function(ctx, meterArea, minValue, maxValue) {
			if(!(this.meterStyle.getTickSize() == 0)) {
				for (var v = minValue; v <= maxValue; v += this.meterStyle.getTickSize()) {
					this.drawTickAndLabelWithValue(ctx, meterArea, v);
				}
			}
		},
		
		paintOutSide		:		function(ctx, minValue, maxValue) {
			if(!(this.meterStyle.getTickSize() == 0)) {
				ctx.save();
				for (var v = minValue; v <= maxValue; v += this.meterStyle.getTickSize()) {
					
					var valueAngle = this.valueToAngle(v);
					var radius = (this.meterArea.getWidth() / 2) + MeterStyle.prototype.DEFAULT_BORDER_SIZE;
					
					var arcd = new Arc2D(this.meterMiddleX, this.meterMiddleY, 1.03 * radius, 0, 360);
							
					ctx.fillStyle = "gray";
					ctx.lineWidth = 1;
					arcd.stroke(ctx);
					
					var arc = new Arc2D(this.meterMiddleX, this.meterMiddleY,0.9 * radius, 0, 360);
					
					ctx.strokeStyle = 'gray';
					ctx.lineWidth = 2;
					arc.stroke(ctx);
					
					// kunsnat: ɫ~  IEFFвͬ  java ͬ...
					var graytowhite = ctx.createRadialGradient(
											this.meterMiddleX,
											this.meterMiddleY,
											radius,
											this.meterMiddleX,
											this.meterMiddleY,
											radius * 1.1
										);
							
					graytowhite.addColorStop(0, 'gray');
					graytowhite.addColorStop(0.9, 'white');
					graytowhite.addColorStop(1, 'gray');
					
					ctx.fillStyle = graytowhite;
					
					ctx.beginPath();
					ctx.arc(this.meterMiddleX, this.meterMiddleY, radius * 1.1, 0, 360, false);
					ctx.fill();
					
//					ctx.fillRect(this.meterMiddleX - 1.1*radius, this.meterMiddleY - 1.1*radius, 2.2*radius, 2.2*radius);
					
//					ctx.fillStyle = oldColor;
//					ctx.fillRect(this.meterMiddleX - 1.1*radius, this.meterMiddleY - 1.1*radius, 2.2*radius, 2.2*radius);
				}
				ctx.restore();
			}
		},
		
		drawTickAndLabelWithValue 		:		function(ctx, meterArea, value) {
			ctx.save();

			var valueAngle = this.valueToAngle(value);
	
			var meterMiddleX = meterArea.getX() + meterArea.getWidth()/2;
			var meterMiddleY = meterArea.getY() + meterArea.getHeight()/2;
	
			ctx.font = "10 px Times New Roman"
			
			ctx.fillStyle = this.meterStyle.getTickColor();
			ctx.strokeStyle = this.meterStyle.getTickColor();
			
			ctx.lineWidth = 2.0;
	
			var valueP2X = 0;
			var valueP2Y = 0;
			var valueP3X = 0;
			var valueP3Y = 0;
			var valueP4X = 0;
			var valueP4Y = 0;
			var valueP5X = 0;
			var valueP5Y = 0;
	
			var radius = (meterArea.getWidth() / 2) + MeterStyle.prototype.DEFAULT_BORDER_SIZE;
			var radius1 = radius * 0.70; // ǩ
			var radius2 = radius * 0.8; // ̶ȱ
			var radius3 = radius * 0.86;
	
			var valueP1X = meterMiddleX
					+ (radius * Math.cos(Math.PI * (valueAngle / 180)));
			var valueP1Y = meterMiddleY
					+ (radius * Math.sin(Math.PI * (valueAngle / 180)));
	
			// ̶λ
			var degrees = Math.PI * (valueAngle / 180);
			valueP2X = meterMiddleX
					+ (radius1 * Math.cos(degrees));
			valueP2Y = meterMiddleY
					+ (radius1 * Math.sin(degrees));
			valueP3X = meterMiddleX
					+ (radius2 * Math.cos(degrees));
			valueP3Y = meterMiddleY
					+ (radius2 * Math.sin(degrees));
					
			ctx.beginPath();
			ctx.moveTo(valueP3X, valueP3Y);
			ctx.lineTo(valueP1X,valueP1Y);
			ctx.stroke();
	
			// С̶(ڿ̶ȴ0ǰ, ȻͲ̶.)
			if(!(this.meterStyle.getTickSize() == 0)) {
				for (var i = 1; i <= ((this.meterStyle.getEndValue() - this.meterStyle.getStartValue()) * 5) / this.meterStyle.getTickSize(); i++) {
					valueP5X = meterMiddleX
					+ (0.9 * radius * Math.cos(Math.PI * (this.valueToAngle(i * (this.meterStyle.getTickSize() / 5)) / 180)));
					valueP5Y = meterMiddleY
					+ (0.9 * radius * Math.sin(Math.PI * (this.valueToAngle(i * (this.meterStyle.getTickSize() / 5)) / 180)));
					valueP4X = meterMiddleX
					+ (radius3 * Math.cos(Math.PI * (this.valueToAngle(i * (this.meterStyle.getTickSize() / 5)) / 180)));
					valueP4Y = meterMiddleY
					+ (radius3 * Math.sin(Math.PI * (this.valueToAngle(i * (this.meterStyle.getTickSize() / 5)) / 180)));
					var smallline = new Line2D(valueP4X, valueP4Y, valueP5X, valueP5Y);
					
					ctx.save();
					ctx.lineWidth = 1;
					
					ctx.beginPath();
					ctx.moveTo(valueP4X, valueP4Y);
					ctx.lineTo(valueP5X, valueP5Y);
					ctx.stroke();
					
					ctx.restore();
				}
			}
	
			// kunsnat: ̶ȱǩǷɼ. ɫͿ̶ȱһ. ָʽ͵λһ.
			if (this.meterStyle.isTickLabelsVisible()) {
				var tickLabel;
				if(this.meterStyle.getUnitFormat() != null) {
					tickLabel = FR.contentFormat.format(value, this.meterStyle.getUnitFormat());
				} else {
					tickLabel = value + "";
				}
				
				var tickLabelBounds = this.getTextBounds(tickLabel, ctx);
				// ַӵмλ.
				var x = valueP2X;
				var y = valueP2Y;
	
				if (valueAngle == 90 || valueAngle == 270) {
					x = x - tickLabelBounds.getWidth() / 2;
					y = y + tickLabelBounds.getHeight() / 4;
					ctx.fillText(tickLabel, x, y);
				} else if (valueAngle < 90 || valueAngle > 270) {
					x = x - tickLabelBounds.getWidth() / 2;
					ctx.fillText(tickLabel, x, y);
				} else if (valueAngle > 90 || valueAngle < 270) {
					y = y + tickLabelBounds.getHeight() / 2;
					x = x - tickLabelBounds.getWidth() / 2;
					ctx.fillText(tickLabel, x, y);
				}
			}
			ctx.restore();
		},
		
		setMeterStyle		:		function(meterStyle) {
			this.meterStyle = meterStyle;
		},
		
		getMeterStyle 		:		function() {
			return this.meterStyle;
		},
		
		setValue		:		function(value) {
			this.value = value;
		},
		
		getValue		:		function() {
			return this.value;
		},
		
		setTitle		:		function(title) {
			this.titleGlyph = title;
		},
		
		getTitle		:		function() {
			return this.titleGlyph;
		}
	}
	
	function	MeterStyle(js) {
		this.initConstants(js);
	}
	
	MeterStyle.prototype = {
		initConstants	:		function(js) {
			js = js || {};
			
			this.dialShape = js.dialShape == undefined ? "CIRCLE" : js.dialShape;
			this.meterAngle = js.meterAngle == undefined ? 270 : js.meterAngle;
			this.startValue = js.startValue == undefined ? 0.0 : js.startValue;
			this.endValue = js.endValue == undefined ? 400 : js.endValue;
			this.tickSize = js.tickSize == undefined ? 50.0 : js.tickSize;
			this.tickColor = js.tickColor == undefined ? 'rgb(51, 204, 204)' : js.tickColor;
			this.units = js.units == undefined ? "λ" : js.units;
			this.unitFormat = js.unitFormat == undefined ? null : js.unitFormat;
			
			this.needleColor = js.needleColor == undefined ? 'rgb(0,255,255)' : js.needleColor;
			
			this.dialBackgroundColor = js.dialBackgroundColor == undefined ? 'gray' : js.dialBackgroundColor;
			this.tickLabelsVisible = js.tickLabelsVisible == undefined ? true : js.tickLabelsVisible;
			
			this.titleTextAttr = js.titleTextAttr == undefined ? new TextAttr() : new TextAttr(js.titleTextAttr);
				
			this.intervals = new Array();
			
			if(js.intervals != undefined && js.intervals.length > 0) {
				for(var i = 0; i < js.intervals.length; i ++) {
					var meterInterval = new MeterInterval(js.intervals[i]);
					this.intervals.push(meterInterval);
				}
			}
		},
		
		DEFAULT_BORDER_SIZE		:		3,
		DEFAULT_CIRCLE_SIZE		:		10,
		CIRCLE		:		"CIRCLE",
		CHORD		:		"CHORD",
		PIE			:		"PIE",
		
		getDialShape		:		function() {
			return this.dialShape;
		},
		
		setDialShape		:		function(dialShape) {
			this.dialShape = dialShape;
		},
		
		getMeterAngle		:		function() {
			return this.meterAngle;
		},
		
		setMeterAngle		:		function(meterAngle) {
			this.meterAngle = meterAngle;
		},
		
		getStartValue 		:		function() {
			return this.startValue;
		},
		
		setStartValue 		:		function(startValue) {
			this.startValue = startValue;
		},
		
		getEndValue		:		function() {
			return this.endValue;
		},
		
		setEndValue		:		function(endValue) {
			this.endValue = endValue;
		},
		
		getTickSize		:		function() {
			return this.tickSize;
		},
		
		setTickSize		:		function(tickSize) {
			this.tickSize = tickSize;
		},
		
		getTickColor	:		function() {
			return this.tickColor;
		},
		
		setTickColor	:		function(tickColor) {
			this.tickColor = tickColor;
		},
		
		setDialBackgroudColor	:		function(color) {
			this.dialBackgroundColor = color;
		},
		
		getDialBackgroundColor	:		function() {
			return this.dialBackgroundColor;
		},
		
		getUnits		:		function() {
			return this.units;
		},
		
		setUnits		:		function(units) {
			this.units = units;
		},
		
		setUnitFormat	:		function(unitFormat) {
			this.unitFormat = unitFormat;
		},
		
		getUnitFormat	:		function() {
			return this.unitFormat;
		},
		
		getNeedleColor		:		function() {
			return this.needleColor;
		},
		
		setNeedleColor		:		function(color) {
			this.needleColor = color;
		},
		
		setTickLabelsVisible	:		function(tickLabelsVisible) {
			this.tickLabelsVisible = tickLabelsVisible;
		},
		
		isTickLabelsVisible	:		function() {
			return this.tickLabelsVisible;
		},
		
		setTitleTextAttr		:		function(textAttr) {
			tihs.titleTextAttr = textAttr;
		},
		
		getTitleTextAttr		:		function() {
			return this.titleTextAttr;
		},
		
		addInterval			:		function(interval) {
			this.getIntervals().push(interval);
		},
		
		getIntervalCount	:		function() {
			return this.getIntervals().length;
		},
		
		getInterval		:		function(index) {
			if(index < 0 || index >= this.getIntervalCount()) {
				return null;
			}
			return this.getIntervals()[index];
		},
		
		clearAllInterval		:		function() {
			if(this.getIntervals() == null) {
				return ;
			}
			this.setIntervals(new Array());
		},
		
		setIntervals	:		function(intervals) {
			this.intervals = intervals;
		},
		
		getIntervals	:		function() {
			return this.intervals;
		}
	}
	
	function	MeterInterval(js) {
		this.initConstants(js);
	}
	
	MeterInterval.prototype = {
		initConstants	:	function(js) {
			js = js || {};
			
			this.stringLabel = js.stringLabel == undefined ? null : js.stringLabel;
			this.beginValue = js.beginValue == undefined ? 0 : js.beginValue;
			this.endValue = js.endValue == undefined ? 0 : js.endValue;
			this.backgroundColor = js.backgroundColor == undefined ? 'black' : js.backgroundColor;
			this.outlineColor = js.outlineColor == undefined ? 'white'	:	js.outlineColor;
			this.outlineSize = js.outlineSize == undefined ? 2 : js.outlineSize;
		},
		
		getStringLabel		:		function() {
			return this.stringLabel;
		},
		
		setStringLabel 		:		function(str) {
			if(str == null) {
				this.stringLabel = "";
			} else {
				this.stringLabel = str;
			}
		},
		
		getBeginValue		:		function() {
			return this.beginValue;
		},
		
		setBeginValue		:		function(begin) {
			this.beginValue = begin;
		},
		
		getEndValue			:		function() {
			return this.endValue;
		},
		
		setEndValue			:		function(end) {
			this.endValue = end;
		},
		
		setOutlineSize		:		function(outlineSize) {
			this.outlineSize = outlineSize;
		},
		
		getOutlineSize		:		function() {
			return this.outlineSize;
		},
		
		setOutlineColor		:		function(color) {
			this.outlineColor = color;
		},
		
		getOutlineColor		:		function() {
			return this.outlineColor;
		},
		
		setBackgroundColor		:		function(color) {
			this.backgroundColor = color;
		},
		
		getBackgroundColor		:		function() {
			return this.backgroundColor;
		}
		
	}
	
	function	MeterPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(MeterPlotGlyph, PlotGlyph, {
		initConstants	:		function(js) {
			js = js || {};
			
			this.meterStyle = js.meterStyle == undefined ? null : new MeterStyle(js.meterStyle);
			
			MeterPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			// do nothing
		},
		
		layoutDataSeriesGlyph		:		function() {
			var plotBounds = this.getBounds();
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var eachWidth = (plotBounds.getWidth() - ((dataSeries.getDataPointCount() + 1) * 10)) / dataSeries.getDataPointCount();
				
				for (var categoryIndex = 0, categoryCount = dataSeries.getDataPointCount(); categoryIndex < categoryCount; categoryIndex++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					var x = 10 + categoryIndex * eachWidth;
					
					var title = dataPoint.getCategoryName();
					// ALEX_CHART ˴titleGlyphbounds,ȻdrawʱNPE
					var dim = TextGlyph.calculateTextDimension(title, this.getMeterStyle().getTitleTextAttr());
					// TextAttrrȿ  .
					var titleGlyph = new TextGlyph(title, this.getMeterStyle().getTitleTextAttr());
					titleGlyph.setBounds(new Bounds((eachWidth - dim.getWidth()) / 2.0, 0, dim.getWidth() , dim.getHeight()));
					
					// TODO   ڶmeter ʱ .
					var meter = new Meter(titleGlyph, dataPoint.getValue(), this.getMeterStyle());
					dataPoint.setGlyph(meter);
					meter.setBounds(new Bounds(x, 0, eachWidth, plotBounds.getHeight()));
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			MeterPlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
		},
		
		setMeterStyle 		:		function(meterStyle) {
			this.meterStyle = meterStyle;
		},
		
		getMeterStyle 		:		function() {
			return this.meterStyle;
		}
	});
	
	function	Cubic(js) {
		this.initConstants(js);
	}
	
	FR.extend(Cubic, GeneralGlyph, {
		TOP	:	0, 
		BOTTOM	:	1,
		LEFT	:	2,
		RIGHT	:	3,
		FRONT	:	4,
		BACK	:	5,
		
		x 	:	0,
		y 	:	0,
		z	:	0,
		width	:	0,
		height	:	0,
		deep 	:	60,
		
		initConstants	:	function(js) {
			js = js || {};
			
			this.projection =  new Projection();
			this.covers = [Cubic.prototype.TOP, Cubic.prototype.RIGHT, Cubic.prototype.FRONT];
			this.points = new Array(8);
			
			Cubic.superclass.initConstants.apply(this, [js]);
		},
		
		setCovers	:	function(covers) {
			this.covers = covers;
		},
		
		setCubic	:	function(x, y, z, width, height, deep) {
			this.x = x;
			this.y = y;
			this.z = z;
			this.width = width;
			this.height = height;
			this.deep = deep;
		},
		
		getDeep		:	function() {
			return this.deep;
		},
		
		setDeep 	:	function(deep) {
			this.deep = deep;
		},
		
		getProjection	:	function() {
			return this.projection;
		},
		
		setProjection	:	function(projection) {
			this.projection = projection;
		},
		
		getBrighterBackground	:	function() {
			var background = this.getBackground();
			
			if(background instanceof ColorBackground) {
				var color = background.getColor();
				if(color != null) {
					return ColorBackground.getInstance(Color.brighter(color));
				}
			}
			
			return background;
		},
		
		getDarkerBackground	:	function() {
			var background = this.getBackground();
			
			if(background instanceof ColorBackground) {
				var color = background.getColor();
				if(color != null) {
					return ColorBackground.getInstance(Color.darker(color));
				}
			}
			
			return background;
		},
		
		draw	:	function(ctx) {
			ctx.save();

			ctx.globalAlpha = this.getAlpha();			
			
			this.init();
			
			if (this.getBackground() != null) {
				var brightBackground = this.getBrighterBackground();
				var darkerBackground = this.getDarkerBackground();
				
				if(this.covers != null) {
					
					for (var i = 0; i < this.covers.length; i ++) {
						switch (this.covers[i]) {
						case Cubic.prototype.TOP: {
							brightBackground.paint(ctx, this.top()); break;						
						}
						case Cubic.prototype.BOTTOM: {
							brightBackground.paint(ctx, this.bottom()); break;
						}
						case Cubic.prototype.LEFT: {
							darkerBackground.paint(ctx, this.left()); break;
						}
						case Cubic.prototype.RIGHT: {
							darkerBackground.paint(ctx, this.right()); break;
						}
						case Cubic.prototype.FRONT: {
							this.getBackground().paint(ctx, this.front()); break;
						}
						case Cubic.prototype.BACK: {
							this.getBackground().paint(ctx, this.back()); break;
						}
						default:
						}
					}
				}
			}
			
			var lineStyle = this.getBorderStyle();
			if (lineStyle != Constants.prototype.LINE_NONE) {
				ctx.strokeStyle = this.getBorderColor();

				if(this.covers != null) {
					for (var i = 0; i < this.covers.length; i ++) {
						ctx.lineWidth = lineStyle;
						switch (this.covers[i]) {
							case Cubic.prototype.TOP: {
								GraphHelper.drawLine(ctx, this.top()); break;						
							}
							case Cubic.prototype.BOTTOM: {
								GraphHelper.drawLine(ctx, this.bottom()); break;	
							}
							case Cubic.prototype.LEFT: {
								GraphHelper.drawLine(ctx, this.left()); break;
							}
							case Cubic.prototype.RIGHT: {
								GraphHelper.drawLine(ctx, this.right()); break;
							}
							case Cubic.prototype.FRONT: {
								GraphHelper.drawLine(ctx, this.front()); break;
							}
							case Cubic.prototype.BACK: {
								GraphHelper.drawLine(ctx, this.back()); break;
							}
							default:
						}
					}
				}
			}
			
			ctx.restore();
		},
		
		getAnimateGlyph	:	function(step) {
			var cubicArray = [];
		
			step = 10;
			for(var i = 0; i < step; i++) {
				var cubic = new Cubic();
				cubicArray[i] = cubic;
				
				if(this.isHorizontal4Cubic) {
					cubic.setCubic(this.x, this.y, this.z, (i + 1) * this.width / step, this.height, this.deep);
					cubic.setInfo(this.info);
					cubic.setProjection(this.projection);
				} else  {
					var actionHeight = (i + 1) * this.height / step;
					cubic.setCubic(this.x, this.y + this.height - actionHeight, this.z, this.width, actionHeight, this.deep);
					cubic.setInfo(this.info);
					cubic.setProjection(this.projection);
				}
			}
			
			return cubicArray;
		},
		
		init	:	function() {
			this.points[0] = this.projection.projectee(this.x, this.y, this.z);
			this.points[1] = this.projection.projectee(this.x + this.width, this.y, this.z);
			this.points[2] = this.projection.projectee(this.x, this.y + this.height, this.z);
			this.points[3] = this.projection.projectee(this.x + this.width,  this.y + this.height, this.z);
			this.points[4] = this.projection.projectee(this.x, this.y, this.z - this.deep);
			this.points[5] = this.projection.projectee(this.x + this.width, this.y, this.z - this.deep);
			this.points[6] = this.projection.projectee(this.x, this.y + this.height, this.z - this.deep);
			this.points[7] = this.projection.projectee(this.x + this.width,  this.y + this.height, this.z - this.deep);
		},
		
		top		:		function() {
			var topArea = new GeneralPath();
			
			topArea.moveTo(this.points[0].getX(), this.points[0].getY());
			topArea.lineTo(this.points[1].getX(), this.points[1].getY());
			topArea.lineTo(this.points[5].getX(), this.points[5].getY());
			topArea.lineTo(this.points[4].getX(), this.points[4].getY());

			return topArea;
		},
		
		bottom	:	function() {
			var bottomArea = new GeneralPath();
		
			bottomArea.moveTo(this.points[2].getX(), this.points[2].getY());
			bottomArea.lineTo(this.points[3].getX(), this.points[3].getY());
			bottomArea.lineTo(this.points[7].getX(), this.points[7].getY());
			bottomArea.lineTo(this.points[6].getX(), this.points[6].getY());
			
			return bottomArea;
		},
		
		right	:	function() {
			var rightArea = new GeneralPath();
		
			rightArea.moveTo(this.points[1].getX(), this.points[1].getY());
			rightArea.lineTo(this.points[3].getX(), this.points[3].getY());
			rightArea.lineTo(this.points[7].getX(), this.points[7].getY());
			rightArea.lineTo(this.points[5].getX(), this.points[5].getY());
			
			return rightArea;
		},
		
		left	:	function() {
			var leftArea = new GeneralPath();
			
			leftArea.moveTo(this.points[0].getX(), this.points[0].getY());
			leftArea.lineTo(this.points[2].getX(), this.points[2].getY());
			leftArea.lineTo(this.points[6].getX(), this.points[6].getY());
			leftArea.lineTo(this.points[4].getX(), this.points[4].getY());
			
			return leftArea;
		},
		
		front	:	function() {
			var frontArea = new GeneralPath();
			
			frontArea.moveTo(this.points[0].getX(), this.points[0].getY());
			frontArea.lineTo(this.points[1].getX(), this.points[1].getY());
			frontArea.lineTo(this.points[3].getX(), this.points[3].getY());
			frontArea.lineTo(this.points[2].getX(), this.points[2].getY());
			
			return frontArea;
		},
		
		back	:	function() {
			var backArea = new GeneralPath();
			
			backArea.moveTo(this.points[4].getX(), this.points[4].getY());
			backArea.lineTo(this.points[5].getX(), this.points[5].getY());
			backArea.lineTo(this.points[7].getX(), this.points[7].getY());
			backArea.lineTo(this.points[6].getX(), this.points[6].getY());
			
			return backArea;
		},
		
		drawPoints	:	function(ctx) {
			ctx.fillText("("+ this.x + "," + this.y + "," + 0 + ")", this.points[0].getX(), this.points[0].getY());
			ctx.fillText("("+ (this.x + this.width) + "," + this.y + "," + 0 + ")", this.points[1].getX(), this.points[1].getY());
			ctx.fillText("("+ this.x + "," + (this.y + this.height) + "," + 0 + ")", this.points[2].getX(), this.points[2].getY());
			ctx.fillText("("+ (this.x + this.width) + "," + (this.y + this.height) + "," + 0 + ")", this.points[3].getX(), this.points[3].getY());
			ctx.fillText("("+ this.x + "," + this.y + "," + (-this.deep) + ")", this.points[4].getX(), this.points[4].getY());
			ctx.fillText("("+ (this.x + this.width) + "," + this.y + "," + (-this.deep) + ")", this.points[5].getX(), this.points[5].getY());
			ctx.fillText("("+ this.x + "," + (this.y + this.height) + "," + (-this.deep) + ")", this.points[6].getX(), this.points[6].getY());
			ctx.fillText("("+ (this.x + this.width) + "," + (this.y + this.height) + "," + (-this.deep) + ")", this.points[7].getX(), this.points[7].getY());
		},
		
		getShape	:	function() {
			this.init();
			
			var generalPath = new GeneralPath();
			if(this.covers != null) {
				for (var i = 0; i < this.covers.length; i ++) {
					switch (this.covers[i]) {
					case Cubic.prototype.TOP: {
						generalPath = this.top();
					}
					case Cubic.prototype.BOTTOM: {
						generalPath = this.bottom();
					}
					case Cubic.prototype.LEFT: {
						generalPath = this.left();
					}
					case Cubic.prototype.RIGHT: {
						generalPath = this.right();
					}
					case Cubic.prototype.FRONT: {
						generalPath = this.front();
					}
					case Cubic.prototype.BACK: {
						generalPath = this.back();
					}
					default:
					}
				}
			}
			
			return generalPath;
		},
		
		getOutlin4Fill	:	function() {
			return this.getShape();
		}
	})
	
function Bar3DPlotGlyph(js) {
	this.initConstants(js);	
}

FR.extend(Bar3DPlotGlyph, BarPlotGlyph, {
	initConstants	:		function(js) {
		js = js || {};
		
		this.projection	 = js.projection == undefined ? new Projection() : new Projection(js.projection);
		this.deep = js.deep == undefined ? -1 : js.deep;
		this.seriesIntervalPercent = js.seriesIntervalPercent == undefined ? 0.0 : js.seriesIntervalPercent;
		this.isCubic3D = js.isCubic3D == undefined ? true : js.isCubic3D;
		this.isCascade = js.isCascade == undefined ? true : js.isCascade;
		
		Bar3DPlotGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	layoutAxisGlyph	:	function() {
		Bar3DPlotGlyph.superclass.layoutAxisGlyph.apply(this, []);
		
		this.layout3DAxisGlyph();
	},
	
	layoutDataSeriesGlyph	:		function() {
		if (this.deep == -1) {
			this.deep = this.getBounds().getWidth();
		}
		
		if (this.getIsCascade() && ! this.getIsStacked()) {
			var seriesCount = this.getSeriesSize();
			var series_deep = this.deep / ((1 + this.getSeriesIntervalPercent()) * seriesCount) ;
			for (var seriesIndex = seriesCount - 1; seriesIndex >= 0; seriesIndex --) {
				var dataSeries = this.getSeries(seriesIndex);
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					var z = - this.getSeriesIntervalPercent() * series_deep * (0.5 + seriesIndex) - series_deep * seriesIndex;
					
					var cubic = new Cubic();
					dataPoint.setGlyph(cubic);
					cubic.setProjection(this.getProjection());
					cubic.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					var rect = this.getBarShape(seriesIndex, categoryIndex);
					cubic.setCubic(rect.getX(), rect.getY(), z, rect.getWidth(), rect.getHeight(), series_deep);
					
					cubic.isHorizontal4Cubic = this.isHorizontal;
					
					this.dealDataPointLabelBounds(dataPoint, cubic);
				}
			}
		} else {
			var series_deep = this.deep / (1 + this.getSeriesIntervalPercent());
			var z = - this.getSeriesIntervalPercent() * series_deep * 0.5;
			for (var seriesIndex = 0, len = this.getSeriesSize(); seriesIndex < len; seriesIndex++) {
				var dataSeries = this.getSeries(seriesIndex);
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					var cubic = new Cubic();
					dataPoint.setGlyph(cubic);
					cubic.setProjection(this.getProjection());
					cubic.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					
					var rect = this.getBarShape(seriesIndex, categoryIndex);
					cubic.setCubic(rect.getX(), rect.getY(), z, rect.getWidth(), rect.getHeight(), series_deep);
					
					cubic.isHorizontal4Cubic = this.isHorizontal;
					
					this.dealDataPointLabelBounds(dataPoint, cubic);
				}
			}
		}
	},
	
	dealDataPointLabelBounds	:		function(dataPoint, cubic) {
		var tg = dataPoint.getDataLabel();
    	if(tg == null) {
    		return;
    	}
    	var dim = tg.preferredDimension();
    	
    	// õ 
    	cubic.init();
    	var rect = cubic.top().getBounds2D();
    	
    	if(this.getIsHorizontal()) {
    		tg.setBounds(new Bounds(
    				rect.getX() + rect.getWidth(), 
    				// kunsnat: y
    				rect.getY() + dim.getHeight(), 
    				dim.getWidth(), dim.getHeight()
    		));
    	} else {
    		tg.setBounds(new Bounds(
    				rect.getX() + (rect.getWidth() - dim.getWidth()) / 2.0, 
    				// kunsnat: y  (- dim.getHeight())
    				rect.getY() , dim.getWidth() + 4, dim.getHeight()	
    		));
    	}
	},
	
	animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
		this.animateReverseGlyphDraw(ctx, time, stepNumber, xylist);
	},
	
	setCubic3D		:		function(isCubic3D) {
		this.isCubic3D	= isCubic3D;
	},
	
	getIsCubic3D	:		function() {
		return this.isCubic3D;
	},
	
	setCascade		:		function(isCascade) {
		this.isCascade	= isCascade;
	},
	
	getIsCascade	:		function() {
		return this.isCascade;
	},
	
	setSeriesIntervalPercent	:		function(seriesIntervalPercent) {
		this.seriesIntervalPercent	= seriesIntervalPercent;
	},
	
	getSeriesIntervalPercent	:		function() {
		return this.seriesIntervalPercent;
	},
	
	setDeep		:		function() {
		this.deep = deep;
	},
	
	getDeep		:		function() {
		return this.deep;
	},
	
	getProjection		:		function() {
		return this.projection;
	},
	
	setProjection		:		function(projection) {
		this.projection	= projection;
	}
	
});


	function FoldLine3D(z, deep) {
		this.setZ(z);
		this.setDeep(deep);
		
		this.initConstants();
	}
	
	FoldLine3D.prototype = {
		initConstants	:	function() {
			this.projection = new Projection();
			this.colorInfo = new ColorInfo();
			this.point_list = new Array();
		},
		
		moveTo	:	function(x, y) {
			this.point_list = new Array();
			
			this.point_list.push(new Point2D(x,y));
		},
		
		lineTo	:	function(x, y) {
			this.point_list.push(new Point2D(x, y));
		},
		
		draw	:	function(ctx) {
			var generalPaths = this.getGeneralPaths();
			for(var i = 0; i < generalPaths.length; i++) {
				this.getColorInfo().paint(ctx, generalPaths[i]);
			}
		},
		
		// acitonĶ̬
		getActionAnimatePoint	:	function() {
			// TODO ԺҪ isStart.  
			var actionPoints = new Array();
			// ÿмֳ9. 3--> 21̬(ԭ)
			// ݵóstep
			var points = this.point_list;
			for(var i = 0; i < points.length - 1; i++) {
				var point1 = points[i];
				var x1 = point1.getX();
				var y1 = point1.getY();
				
				var point2 = points[i+1];
				var x2 = point2.getX();
				var y2 = point2.getY();
				
				for(var step = 0; step < 10; step++) {
					var actionX = x1 + (x2 - x1) * step * 0.1;
					var actionY = y1 + (y2 - y1) * step * 0.1;
					actionPoints.push(new Point2D(actionX, actionY));
				}
				// һ
				if(i == points.length - 2) {
					actionPoints.push(point2);
				}
			}
			
			return actionPoints;
		},
		
		getAnimateGlyph	:	function(step) {
			var foldLineArray = [];
			
			var actionPoints = this.getActionAnimatePoint();
			for(var animate = 0; animate < actionPoints.length; animate++) {
				
				var foldLine = new FoldLine3D(this.z, this.deep);
				foldLineArray[animate] = foldLine;
				
				foldLine.setProjection(this.projection);
				foldLine.setColorInfo(this.colorInfo);
				
				for(var i = 0; i < animate; i++) {
					var point = actionPoints[i];
					if(i == 0) {
						foldLine.moveTo(point.getX(), point.getY());
					} else {
						foldLine.lineTo(point.getX(), point.getY());
					}
				}
			}
			
			return foldLineArray;
		},
		
		getGeneralPaths	:	function() {
			var pathList = new Array();
			
			for(var i = 0; i < this.getPoint_list().length - 1; i ++) {
				var list = this.getPoint_list();
				
				var x1 = this.getPoint_list()[i].getX();
				var y1 = this.getPoint_list()[i].getY();
				var x2 = this.getPoint_list()[i+1].getX();
				var y2 = this.getPoint_list()[i+1].getY();
				
				var p_1 = this.getProjection().projectee(x1, y1, this.getZ());
				var p_2 = this.getProjection().projectee(x2, y2, this.getZ());
				var p_3 = this.getProjection().projectee(x2, y2, this.getZ() - this.getDeep());
				var p_4 = this.getProjection().projectee(x1, y1, this.getZ() - this.getDeep());
				
				var area = new GeneralPath();
				area.moveTo(p_1.getX(), p_1.getY());
				area.lineTo(p_2.getX(), p_2.getY());
				area.lineTo(p_3.getX(), p_3.getY());
				area.lineTo(p_4.getX(), p_4.getY());
				
				pathList.push(area);
			}
			
			return pathList;
		},
		
		getShape	:	function() {
			var generalPath = new GeneralPath();
		
			var generalPaths = this.getGeneralPaths();
			for (var i = 0; i < generalPaths.length; i ++) {
				generalPath.append(generalPaths[i], false);
			}
			
			return generalPath;
		},
		
		setZ	:	function(z) {
			this.z = z;
		},
		
		getZ	:	function() {
			return this.z;
		},
		
		setProjection	:	function(projection) {
			this.projection = projection;
		},
		
		getProjection	:	function() {
			return this.projection;
		},
		
		setDeep	:	function(deep) {
			this.deep = deep;
		},
		
		getDeep	:	function() {
			return this.deep;
		},
		
		setPoint_list	:	function(point_list) {
			this.point_list = point_list;
		},
		
		getPoint_list	:	function() {
			return this.point_list;
		},
		
		setColorInfo	:	function(colorInfo) {
			this.colorInfo = colorInfo;
		},
		
		getColorInfo	:	function() {
			return this.colorInfo;
		}
	}
	
	function	Line3DPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(Line3DPlotGlyph, CategoryPlotGlyph, {
		initConstants	:		function(js) {
			js = js || {};
			this.projection = js.projection == undefined ? new Projection() : new Projection(js.projection);
			this.seriesIntervalPercent = js.seriesIntervalPercent == undefined ?  0 : js.seriesIntervalPercent;
			this.deep = js.deep == undefined ? -1 : js.deep;
			
			Line3DPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			Line3DPlotGlyph.superclass.layoutAxisGlyph.apply(this, []);
			
			this.layout3DAxisGlyph();
		},
		
		layoutDataSeriesGlyph	:		function() {
			if (this.deep == -1) {
				this.deep = this.getBounds().getWidth();
			}
			var seriesCount = this.getSeriesSize();
			var series_deep = this.deep / ((1 + this.getSeriesIntervalPercent()) * seriesCount) ;
			
			for (var seriesIndex = seriesCount - 1; seriesIndex >= 0; seriesIndex --) {
				var dataSeries = this.getSeries(seriesIndex);
				
				var z = -this.getSeriesIntervalPercent() * series_deep * (0.5 + seriesIndex) - series_deep * seriesIndex;
				
				var foldLine3D = new FoldLine3D(z, series_deep);
				dataSeries.setGlyph(foldLine3D);
				foldLine3D.getColorInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				
				for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
					var dataPoint = dataSeries.getDataPoint(categoryIndex);
					
					var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
					
					var point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX();				
					var point_y;
					
					if (this.getIsStacked()) {
						var pre_sum = 0;	// ǰϵеĳ
						for (var i = seriesIndex - 1; i >= 0; i --) {
							pre_sum += this.getDataPointPercentValue(i, categoryIndex);
						}
						
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
					} else {
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(value).getY();
					}
					
					if (categoryIndex == 0) {
						foldLine3D.moveTo(point_x, point_y);
					} else {
						foldLine3D.lineTo(point_x, point_y);
					}
					
					var p = this.projection.projectee(point_x, point_y, z);
					dataPoint.setShape(
							new Arc2D(p.getX(), p.getY(), 6, 0, 360)		
					);
					
					this.dealDataPointLabelBounds(dataPoint, seriesIndex);
				}
			}
		},
		
		setSeriesIntervalPercent	:		function(seriesIntervalPercent) {
			this.seriesIntervalPercent	= seriesIntervalPercent;
		},
		
		getSeriesIntervalPercent	:		function() {
			return this.seriesIntervalPercent;
		},
		
		setDeep		:		function() {
			this.deep = deep;
		},
		
		getDeep		:		function() {
			return this.deep;
		},
		
		getProjection		:		function() {
			return this.projection;
		},
		
		setProjection		:		function() {
			this.projection	= projection;
		}
	});


	function	Area3D(z, deep) {
		Area3D.superclass.constructor.apply(this, [z,deep]);
		
		this.initConstants();
	}
	
	FR.extend(Area3D, FoldLine3D, {
		initConstants	:	function() {
			Area3D.superclass.initConstants.apply(this, []);
		},
		
		draw	:	function(ctx) {
			Area3D.superclass.draw.apply(this, [ctx]);
			
			// color.brighter....  ⲿ Ⱦ
			var oldColor = this.getColorInfo().getSeriesColor();
			if(this.getColorInfo() != null && this.getColorInfo().getSeriesColor() != null) {
				this.getColorInfo().setSeriesColor(Color.brighter(this.getColorInfo().getSeriesColor()));
			}
			
			this.getColorInfo().paint(ctx, this.getFrontArea());
			
			// ָcolor
			if(this.getColorInfo() != null && this.getColorInfo().getSeriesColor() != null) {
				this.getColorInfo().setSeriesColor(oldColor);
			}
		},
		
		/**
		 * õ̬Ĳglyph, Area3D.
		 */
		getAnimateGlyph	:	function(step) {
			var resultArea3D = [];
			var actionStep = 0;
			
			for(var j = 0; j< step; j++) {
				// kunsnat: ֤stepͬ. һglyph
				actionStep += 1/step;
				
				var tmpArea3D = new Area3D(this.z, this.deep);
				tmpArea3D.setColorInfo(this.colorInfo);
				tmpArea3D.projection = this.projection;
				
				resultArea3D[j] = tmpArea3D;
				
				// ԳƵĵ, ӵһ㿪ʼ, Area3DPlotеļ¼й
				var points = this.point_list;
				for(var i = 0; i < points.length; i++) {
					var p1 = points[i];
					var p2 = points[points.length - 1 - i];
					
					if(i < points.length/2) {
						var x1 = p2.x + (p1.x - p2.x) * actionStep;
						var y1 = p2.y + (p1.y - p2.y) * actionStep;
						if(i == 0) {
							tmpArea3D.moveTo(x1, y1);
						} else {
							tmpArea3D.lineTo(x1, y1);
						}
					} else {
						tmpArea3D.lineTo(p1.x, p1.y);
					}
				}
			}
			
			return resultArea3D;
		},
		
		getFrontArea	:	function() {
			var areaPaths = new GeneralPath();
			for (var i = 0; i < this.getPoint_list().length; i ++) {
				var p = this.getProjection().projectee(this.getPoint_list()[i].getX(), this.getPoint_list()[i].getY(), this.getZ());
				
				if(i == 0) {
					areaPaths.moveTo(p.getX(), p.getY());
				} else {
					areaPaths.lineTo(p.getX(), p.getY());
				}
			}
			
			return areaPaths;
		},
		
		getShape	:	function() {
			var frontArea = this.getFrontArea();
			
			frontArea.append(Area3D.superclass.getShape.apply(this, []), false);
			
			return frontArea;
		}
	});
	
	function	Area3DPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(Area3DPlotGlyph, CategoryPlotGlyph, {
		initConstants	:		function(js){
			js = js || {};
			
			this.deep = js.deep == undefined ? -1 : js.deep;
			this.seriesIntervalPercent = js.seriesIntervalPercent == undefined ? 3 : js.seriesIntervalPercent;
			this.projection = js.projection == undefined ? new Projection() : new Projection(js);
			
			Area3DPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			Area3DPlotGlyph.superclass.layoutAxisGlyph.apply(this, []);

			this.layout3DAxisGlyph();
		},
		
		layoutDataSeriesGlyph		:		function() {
			var deep = this.getDeep();
			if (deep == -1) {
				deep = this.getBounds().getWidth();
			}
			
			if (this.getIsStacked()) {
				var series_deep = deep / (1 + this.getSeriesIntervalPercent());
				var z = - this.getSeriesIntervalPercent() * series_deep * 0.5;
				
				for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex ++) {
					var dataSeries = this.getSeries(seriesIndex);
					
					var area3D = new Area3D(z, series_deep);
					dataSeries.setGlyph(area3D);
					
					area3D.setProjection(this.projection);
					area3D.getColorInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					
					// ʼ
					var pre_value = [];
					
					var point_x = this.getCategoryAxisGlyph().getPoint2D(0.0).getX();
					var point_y = this.getValueAxisGlyph().getPoint2D(0).getY();
					
					for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
						var dataPoint = dataSeries.getDataPoint(categoryIndex);
						
						var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
						
						point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX();
						
						var pre_sum = 0;
						
						for (var i = seriesIndex - 1; i >= 0; i --) {
							pre_sum += this.getDataPointPercentValue(i, categoryIndex);
						}
						
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum + value).getY();
						pre_value[categoryIndex] = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(pre_sum).getY();
						
						if (categoryIndex == 0) {
							area3D.moveTo(point_x, point_y);
						} else {
							area3D.lineTo(point_x, point_y);
						}
						
						var p = this.projection.projectee(point_x, point_y, z);
						dataPoint.setShape(
								new Arc2D(p.getX(), p.getY(), 6, 0, 360)		
						);
						
						this.dealDataPointLabelBounds(dataPoint, seriesIndex);
					}
					
					for (var i = pre_value.length - 1; i >= 0; i --) {
						area3D.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX(), pre_value[i]);
					}
				}
			} else {
				var seriesCount = this.getSeriesSize();
				var series_deep = deep / ((1 + this.getSeriesIntervalPercent()) * seriesCount) ;
				
				for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex++) {
					var dataSeries = this.getSeries(seriesIndex);
					
					var z = - this.getSeriesIntervalPercent() * series_deep * (0.5 + seriesIndex) - series_deep * seriesIndex;
					
					var area3D = new Area3D(z, series_deep);
					dataSeries.setGlyph(area3D);
					area3D.setProjection(this.projection);
					
					area3D.getColorInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					
					// ʼ
					var pre_value =	[];
					
					var point_x = this.getCategoryAxisGlyph().getPoint2D(0.0).getX();
					var point_y = this.getValueAxisGlyph().getPoint2D(0).getY();
					
					for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
						var dataPoint = dataSeries.getDataPoint(categoryIndex);
						
						var value = dataSeries.getDataPoint(categoryIndex).getValue();
						
						point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX();
						
						point_y = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(value).getY();
						pre_value[categoryIndex] = this.getValueAxisGlyph().getBounds().getY() + this.getValueAxisGlyph().getPoint2D(0).getY();
						
						if (categoryIndex == 0) {
							area3D.moveTo(point_x, point_y);
						} else {
							area3D.lineTo(point_x, point_y);
						}
						
						var p = this.projection.projectee(point_x, point_y, z);
						
						dataPoint.setShape(
								new Arc2D(p.getX(), p.getY(), 6, 0, 360)		
						);
						
						this.dealDataPointLabelBounds(dataPoint, seriesIndex);
					}
					
					for (var i = pre_value.length - 1; i >= 0; i --) {
						area3D.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX(), pre_value[i]);
					}
				}
			}
		},
		
		animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
			// Ļ.
			this.animateReverseGlyphDraw(ctx, time, stepNumber, xylist);
		},
		// ͼ, animateGlyph, еĽл
		createCateAnimateGlyph	:	function() {
			this.cateAnimateGlyph = [];
			for(var i = 0, len = this.getSeriesSize(); i < len; i++) {
				this.cateAnimateGlyph = this.cateAnimateGlyph.concat(this.getSeries(i).animateGlyph)
			}
		},
		
		getCateAnimateStepNumber	:	function() {
			return this.cateAnimateGlyph.length;
		},
		
		drawCateAnimateGlyph	:	function(ctx, count) {
			this.cateAnimateGlyph[count].draw(ctx);
		},

		setSeriesIntervalPercent	:		function(seriesIntervalPercent) {
			this.seriesIntervalPercent	= seriesIntervalPercent;
		},
		
		getSeriesIntervalPercent	:		function() {
			return this.seriesIntervalPercent;
		},
		
		setDeep		:		function() {
			this.deep = deep;
		},
		
		getDeep		:		function() {
			return this.deep;
		},
		
		getProjection		:		function() {
			return this.projection;
		},
		
		setProjection		:		function() {
			this.projection	= projection;
		}
	});
	
	function	CustomPlotGlyph(js) {
		this.initConstants(js);	
	}
	
	FR.extend(CustomPlotGlyph, CategoryPlotGlyph, {
		initConstants	:	function(js) {
			js = js || {};
			
			this.hasSecondValueAxis = js.hasSecondValueAxis == undefined ? true : js.hasSecondValueAxis;
			this.secondValueAxisGlyph = js.secondValueAxisGlyph == undefined ? null : new ValueAxisGlyph(js.secondValueAxisGlyph);
			
			CustomPlotGlyph.superclass.initConstants.apply(this, [js]);
		},
		
		layoutAxisGlyph		:		function() {
			// kunsnat: dealPlotBounds
			if(this.hasSecondValueAxis && this.secondValueAxisGlyph != null) {
				this.secondValueAxisGlyph.dealPlotBoundsWithAxisLabel(this.getBounds());
			}
			
			CustomPlotGlyph.superclass.layoutAxisGlyph.apply(this, []);
			
			if(this.hasSecondValueAxis && this.secondValueAxisGlyph != null) {
				this.secondValueAxisGlyph.calculateAxisGlyph(this.getBounds());
			}
		},
		
		layoutDataSeriesGlyph		:		function() {
					// ¼ϵеĸ ڽͼͼмλ.
			var barSeriesCount = 0;
			for (var i = 0; i < this.getSeriesSize(); i++ ) {
				var seriesAttr = this.getSeriesCollection().getSeriesAttr(i);
				var render = seriesAttr.getRenderer();
				if(render == CustomAttr.prototype.BAR_RENDERER){
					barSeriesCount++;
				}
			}
	
			// kunsnat: ͸updateʱdefaultPlotݸcustomPlot(ͳһcustomPlotdataSeriesC.defaultAlpha)
			var barSeriesIndex = 0;
			for (var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex++ ) {
				var customSeriesAttr = this.getSeriesCollection().getSeriesAttr(seriesIndex);
				var dataSeries = this.getSeries(seriesIndex);
				
				var render = customSeriesAttr.getRenderer();
				
				var currentValueAxisGlyph = customSeriesAttr.axisPosition == CustomAttr.prototype.Axis_RIGHT ? this.getSecondValueAxisGlyph() : this.getValueAxisGlyph();
				
				if(render == CustomAttr.prototype.BAR_RENDERER) {
					for (var j = 0; j < dataSeries.getDataPointCount(); j ++) {
						var dataPoint = dataSeries.getDataPoint(j);
					
						// ϵкƥϵ TODO  barPlotGlyph
						var barPlotGlyph = new Bar2DPlotGlyph();
						var sg = new ShapeGlyph();
						sg.shape = barPlotGlyph.getBarShape4CustomPlot(seriesIndex, j, this.getCategoryAxisGlyph(), currentValueAxisGlyph, this, barSeriesCount, barSeriesIndex);
						dataPoint.setGlyph(sg);
						
						// TODO ==> Series  getBackground--   ֮ǰж
						sg.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
						
						this.dealDataPointLabelBounds(dataPoint, seriesIndex);
					}
					barSeriesIndex ++;
				}
				if(render == CustomAttr.prototype.AREA_RENDERER) {
					var areaPaths = new GeneralPath();
					var sg = new ShapeGlyph(); sg.shape = areaPaths;
					dataSeries.setGlyph(sg);
					
					sg.getInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
					
					var pre_value = [];
					
					var point_x = this.getCategoryAxisGlyph().getPoint2D(0.0).getX();
					var point_y = currentValueAxisGlyph.getPoint2D(currentValueAxisGlyph.getCrossValue()).getY();
					areaPaths.moveTo(point_x, point_y);
					
					for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
						var dataPoint = dataSeries.getDataPoint(categoryIndex);
						
						var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
						// x ǵȫplot
						if(categoryIndex == dataSeries.getDataPointCount() - 1) {
							point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX()  + this.getCategoryAxisGlyph().getUnitLen();
						} else if(categoryIndex > 0) {
							point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX()  + this.getCategoryAxisGlyph().getUnitLen() /2;
						} else if(categoryIndex == 0) {
							point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex).getX();
						}
						
						var pre_sum = currentValueAxisGlyph.getCrossValue();
						
						point_y = currentValueAxisGlyph.getBounds().getY() + currentValueAxisGlyph.getPoint2D(value).getY();
						
						pre_value[categoryIndex] = currentValueAxisGlyph.getBounds().getY() + currentValueAxisGlyph.getPoint2D(pre_sum).getY();
	
						areaPaths.lineTo(point_x, point_y);
						
						dataPoint.setShape(
								new Arc2D(point_x - 3, point_y - 3, 6, 6, 0, 360, Arc2D.PIE)		
						);
						
						this.dealDataPointLabelBounds(dataPoint, seriesIndex);
					}
					
					for (var i = pre_value.length - 1; i >= 0; i --) {
						// ͼǵȫplot
						if(i == pre_value.length - 1) {
							areaPaths.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX() + this.getCategoryAxisGlyph().getUnitLen() , pre_value[i]);
						} else if(i > 0) {
							areaPaths.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX(), pre_value[i]);
						} else if(i == 0) {
							areaPaths.lineTo(this.getCategoryAxisGlyph().getPoint2D(i).getX(), pre_value[i]);
						}
					}
				}
				if(render == CustomAttr.prototype.LINE_RENDERER) {
					var linePaths = new GeneralPath(GeneralPath.WIND_NON_ZERO);
					
					for (var categoryIndex = 0; categoryIndex < dataSeries.getDataPointCount(); categoryIndex ++) {
						var dataPoint = dataSeries.getDataPoint(categoryIndex);
						
						var value = this.getDataPointPercentValue(seriesIndex, categoryIndex);
						
						// alex:˴ȡxλõʱ,Ϊʼ㲻ǿ,аλƫ
						var point_x = this.getCategoryAxisGlyph().getPoint2D(categoryIndex + 0.5).getX();				
						var point_y;
						
						point_y = currentValueAxisGlyph.getBounds().getY() + currentValueAxisGlyph.getPoint2D(value).getY();
	
						if (categoryIndex == 0) {
							linePaths.moveTo(point_x, point_y);
						} else {
							linePaths.lineTo(point_x, point_y);
						}
						
						var markerGlyph = new MarkerGlyph();
						markerGlyph.dealCondition4Line(this.getSeriesCollection(), seriesIndex);
						markerGlyph.setShape(new Bounds(point_x - 5, point_y - 5, 10, 10));
						
						dataPoint.setGlyph(markerGlyph);
						
						this.dealDataPointLabelBounds(dataPoint, seriesIndex);
					}
					
					var foldLine = new FoldLine(linePaths); 
					dataSeries.setGlyph(foldLine);
					
					foldLine.getLineStyleInfo().dealCondition(this.getSeriesCollection(), seriesIndex);
				}
			}
		},
		
		draw		:		function(ctx, time, xylist) {
			this.drawInfo(ctx);
			
			ctx.translate(this.getBounds().getX(), this.getBounds().getY());
			
			if(this.hasSecondValueAxis && this.secondValueAxisGlyph != null) {
				this.secondValueAxisGlyph.draw(ctx);
			}
			
			ctx.translate(-this.getBounds().getX(), -this.getBounds().getY());
			
			CustomPlotGlyph.superclass.draw.apply(this, [ctx, time, xylist]);
		},
		
		/**
		 * kunsnat: , ߵĶ̬, ΪߺӻstepNumber ܿܲһ. 
		 * ԴߵstepNumber û. ʵԷŵPlotGlyph, setIntervalͶ.Ȳ
		 */ 
		animateGlyphDraw	:	function(ctx, time, stepNumber, xylist) {
			
			var maxStepNumber = 0;
			
			for(var seriesIndex = 0; seriesIndex < this.getSeriesSize(); seriesIndex++) {
				maxStepNumber = Math.max(maxStepNumber,this.getSeries(seriesIndex).getAnimateStepNumber());
			}
			
			this.animateDraw(ctx, time, maxStepNumber, xylist);
		},
		
		// kunsnat: intervalļ, ֵ. countȽ. numberͲ.
		animateDraw	:	function(ctx, time, stepNumber, xylist) {
			var count = 0;
			var plotGlyph = this;
			
			var id = setInterval(function() {
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(xylist[i], xylist[i+1]);
				}
				
				for(var i = 0; i < plotGlyph.getSeriesSize(); i++) {
					
					// ֮ǰжstepNumberĴС
					if(count < plotGlyph.getSeries(i).getAnimateStepNumber()) {
						plotGlyph.getSeries(i).drawAnimateGlyph(ctx, count);
					}
				}
				
				count++;
				
				if(count > stepNumber - 1) {
					clearInterval(id);
					
					for(var i = 0, len = plotGlyph.getSeriesSize(); i < len; i++) {
						plotGlyph.getSeries(i).drawLabel(ctx);
						
						if(plotGlyph.getSeriesCollection().getSeriesAttr(i).getRenderer() == CustomAttr.prototype.LINE_RENDERER) {
							// kunsnat: Ҫֻ ߵMarker 
							var dataPoints = plotGlyph.getSeries(i).getPoints();
						    for (var j=0; j < dataPoints.length; j++ ) {
								dataPoints[j].draw(ctx);
						    }
						}
					}
					
					plotGlyph.drawLegendGlyphAndTitleGlyph(ctx, xylist);
				}
				
				for(var i = 0; i < xylist.length; i = i + 2) {
					ctx.translate(-xylist[i], -xylist[i+1]);
				}
			}, time/stepNumber);
		},
		
		setHasSecondValueAxis	:		function(hasSecond) {
			this.hasSecondValueAxis = hasSecond;
		},
		
		getHasSecondValueAxis	:		function() {
			return this.hasSecondValueAxis;
		},
		
		setSecondValueAxisGlyph	:		function(secondValueAxisGlyph) {
			this.secondValueAxisGlyph = secondValueAxisGlyph;
		},
		
		getSecondValueAxisGlyph 	:		function() {
			return this.secondValueAxisGlyph;
		}
	});
	
function DataPoint(js) {
	this.initConstants(js);
}

DataPoint.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		this.categoryIndex = js.categoryIndex == undefined ? 0 : js.categoryIndex;
		this.value = js.value == undefined ? 0 : js.value;
		this.categoryName = js.categoryName == undefined ? null : js.categoryName;
		this.valueIsNull = js.valueIsNull == undefined ? false : js.valueIsNull;
		this.seriesName = js.seriesName == undefined ? null : js.seriesName;
		this.percentValue = js.percentValue == undefined ? 0 : js.percentValue;
		this.seriesLabel = js.seriesLabel == undefined ? null : js.seriesLabel;
		// ǩ
		this.dataLabel = js.dataLabel == undefined ? null : new TextGlyph(js.dataLabel);
		// dolayout֮
		this.glyph = null;
		this.leadLine = null;
	},
	
	getIndex	:		function() {
		return this.categoryIndex;
	},
	
	setIndex	:		function(index) {
		this.categoryIndex	= index;
	},
	
	getValue		:		function()
	{
		return this.value;
	},
	
	setValue		:		function(value)
	{
		this.value = value;
	},
	
	setPercentValue		:		function(percentValue) {
		this.percentValue = percentValue;
	},
	
	getPercentValue		:		function() {
		return this.percentValue;
	},
	
	getSeriesName		:		function()
	{
		return this.seriesName;
	},
	
	setSeriesName		:		function(seriesName)
	{
		this.seriesName = seriesName;
	},
	
	getCategoryName		:		function()
	{
		return this.categoryName;
	},
	
	setCategoryName		:		function(categoryName)
	{
		this.categoryName = categoryName;
	},
	
	setSeriesLabel		:		function(seriesLabel) {
		this.seriesLabel = seriesLabel;
	},
	
	getSeriesLabel		:		function() {
		return this.seriesLabel;
	},
	
	setGlyph		:		function(glyph) 
	{
	    this.glyph = glyph;
	},
	
	getGlyph		:		function()
	{
	   	return this.glyph;
	},
	
	setDataLabel	:		function(dataLabel) {
		this.dataLabel	= dataLabel;
	},
	
	getDataLabel	:		function() {
		return this.dataLabel;
	},
	
	setLeadLine		:		function(leadLine) {
		this.leadLine	= leadLine;
	},
	
	getLeadLine		:		function() {
		return this.leadLine;
	},
	
	setShape		:	function(shape) {
		var shapeGlyph = new ShapeGlyph();
		shapeGlyph.shape = shape;
		this.glyph = shapeGlyph;
	},
	
	getShape		:		function() {
		return this.glyph == null ? null : this.glyph.getShape();
	},
	
	draw		:		function(ctx, time, xylist) {
	   	var glyph = this.getGlyph();
	  	if(glyph != null) {
		    glyph.draw(ctx, time, xylist);
	  	}
	},
	
	getAnimateGlyph	:	function(step) {
		if(this.glyph != null) {
			this.animateGlyph = this.glyph.getAnimateGlyph(step);
		}
	},
	
	drawAnimateGlyph	:	function(ctx, count) {
		if(this.animateGlyph != null && this.animateGlyph.length > 0 && count < this.animateGlyph.length) {
			this.animateGlyph[count].draw(ctx);
		}
	},
	
	drawLabel	:		function(ctx) {
		if(this.dataLabel != null) {
			this.dataLabel.draw(ctx);
		}
		if(this.getLeadLine() != null) {
			GraphHelper.drawLine(ctx, this.getLeadLine());
		}
	}
}

function DataSeries(js) {
 	this.initConstants(js);
}

DataSeries.prototype = {
	initConstants	:	function(js) {
		js = js || {};
		
		// kunsnat: Ϊdrawglyphlayout֮󴴽
		this.glyph = null;
		
		this.points = [];
		if(js.points != undefined && js.points.length > 0) {
			var dataPoints = js.points;
			for(var i = 0; i < dataPoints.length; i++) {
				this.points[i] = new DataPoint(dataPoints[i]);
			}
		}
	},
	
	setGlyph	:	function(glyph) 
	{
	    this.glyph = glyph;
	},
	
	getGlyph	:	function() 
	{
	   return this.glyph;
	},
	
	getPoints	:	function() 
	{
		return this.points;
	},
	
	setPoints	:	function(points) 
	{
		this.points = points;
	},
	
	getDataPoint	:	function(index)
	{
		return this.points[index];
	},
	
	getDataPointCount	:	function()
	{
        var count = 0;
        if(this.points != null) {
		 	count = this.points.length;
		}
		return count;
	},
	
	draw		:		function(ctx, time, xylist, actionModel) {
		if(this.glyph  != null) {
			this.glyph.draw(ctx, time, xylist, actionModel);			
		}
		
		var dataPoints = this.getPoints();
	    for (var i=0; i < this.getDataPointCount(); i++ ) {
			dataPoints[i].draw(ctx, time, xylist);
	    }
	},
	
	drawLabel	:		function(ctx, time, xylist) {
		for(var i = 0; i < this.getDataPointCount(); i++) {
			this.getDataPoint(i).drawLabel(ctx, time, xylist);
		}
	},
	
	/**
	 * kunsnat: õ̬ÿĻglyph
	 */
	getAnimateGlyph	:	function(step) {
		if(this.glyph != null) {
			this.animateGlyph = this.glyph.getAnimateGlyph(step);
			return;
		}
		
		var dataPoints = this.getPoints();
	    for (var i=0; i < this.getDataPointCount(); i++ ) {
	    	dataPoints[i].getAnimateGlyph(step);
	    }
	},
	
	getAnimateStepNumber	:	function() {
		if(this.animateGlyph != null) {
			return this.animateGlyph.length;
		}
		
		if(this.points[0] != null) {
			var point = this.points[0];
			return point.animateGlyph.length;
		}
	},
	
	drawAnimateGlyph	:	function(ctx, count) {
		if(this.animateGlyph != null && this.animateGlyph.length > 0 && count < this.animateGlyph.length) {
			this.animateGlyph[count].draw(ctx);
		}
		
		var dataPoints = this.getPoints();
	    for (var i=0; i < this.getDataPointCount(); i++ ) {
	    	dataPoints[i].drawAnimateGlyph(ctx, count);
	    }
	}
}

function ChartGlyph(js) {
	this.initConstants(js);
}					  

FR.extend(ChartGlyph, RectangleGlyph, {
	initConstants	:	function(js) {
		js = js || {};
		
		this.legendGlyph = js.legendGlyph == undefined ? null : new LegendGlyph(js.legendGlyph);
		this.titleGlyph = js.titleGlyph == undefined ? null : new TextGlyph(js.titleGlyph);
		
		if(js.plotGlyph == undefined) {
			this.plotGlyph = null;
		} else {
			// ĬϵBar2DPlotGlyph
			var plotType = js.plotType;
			if(plotType == "Bar3DPlotGlyph") {
				this.plotGlyph = new Bar3DPlotGlyph(js.plotGlyph);
			} else if(plotType == "AreaPlotGlyph") {
				this.plotGlyph = new AreaPlotGlyph(js.plotGlyph);
			} else if(plotType == "Area3DPlotGlyph") {
				this.plotGlyph = new Area3DPlotGlyph(js.plotGlyph);
			} else if(plotType == "LinePlotGlyph") {
				this.plotGlyph = new LinePlotGlyph(js.plotGlyph);
			} else if(plotType == "Line3DPlotGlyph") {
				this.plotGlyph = new Line3DPlotGlyph(js.plotGlyph);
			} else if(plotType == "MeterPlotGlyph") {
				this.plotGlyph = new MeterPlotGlyph(js.plotGlyph);
			} else if(plotType == "RadarPlotGlyph") {
				this.plotGlyph = new RadarPlotGlyph(js.plotGlyph);
			} else if(plotType == "CustomPlotGlyph") {
				this.plotGlyph = new CustomPlotGlyph(js.plotGlyph);
			} else if(plotType == "PiePlotGlyph") {
				this.plotGlyph = new PiePlotGlyph(js.plotGlyph);
			} else if(plotType == "Pie3DPlotGlyph") {
				this.plotGlyph = new Pie3DPlotGlyph(js.plotGlyph);
			} else if(plotType == "RangePlotGlyph") {
				this.plotGlyph = new RangePlotGlyph(js.plotGlyph);
			} else if(plotType == "XYScatterPlotGlyph") {
				this.plotGlyph = new XYScatterPlotGlyph(js.plotGlyph);
			} else if(plotType == "StockPlotGlyph") {
				this.plotGlyph = new StockPlotGlyph(js.plotGlyph);
			} else {
				this.plotGlyph = new Bar2DPlotGlyph(js.plotGlyph);
			}
		}

		ChartGlyph.superclass.initConstants.apply(this, [js]);
	},
	
	setPlotGlyph		:		function(plotGlyph) {
		this.plotGlyph = plotGlyph;
	},
	
	getPlotGlyph		:		function() {
		return this.plotGlyph;
	},
	
	setLegendGlyph		:		function(legendGlyph) {
		this.legendGlyph = legendGlyph;
	},
	
	getLegendGlyph		:		function() {
		return this.legendGlyph;
	},
	
	setTitleGlyph		:		function(titleGlyph) {
		this.titleGlyph = titleGlyph;
	},
	
	getTitleGlyph		:		function() {
		return this.titleGlyph;
	},
	
	setNameHyperlinkGroup		:		function(nameHyperlinkGroup) {
		this.nameHyperlinkGroup = nameHyperlinkGroup;
	},
	
	getHotHyperlink		:		function() {
		return this.nameHyperlinkGroup;
	},
	
	draw		:		function(ctx) {
		ChartGlyph.superclass.draw.apply(this, [ctx]);
			
		ctx.translate(this.getBounds().getX(),this.getBounds().getY());
		
		// GraphHelperļ
		GraphHelper.ctx = ctx;
		
		this.doLayout();
	
		if(this.plotGlyph != null) {
			var xylist = new Array();
			xylist.push(this.getBounds().getX());
			xylist.push(this.getBounds().getY());
			
			// kunsnat: ¸ı, ֹlegendGlyphtitleGlyph ŵPloGlyph, ̬ʱٻ
			this.plotGlyph.legendGlyph = this.legendGlyph;
			this.plotGlyph.titleGlyph = this.titleGlyph;
			
			this.plotGlyph.draw(ctx, 1000, xylist);
		}
	
		ctx.translate(-this.getBounds().getX(),-this.getBounds().getY());
	},
	
	doLayout		:		function() {
		var layout = new ChartGlyphLayout();
		layout.setLayoutBounds(this.getBounds());
	    
		layout.doLayout(this);
	}
});

